commit de7aca3b517c46d6485ce0464e6126216c592b1c
Author: Damian Johnson <atagar@torproject.org>
Date:   Sat Jun 7 13:03:22 2014 -0700

    Adding hotfix changes to our changelog
    
    We had a note for our 1.0.1 hotfix release, but none of the later ones.

commit 6ba7725534df08f3b0c25819fb83742848cd60a2
Author: Damian Johnson <atagar@torproject.org>
Date:   Sat Jun 7 11:42:56 2014 -0700

    Updating download links for the 1.2.2 hotfix release

commit a91776a1e9ba546984698d02f219d82157e086c1
Merge: d81dafb ca0ea05
Author: Damian Johnson <atagar@torproject.org>
Date:   Sat Jun 7 11:41:51 2014 -0700

    Merge version 1.2.2 hotfix

commit ca0ea05d3b9a127c9800b65dec3dc9e44c7c5968
Author: Damian Johnson <atagar@torproject.org>
Date:   Sat Jun 7 11:35:40 2014 -0700

    Stem release 1.2.2
    
    Hotfix release for our Python 2.6 support...
    
      https://trac.torproject.org/projects/tor/ticket/12223

commit 16287558bc585af3f280ef601b9526032489d104
Author: Damian Johnson <atagar@torproject.org>
Date:   Sat Jun 7 11:01:56 2014 -0700

    Test used 'with' for tarfiles, breaking python 2.6
    
    Integ tests couldn't pass with python 2.6 because we started using with for
    tarfiles. We already accounted for this in all our other tarfile uses - just a
    regression in a newly added test.

commit 2ebd329ff3c9079828d62529e1e01be9ba0cdf1d
Author: Damian Johnson <atagar@torproject.org>
Date:   Sat Jun 7 10:55:53 2014 -0700

    Python 2.6 broken by OrderedDict usage
    
    In our recent release I swapped our stem.util.conf to use an OrderedDict,
    breaking our support for python 2.6...
    
      % python2.6 ./run_tests.py --unit
      Traceback (most recent call last):
        File "./run_tests.py", line 465, in <module>
          main()
        File "./run_tests.py", line 119, in main
          test_config.load(os.path.join(STEM_BASE, "test", "settings.cfg"))
        File "/home/atagar/Desktop/stem/stem/util/conf.py", line 504, in load
          self.set(key, value, False)
        File "/home/atagar/Desktop/stem/stem/util/conf.py", line 604, in set
          listener(self, key)
        File "/home/atagar/Desktop/stem/stem/util/conf.py", line 175, in update
          new_value = config.get(key, self.config_dict[key])
        File "/home/atagar/Desktop/stem/stem/util/conf.py", line 685, in get
          valMap = collections.OrderedDict()
      AttributeError: 'module' object has no attribute 'OrderedDict'
    
    Caught by pmezard on...
    
      https://trac.torproject.org/12223
    
    This is actually something we've already dealt with elsewhere. Stem contains
    its own python 2.6 compatable copy of the OrderedDict module, I just forgot to
    use it here.

commit d81dafbdd9cf4baa8f7f53a78b8badf818af4667
Author: Damian Johnson <atagar@torproject.org>
Date:   Fri Jun 6 08:35:35 2014 -0700

    Interpreter's /info errored for relays without contact info
    
    Issue caught by zoltan...
    
      >>> /info 74.3.165.39
      Traceback (most recent call last):
        File "/usr/bin/tor-prompt", line 8, in <module>
          stem.interpreter.main()
        File "/usr/lib/python3.4/site-packages/stem/interpreter/__init__.py", line 116, in main
          response = interpreter.run_command(user_input)
        File "/usr/lib/python3.4/site-packages/stem/util/conf.py", line 276, in wrapped
          return func(*args, config = config, **kwargs)
        File "/usr/lib/python3.4/site-packages/stem/interpreter/commands.py", line 318, in run_command
          output = self.do_info(arg)
        File "/usr/lib/python3.4/site-packages/stem/interpreter/commands.py", line 229, in do_info
          contact = contact.replace(alias, '@')
      AttributeError: 'NoneType' object has no attribute 'replace'

commit f46974987106e3246482158e009491faa07bbae4
Author: Damian Johnson <atagar@torproject.org>
Date:   Wed Jun 4 08:58:38 2014 -0700

    Accounting for unattached streams in the exit_used example
    
    Issue mentioned on...
    
      https://stem.torproject.org/tutorials/examples/exit_used.html

commit a54d6430f802c270f70ee9cf850a34ec67245f02
Author: Damian Johnson <atagar@torproject.org>
Date:   Wed Jun 4 08:46:35 2014 -0700

    Changing descriptor archive links from Metrics to CollecTor
    
    Karsten just released CollecTor, a site that's replacing the Metrics archive.
    Adjusting our links...
    
      https://lists.torproject.org/pipermail/tor-dev/2014-June/006942.html

commit 3ced0872d55c153f17a487eb2835cb359de59c13
Author: Damian Johnson <atagar@torproject.org>
Date:   Tue Jun 3 08:23:58 2014 -0700

    Updating our download link for the 1.2.1 release
    
    Bumping our PyPI download links for the hotfix release.

commit ff36ce755731a53edb0ff6644eb5606b0344bf7b
Merge: c29f21c c2541bd
Author: Damian Johnson <atagar@torproject.org>
Date:   Tue Jun 3 08:18:58 2014 -0700

    Merge version 1.2.1 hotfix

commit c2541bd9695fc371fe8ad75e2ebdcba15bcd2aa8
Author: Damian Johnson <atagar@torproject.org>
Date:   Tue Jun 3 08:16:54 2014 -0700

    Stem release 1.2.1
    
    Hotfix release for our Python 3.x for...
    
      https://trac.torproject.org/projects/tor/ticket/12185

commit 4e458ee979569f2be2cf1cacd1f653b5bb8a9667
Author: Damian Johnson <atagar@torproject.org>
Date:   Tue Jun 3 08:10:22 2014 -0700

    Fixing /info for python3
    
    On irc zoltan reported that the /info command balks under python3...
    
      >>> /info moria1
      Traceback (most recent call last):
        File "/usr/local/bin/tor-prompt", line 8, in <module>
          stem.interpreter.main()
        File "/usr/local/lib/python3.2/dist-packages/stem/interpreter/__init__.py", line 116, in main
          response = interpreter.run_command(user_input)
        File "/usr/local/lib/python3.2/dist-packages/stem/util/conf.py", line 276, in wrapped
          return func(*args, config = config, **kwargs)
        File "/usr/local/lib/python3.2/dist-packages/stem/interpreter/commands.py", line 317, in run_command
          output = self.do_info(arg)
        File "/usr/local/lib/python3.2/dist-packages/stem/interpreter/commands.py", line 184, in do_info
          for desc in server_desc_query:
        File "/usr/local/lib/python3.2/dist-packages/stem/descriptor/remote.py", line 328, in __iter__
          for desc in self._run(True):
        File "/usr/local/lib/python3.2/dist-packages/stem/descriptor/remote.py", line 317, in _run
          for desc in results:
        File "/usr/local/lib/python3.2/dist-packages/stem/descriptor/__init__.py", line 211, in parse_file
          for desc in file_parser(descriptor_file):
        File "/usr/local/lib/python3.2/dist-packages/stem/descriptor/__init__.py", line 261, in _parse_metrics_file
          for desc in stem.descriptor.server_descriptor._parse_file(descriptor_file, is_bridge = False, validate = validate, **kwargs):
        File "/usr/local/lib/python3.2/dist-packages/stem/descriptor/server_descriptor.py", line 146, in _parse_file
          if descriptor_content[0].startswith('@type'):
      TypeError: startswith first arg must be bytes or a tuple of bytes, not str
    
      https://trac.torproject.org/projects/tor/ticket/12185
    
    There's a couple issues here. First is a last minute change I added to strip
    @type annotations. It ran into the normal bytes/unicode python3 gotcha
    resulting in the stacktrace above. The other is that our contact field is
    bytes, so it needs to be converted to unicode before mingling with the other
    lines.

commit c29f21cc06a9acdc772070562a14da3e40d26e44
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Jun 1 14:16:45 2014 -0700

    Adding '-dev' version suffix

commit 3f92106ef478fc01363a69538ae499705342f9a9
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Jun 1 13:26:08 2014 -0700

    Missing link anchor for the version 1.2 changelog

commit f9a0503654a484236b048d9f37de95e6f62e005c
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Jun 1 13:16:40 2014 -0700

    Missing link for the version 1.2 changes

commit 2d8551dd44d7dc491729e449062830e3c99cc540
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Jun 1 13:12:42 2014 -0700

    Updating changelog to note the new release

commit 46730ef54ee6c0fba5dd4da2e357bf87b56d7376
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Jun 1 13:10:17 2014 -0700

    Updating PyPI download links

commit 59408c3f1f6c785d12c543859a1e0abf308abfa1
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Jun 1 12:55:28 2014 -0700

    Stem release 1.2.0

commit 893b05913013a791d82a7e072680869c23631826
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Jun 1 12:46:28 2014 -0700

    Dropping unnecessary package_dir setup.py clause
    
    Just checked and we don't need the package_dir entry to include our
    settings.cfg.

commit 16837ec27a76db2e6b3affef5926bff26e679799
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Jun 1 12:44:07 2014 -0700

    Fixing tor-prompt location
    
    Adjusting the install path to the one actually picked by default.

commit 90c291dca7f48edf1dc4640d5add3ebf0ab1f775
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Jun 1 12:33:17 2014 -0700

    Shortening setup.py description
    
    Minor change to our description. TorCtl has been deprecated long enough that
    there's probably little point in mentioning it.

commit 01c516df08c192a159ed84a1404ce7771edbf037
Author: Damian Johnson <atagar@torproject.org>
Date:   Sat May 31 20:34:04 2014 -0700

    Skipping @type annotations in descriptor parse_file() functions
    
    At a high level stem parses descriptors by doing the following...
    
      1. Users call stem.descriptor.parse_file().
    
      2. The parse_file() function uses the @type annotation to guess the
         descriptor type.
    
      3. It delegates to the parse_file() function of the relevant descriptor
         class. Every descriptor class has its own parse_file() function.
    
    Karsten is starting to serve descriptor files which are multiple descriptors
    concatenated together. Stem actually already pretty much handles this since I
    designed our parsers to read Tor's cached descriptors (which are concatenated
    descriptors as well).
    
    The only gotcha is that @type annotations technically aren't valid descriptor
    content so at step #3 the descriptor classes balk saying so. Working around
    this by simply skipping @type annotations at the beginning of files.

commit 68dfff4e3b0226450ff834fd081c6e60d456824e
Author: Damian Johnson <atagar@torproject.org>
Date:   Sat May 31 19:57:57 2014 -0700

    FAQ entry to discuss how to handle *.tar.xz archives
    
    Short FAQ entry dicussing how to handle metric's new *.tar.xz archives...
    
      https://lists.torproject.org/pipermail/tor-dev/2014-May/006884.html

commit a5596873fd544d79c53f0c0123caa89bdb5a9f72
Author: Damian Johnson <atagar@torproject.org>
Date:   Sat May 31 14:14:06 2014 -0700

    Adding tarfile support to stem.descriptor.parse_file()
    
    A while back Karsten tried to hand a tarfile to our parse_file() method and had
    confusing results...
    
      https://trac.torproject.org/projects/tor/ticket/10977
    
    Expanding our parse_file() function so it'll happily handle tarfiles and tar
    paths.
    
    Note that the DescriptorReader, which already had tar support, is keeping its
    own separate implementation. This is because using the parse_file()'s tar
    support has a couple drawbacks...
    
      1. The reader then couldn't stop in the middle of handling tarballs.
    
      2. If a tarball contains both descriptor and non-descriptor content then the
         DescriptorReader can handle that. parse_file(), however, raises an
         exception.

commit bbaa4c85bd5d3fabf43bc1e899e234aefa111235
Author: Damian Johnson <atagar@torproject.org>
Date:   Sat May 31 12:17:27 2014 -0700

    Added missing versionadded tags
    
    We were missing a handful of versionadded tags for things being added in 1.2.0.

commit fcf49ad8afe52a36553fabbeaa3741566fa299f6
Author: Damian Johnson <atagar@torproject.org>
Date:   Thu May 29 08:48:51 2014 -0700

    Close stdout/stderr after the tor process initializes
    
    We use tor's stdout and stderr to determine two things...
    
      * at what stage it has bootstrapped to
      * errors if tor fails to start
    
    After startup, however, we stop listing to stdout which can cause Tor to lock
    up if it's registering a lot of NOTICE level messages...
    
      https://trac.torproject.org/projects/tor/ticket/9862
    
    Tested by the following script. Before this fix tor hung after ~3 seconds. With
    it things happily chug along...
    
      import time
    
      import stem.process
    
      from stem.control import EventType, Controller
    
      tor_process = stem.process.launch_tor_with_config(
        config = {
          'ControlPort': '9051',
          'Log': 'DEBUG stdout',
        },
        take_ownership = True,
      )
    
      with Controller.from_port() as controller:
        controller.authenticate()
    
        def heartbeat(event):
          print "%s - %s / %s" % (time.time(), event.read, event.written)
    
        controller.add_event_listener(heartbeat, EventType.BW)
    
        print "Press any key to quit..."
        raw_input()

commit 29f2a1cde6f6bc4fb523a410568559d9bd2c142e
Author: Damian Johnson <atagar@torproject.org>
Date:   Sat May 31 11:35:07 2014 -0700

    Vending the test_tools and tor_tools utility modules
    
    On reflection both are very well written and tested. I've found these useful in
    my projects and there's little reason so keep 'em to ourselves so sharing the
    wealth.

commit d14594b61f85527fcf2b20e90f36439391e1310b
Author: Damian Johnson <atagar@torproject.org>
Date:   Thu May 29 09:13:52 2014 -0700

    Note that process renaming might cause problems for FreeBSD
    
    Citing a ticket where a user indicated that _set_argv() caused issues for them.
    The user disappeared so not positive if it's really an issue (nor a fix if so).

commit b7a04768747681bc7889ef0b9a959b918557b3d9
Author: Damian Johnson <atagar@torproject.org>
Date:   Thu May 29 08:15:42 2014 -0700

    Moving launch_tor() cleanup to a finally block
    
    Whenever launch_tor() finishes, either with success or failure we want to do
    two things:
    
      * stop our alarm if we were running with a timeout
      * clean up our temporary torrc if we made a blank one
    
    We did this in an ad-hoc fashion, but it better belongs in a finally block.

commit 8ca253a974c7e6eec9038c2d39a98a245a1ff024
Author: Damian Johnson <atagar@torproject.org>
Date:   Wed May 28 09:18:31 2014 -0700

    Adding DROPGUARDS support
    
    Adding a Controller method for tor's DROPGUARDS function...
    
      https://trac.torproject.org/projects/tor/ticket/10032
      https://gitweb.torproject.org/torspec.git/commitdiff/7c6c7fc

commit 90843e507b381fef2579afee01e2b507a4fd505f
Author: Damian Johnson <atagar@torproject.org>
Date:   Wed May 28 08:35:20 2014 -0700

    Changing Fedora link
    
    For a while now our Fedora page has been getting an error response...
    
      https://github.com/fedora-infra/fedora-packages/issues/76
    
    Juan suggested using this link instead until it gets sorted out.

commit 8867b4158f16d015cc10f21a048e9548f71342e5
Author: Damian Johnson <atagar@torproject.org>
Date:   Tue May 27 09:44:00 2014 -0700

    Adding or-applet to our examples page

commit aa0622d13be3e274200eb3fecfcd470528d1695a
Author: Damian Johnson <atagar@torproject.org>
Date:   Mon May 26 14:18:26 2014 -0700

    Fixing interpreter unit test
    
    Revising our test for /info to account for the recent changes.

commit cec8c1f0d573160e0fa51d2fece254b45316e647
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun May 25 14:16:34 2014 -0700

    Expanding /info output
    
    Greatly enriching our /info output to include all relay information the user is
    likely to find helpful. This revises the summary a bit, but more importantly
    now includes the relay's hostname and all descriptor content (server,
    extrainfo, microdescriptor, and router status entry).
    
    Fetching both the hostname and descriptor content involves active lookups, but
    while this was a no-go for arm it's perfectly fine for an interactive
    interpreter like this.

commit d699f816ea1f05d085e52f8adfa75f09442c1d81
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun May 25 13:06:22 2014 -0700

    Fix interaction of color prompt with readline
    
    For a long while we've had an issue where readline history would break with
    long inputs. For instance, entering...
    
      >>> the quick brown fox jumped over the very nice fence and ran around in pretty fields
    
    ... then pressing 'up' to autocomplete history then 'down' to go back to an
    empty prompt would leave a fragment of this mingled with the prompt.
    
    This turned out to be an issue with how readline calculates column width.
    Readline included the formatting sequences when determining our prompts width,
    which can be corrected by wrapping all encodings with RL_PROMPT_START_IGNORE
    and RL_PROMPT_END_IGNORE sequences...
    
      https://stackoverflow.com/questions/9468435/look-how-to-fix-column-calculation-in-python-readline-if-use-color-prompt
    
    Many thanks to Yawning for pointing this out!

commit 00903e75ff4f3e16ae81240506237ef9e50da113
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun May 25 12:10:51 2014 -0700

    Changing prompt's events builtin to be a function
    
    Changing 'events' from being a variable to a function. Presently this provides
    a single optional argument to filter the event types it returns (a very, very
    common thing to want). This also makes it easier for us to expand in the future
    as more use cases crop up.

commit fb2734b074865ba2af55d18f966a82ae8279f96c
Author: Damian Johnson <atagar@torproject.org>
Date:   Sat May 24 15:10:44 2014 -0700

    Correcting setup.py for tor-prompt
    
    Patch from Yawning that corrects two things...
    
    * Doesn't hardcode tor-prompt to install to /usr/bin so the user can customize it.
    * Installs the prompt's settings.cfg (without which it won't run).

commit b4da7f833ded8123d4af709dad4c5c84cccbd147
Author: Damian Johnson <atagar@torproject.org>
Date:   Sat May 24 13:49:49 2014 -0700

    'Down the Rabbit Hole' tutorial
    
    Adding a tutorial for our new interpreter, giving an overview of both how to
    run it and what it can do. Think this might be my favorite tutorial yet...

commit 732ecff7d0aa193178f29b1d62cb3413398d7084
Author: Damian Johnson <atagar@torproject.org>
Date:   Sat May 24 13:31:55 2014 -0700

    Supporting '/events clear'
    
    Adding a command to clear the backlog of events we've received.

commit c5a7bbe46555f9a922639942561786c7155ca4f0
Author: Damian Johnson <atagar@torproject.org>
Date:   Thu May 22 09:15:51 2014 -0700

    Fixing interpretor misspelling
    
    Huh. Not sure why my spell checker thought 'interpretor' was ok. Thanks to
    Yawning for pointing this out.

commit ffc1f706920fac1dec61c1aedf19028bac0057f5
Author: Damian Johnson <atagar@torproject.org>
Date:   Thu May 22 09:04:58 2014 -0700

    Renaming 'prompt' to 'tor-prompt'
    
    Renaming our prompt to be less generic so we can add it to bin on installation.
    I'm not in love with this name, but at least it's pretty self-explanatory.

commit 32b9f75825d0c67639ded301f76d8c599031a616
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun May 11 22:21:09 2014 -0700

    Only doing raw controller requests via the prompt
    
    I was using our Controller's high level methods (get_info(), get_conf(),
    add_event_listeners()) for a couple reasons. First they provide caching and
    second because they yeild more succinct output. But on refection those are both
    terrible reasons. Caching is worthless with such a low call volume, and it's
    actually *better* if we print raw Tor responses. This is supposed to provide
    raw controller accesss, right? :)
    
    If users want the behavior of the high level methods then they can now call
    those easy enough.

commit 87aecce52ff95c5f79759a4cd57b77280f4beefd
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun May 11 16:21:29 2014 -0700

    Providing an option to disable colorized prompt output
    
    Not everyone will probably want highly colorized output so providing an option
    to disable it.
    
    I dislike this approach of using a global in the stem.util.term module. I'm
    explicitely not vending this to others since I'm sure there's a more graceful
    way of toggling this.

commit 1e56973e4cf251b7a29429435b1b97bcf353dbdc
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun May 11 16:09:23 2014 -0700

    Colorizing header banner
    
    Colorizing our prompt's initial output, with bolding to better emphasize the
    examples.

commit 51160196e6b58d4d9bbb1cfd6eb318375300c7f4
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun May 11 15:37:55 2014 -0700

    Integrating python prompt into interpretor
    
    Our prompt provided two modes: a python prompt or raw controller prompt. But
    why not combine the two?
    
    We now provide a python interpretor (like IDLE), but with the following...
    
    * A connection to Tor is available via our 'controller' variable.
    
    * Events we've received via SETEVENTS is available via our 'events' variable.
    
    * Controller commands we recognized are passed directly to Tor (like our prior
      prompt).
    
    * Python support can be toggled via '/python'. If it's disabled this is
      effectively our prior prompt.
    
    * Starting tor without prompting if it isn't running. Tor only takes a fraction
      of a second to bootstrap to a state we can use, so asking the user is more of
      a hassle than help.

commit 3650c6089186fd941bd2e71613f5c37022313c0e
Author: Damian Johnson <atagar@torproject.org>
Date:   Sat May 10 12:53:31 2014 -0700

    Standardizing single vs double quotes
    
    PEP8 doesn't have any advice on when to opt for one quote type or the other, so
    I'm settling on the following:
    
      Single quotes unless it's either block quotes (""") or has single quotes in
      the content ("he said 'hello'").

commit 7f63b5a525768ab80dd04ac670fb9a68aa329324
Author: Damian Johnson <atagar@torproject.org>
Date:   Sat May 10 18:02:00 2014 -0700

    Revising prompt --help output
    
    Just a few minor tweaks. Dropping the examples from the end since we have
    better example usage earlier now.

commit 29e7524d4e54baa26022597793ad84c2df9031ff
Author: Damian Johnson <atagar@torproject.org>
Date:   Sat May 10 17:48:53 2014 -0700

    Dropping the old prompt
    
    Our new prompt does everything the old one does and much more. Dropping the old
    prompt command.

commit 8c3ada016b02bf19eed54e18c7cfed03ecacd52a
Author: Damian Johnson <atagar@torproject.org>
Date:   Sat May 10 17:46:29 2014 -0700

    Offer to start tor when running prompt
    
    If tor isn't running then offering to start an instance for our prompt to
    connect to. This only lasts for the duration of the interpretor session.

commit dcf0852106423d413c262e7aa87abc8b5695346d
Author: Damian Johnson <atagar@torproject.org>
Date:   Sat May 10 15:37:47 2014 -0700

    Python interpretor when running the prompt
    
    Support for providing the user with a python interpretor when they include the
    '--python' argument. This is what our old 'prompt' command once provided, and
    is handy when you'd like to get a quick and easy Controller to interact with.

commit 365d6b611262f5a9ec85ce49e98757bfef4a0931
Author: Damian Johnson <atagar@torproject.org>
Date:   Wed May 7 08:25:04 2014 -0700

    Supporting microdescriptor's new 'id' parameter
    
    Not something our callers will care about (the parameter's just present for
    collision prevention), so just adding for completeness.

commit a76f28c59b2155f9dd577094eb4c0da99da04037
Author: Damian Johnson <atagar@torproject.org>
Date:   Tue May 6 08:56:17 2014 -0700

    Adding torsearch to our examples
    
    GSoC by wfn that used stem's DescriptorReader for backfilling descriptors into
    its DB.

commit 3581dbc1fc318e86102656b7e7a3e73d1d3bea8b
Author: Damian Johnson <atagar@torproject.org>
Date:   Tue May 6 08:48:22 2014 -0700

    Adding PT_MISSING to ORClosureReason
    
    New reasson for the enumeration...
    
      https://gitweb.torproject.org/torspec.git/commitdiff/358e8ac97811ff2ad6de34f84fb59a92612b4a08

commit 188952d0ba0b13028cba591d9f6a5c24cffb5054
Author: Damian Johnson <atagar@torproject.org>
Date:   Tue May 6 08:37:48 2014 -0700

    Updating changelog
    
    Noting the recent interpretor and site changes.

commit 6622eabc36b795c771afd7913c94273c3c6f1e6a
Author: Damian Johnson <atagar@torproject.org>
Date:   Mon May 5 18:34:28 2014 -0700

    Unit tests didn't account for ending newlines
    
    Oops, last minute change added a newline to the end of non-interpretor
    commands. Forgot to update the unit tests to account for this.

commit 1b21c24d1a6ba02fe1eea191379eb6c9811657fe
Merge: 0d357a9 f2cabcd
Author: Damian Johnson <atagar@torproject.org>
Date:   Mon May 5 18:03:46 2014 -0700

    Interpretor prompt
    
    Arm's 1.4.5 release included an interpretor panel that allowed raw control
    port access with usability improvements like...
    
      * tab completion
      * history by pressing up/down
      * terminal coloring to improve readability
      * irc-style functions such as '/help' and '/info'
    
    This was pretty slick but rarely used, and is being removed from the next arm
    release.
    
    The trouble isn't with the feature, but rather the audience. Raw control port
    access is useful to learn about tor's controller interface and debug
    during development. This didn't match arm's audience, who are primarily relay
    operators and power users. However, it's *perfect* for Stem!
    
    This is a rewritten version of arm's interpretor...
    
      https://gitweb.torproject.org/arm.git/blob/e249dc8f5c4c282326324161cf8421f947cf660e:/src/util/torInterpretor.py
    
    Functionally this is the same as arm's, but is much more modular and better
    tested. Pending improvements I plan include...
    
      * tutorial to introduce new stem users to the prompt
      * option to get a python prompt (similar to our old 'prompt' command)

commit f2cabcdf9618af85005e830e2aa0d72a4e369a3f
Author: Damian Johnson <atagar@torproject.org>
Date:   Mon May 5 18:02:40 2014 -0700

    Always include an empty line before the next prompt

commit dcb9576041720573eac88920f84551d6d562a16d
Author: Damian Johnson <atagar@torproject.org>
Date:   Mon May 5 17:58:50 2014 -0700

    Help output had an extra newline

commit 1fab359f84b3c462f0b0fea1baeb4230be39ccab
Author: Damian Johnson <atagar@torproject.org>
Date:   Mon May 5 17:47:12 2014 -0700

    Unit tests for interpretor commands
    
    Tests for issuing commands to the interpretor prompt.

commit ee2f739ab1b5d14661193543ac58f17e471d2ae3
Author: Damian Johnson <atagar@torproject.org>
Date:   Mon May 5 13:52:42 2014 -0700

    Unit test for /info

commit fb6962ed28463a56d100c9cac7cc7517879dec99
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun May 4 19:14:35 2014 -0700

    Helper function for resolution of inputs to fingerprints
    
    Splitting a big chunk of do_info() into a helper. Much better for both
    readability and testability.

commit 1ee5d21f16921e2679239839899bacc0d21ccad8
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun May 4 15:20:45 2014 -0700

    Help and event ControlInterpretor unit tests
    
    First couple unit tests for the ControlInterpretor class, covering '/help' and
    '/events'.

commit f44f094fba5ce45c03c83b4e0b40746728105597
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun May 4 14:38:08 2014 -0700

    Using a common mock controller for unit tests
    
    A couple of our test modules need a mock controller, so having them each use
    the same mock to avoid duplicating it.

commit a8b48a4c14186f1192132fc0947761215d30da9d
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun May 4 14:32:48 2014 -0700

    Unit tests for help module

commit cfab7b6096f068e4784bbd73d3376a32f978af7d
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun May 4 12:46:23 2014 -0700

    Moving help responses to their own module

commit 6bdbec2e95a31435fa39255ccf67242151e54a06
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun May 4 12:01:54 2014 -0700

    Renaming formatting constants

commit 267ea3a7815ed39a8360c088b7ff6bdd20e79b84
Author: Damian Johnson <atagar@torproject.org>
Date:   Sat May 3 12:51:04 2014 -0700

    Lazy fetching for help responses
    
    Our prior commit changed /help to be eagerly feched and chached. Caching for
    this is good, but cached lazy fetches are even better. No reason to make a
    handful of GETINFO requests at startup if they won't be needed.

commit 48c016d9d65345bf8ad82eb57b8ec950e52ed145
Author: Damian Johnson <atagar@torproject.org>
Date:   Sat Apr 19 23:11:32 2014 -0700

    Caching /help responses
    
    Determining our /help output on construction rather than on demand. I'm a
    little on the fencepost about this, but this includes some minor output and
    code improvements so opting for it for the moment.

commit 6478057edcf83b1cfda1107dd78e290b1c102d0a
Author: Damian Johnson <atagar@torproject.org>
Date:   Sat Apr 19 21:04:29 2014 -0700

    Autocompletion unit tests
    
    Unit tests for our autocompletion class and helper funtion for determine
    options from tor. This didn't uncover any issues with that, but it *did* reveal
    a bug with our util module. We didn't make a shallow copy of list config
    values, so in place modifications edited the configuration's master value.

commit 0764a99b75a55c94545a8e7ff90408366966e079
Author: Damian Johnson <atagar@torproject.org>
Date:   Sat Apr 19 19:07:51 2014 -0700

    Changing @uses_settings to use keyword argument
    
    Our @uses_settings passed along the configuration as the function's first
    argument. This is well and good for functions, but for methods that meant we no
    longer started with 'self'. This is really, really weird in the python world so
    changing the annotation to pass the value along as a keyword argument.

commit 366195ca5d7000aa7776be9171c3b6b376da455c
Author: Damian Johnson <atagar@torproject.org>
Date:   Sat Apr 19 19:03:18 2014 -0700

    Revise _get_commands() helper
    
    Little refactoring for our _get_commands() helper to reduce some duplicate bits
    and minor improvements for readability. The only functional change is that we
    no longer blindly add /help commands for everything. Rather, we add help for
    commands with usage information.

commit 71028da33515673c7f5df55b46e2235833741352
Author: Damian Johnson <atagar@torproject.org>
Date:   Sat Apr 19 17:00:16 2014 -0700

    Caching autocompletion matches
    
    Readline's autocompletion is kinda weird. It uses a function of the form...
    
      matches(text, state)
    
    ... where the state is the index of the match to be returned. This is probably
    to match the underlying C readline funcion (ahhh, the world before dynamically
    allocated lists).
    
    Considering that we're calling the match function N+1 times where N is the
    number of autocompletion matches we might as well cache the results. The
    autocompleter should have a match function that returns a list of matches
    anyway.

commit 278994377919bef35dcf6fef604d7bf5ef3be6da
Author: Damian Johnson <atagar@torproject.org>
Date:   Sat Apr 19 16:23:01 2014 -0700

    Moving autocompletion to its own module
    
    I bundled autocompletion with commands.py because it used one of its globals.
    However, we've since dropped those bits so this can be nicely moved back to its
    own file.

commit 3fc675f911aba1d4581d1db3e7b60b2cb96428ac
Author: Damian Johnson <atagar@torproject.org>
Date:   Sat Apr 19 15:55:00 2014 -0700

    Moving remaining /help information to config
    
    Moving the last of our /help output that remained in commands.py.

commit 8caafbc46c7c696f97cb1895604780af63566813
Author: Damian Johnson <atagar@torproject.org>
Date:   Sat Apr 19 12:35:18 2014 -0700

    Moving SIGNAL option descriptions to config
    
    Another good candidate for our config. This required a couple fixes for our
    config util...
    
      * @uses_settings couldn't be used with class methods
      * dictionaries were unordered - no reason not to keep ordering

commit 6ab77cb951c927a899ec80d1afde596bb9226fbd
Author: Damian Johnson <atagar@torproject.org>
Date:   Sat Apr 19 12:03:31 2014 -0700

    Moving base autocompletion commands to config
    
    Perfect thing to get out of our source. :)

commit 0e5cf58a99fe0adec83e06e918cf896019411480
Author: Damian Johnson <atagar@torproject.org>
Date:   Sat Apr 19 09:12:16 2014 -0700

    Unit tests for interpretor argument parsing
    
    Few simple tests for our argument handling, adapted from arm.

commit fb65766f1e74cf3218efa9889a5479a13ba70ca4
Author: Damian Johnson <atagar@torproject.org>
Date:   Fri Apr 18 10:29:22 2014 -0700

    Adding a @uses_settings to our config module
    
    The @uses_settings helper our interpretor panel uses is actually a nice way of
    taking advantage of our config module. Moving the helper to our util so others
    can use it.

commit 6945b02706ca7c49bb75447ebc05a6721ae15759
Author: Damian Johnson <atagar@torproject.org>
Date:   Thu Apr 17 09:53:36 2014 -0700

    Readline history can screw up the prompt
    
    Something between raw_input() and readline history has a bug for color prompts
    like ours. Certain histories cause our prompt to be widened. Widening our
    initial prompt with invisiable characters (like resets) seems to mitigate this.
    And yes, this is quite a hack. :(
    
    Steps to repro for python 2.7.1...
    
    1. Start prompt.
    2. Type "/help GETINFO version".
    3. Press 'up' to render that command. Your prompt should now look screwed up.
    4. Press 'down' to return to what should be a blank prompt. You'll still be
       offset several characters to the right.

commit 216a6072ccc5506ac7c00acc6ef618e531d42a23
Author: Damian Johnson <atagar@torproject.org>
Date:   Thu Apr 17 09:27:28 2014 -0700

    Moving --help output to configuration
    
    It wasn't worth having a config file for just this one string, but now that we
    have one anyway we might as well use it.
    
    This also changes msg() to raise a ValueError so it's less likely that errors
    where we fail to fetch string resources will go unnoticed.

commit 407f9537cb0de0ec3c1cf1423b74e16f42abe7f0
Author: Damian Johnson <atagar@torproject.org>
Date:   Thu Apr 17 09:12:08 2014 -0700

    Moving msg() helper to base module
    
    We'll want our msg() function outside of the commands module so moving it to
    __init__.py.

commit ca331a6fba5ead083c4a010b72e5d4886396e7a1
Author: Damian Johnson <atagar@torproject.org>
Date:   Wed Apr 16 10:15:18 2014 -0700

    Supporting the /info option
    
    Adding support for a /info option that provides a simple summary of a relay's
    information. This accepts a fingerprint, nickname, or IP address. If there's a
    match this provides basic information in a similar fashion to arm.

commit e4ea4f64e19c53a85414294f5b446d10cce4a074
Author: Damian Johnson <atagar@torproject.org>
Date:   Tue Apr 15 09:42:54 2014 -0700

    Interpretor event handling
    
    Supporting SETEVENTS and an '/event [type]' interpretor command for listing the
    events we've received.

commit 523d5075496a5787e8bb814ed593c6699a50e929
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Apr 13 12:37:07 2014 -0700

    Moving bulk of help output to config
    
    Moving most of the help descriptions to a configuration file rather than
    bundling it with the source. There's still some more bits I plan to move, but
    this gets the largest parts.

commit 0d357a9d6687afedbe9ad7509ced1797d1129cdf
Author: Damian Johnson <atagar@torproject.org>
Date:   Tue Apr 15 09:45:45 2014 -0700

    Invalid event types caused add_event_listener() error
    
    When presented with invalid or unrecognized event types our
    add_event_listener() is documented as raising a ProtocolError. However, it
    caused a KeyError instead...
    
      >>> SETEVENTS BW,DEBUG
      Traceback (most recent call last):
        File "./prompt", line 8, in <module>
          stem.interpretor.main()
        File "/home/atagar/Desktop/stem/stem/interpretor/__init__.py", line 67, in main
          print interpretor.run_command(user_input)
        File "/home/atagar/Desktop/stem/stem/interpretor/commands.py", line 449, in run_command
          self.controller.add_event_listener(self.register_event, *events)
        File "/home/atagar/Desktop/stem/stem/control.py", line 1920, in add_event_listener
          event_version = stem.response.events.EVENT_TYPE_TO_CLASS[event_type]._VERSION_ADDED
      KeyError: 'BW,DEBUG'
    
    Skipping the version check if we don't have a class for the event type. This
    both fixes invalid events, and also allows us to proper new event types that
    Stem doesn't recognize yet.
    
      >>> SETEVENTS BW,DEBUG
      SETEVENTS rejected BW,DEBUG

commit 2fad86f212566b456c1f66a159ef11714ec730d3
Author: Damian Johnson <atagar@torproject.org>
Date:   Thu Apr 10 09:12:33 2014 -0700

    Handler for interpretor commands
    
    Using a more sophisticated handler rather than simply run msg(). This adds
    '/help' and '/quit' interpretor commands as well as takes advantage of Stem's
    caching.

commit 9d933b1717abbc5f52f74e640bcb9beabf43ec06
Author: Damian Johnson <atagar@torproject.org>
Date:   Mon Apr 7 10:16:08 2014 -0700

    Handling EOF responses when awaiting input
    
    Handling for ctrl+d on the prompt.

commit 2ccd8797ea06933ff4c2a568c502c84378ddd80b
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Apr 6 17:54:53 2014 -0700

    Tab completion support
    
    Adding support for tab completion for commands tor will accept.

commit eed49b22e06b9a0ea549c68a23e3cb60a4ad7e8d
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Apr 6 13:46:56 2014 -0700

    Basic interpretor prompt
    
    Passing raw input to the control port and presenting the result.

commit 95c1711c7982dd38689c3ffcb1ede2b32a4c13d9
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Apr 6 11:29:18 2014 -0700

    Initial parts for an interpretor prompt
    
    Argument handling, connection, and authentication to tor. This presently
    doesn't allow you to *do* anything. It's just a 'hello world' demo that prints
    tor's version.

commit ccb8a16b9ccb8f11b16d7949d5172bf1f90dc618
Author: Damian Johnson <atagar@torproject.org>
Date:   Tue Apr 15 09:27:54 2014 -0700

    Connect didn't flag controllers as authenticated
    
    Our Controller class tracks if it's been authenticated to Tor or not. When
    users call msg('AUTHENTICATE...') we're authenticated, and when we attach to a
    new socket we're unauthenticated.
    
    This is all well and good, but when a user first constructs us from a
    ControlSocket we have no idea if that socket has been authenticated or not. We
    can't actively check because Tor will disconnect the socket if it doesn't obey
    a very specific authentication dance (... ugg). So we need our caller to tell
    us if it's been authenticated or not.
    
    Previously we just assumed it wasn't authenticated, causing our connect(),
    connect_port(), and connect_socket_file() methods to return a Controller that
    has been authenticated, but didn't know it had. In general this worked, but
    turns out event listening checks the authenticated flag.

commit 448ab2717223508044a4293b366c3ae0cf3e3638
Merge: 872b1e1 be37a4f
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Apr 13 11:52:27 2014 -0700

    Adding stem.connection.connect()
    
    Replacing our connect_port() and connect_socket_file() methods with a simpler,
    better connect() function.

commit be37a4f8a7c388970518e1502ef6d6194743a9d1
Author: Damian Johnson <atagar@torproject.org>
Date:   Mon Apr 7 09:58:02 2014 -0700

    Making connect()'s password prompt opt-in
    
    Making use of stdin opt-in allows the connect() function to be used more safely
    in quick and dirty scripts. Users can then allow a password prompt if waiting
    on stdin is safe.

commit 0efd180327c96a75d25744374e72bf11b5a5b586
Author: Damian Johnson <atagar@torproject.org>
Date:   Sat Apr 5 21:07:51 2014 -0700

    Unit tests for the connect() function
    
    One really neat thing about stealing arm's code is that I'd actually written a
    lot of good unit tests, so we can now move those to stem! Our connect* methods
    previously only had integ coverage, so this is a really nice improvement.
    
    This also uncovered a few bugs from porting the function.

commit 69433bdacc27d3db968b8fc414f1ee598ad54013
Author: Damian Johnson <atagar@torproject.org>
Date:   Sat Apr 5 15:48:48 2014 -0700

    Better connect() function for easily getting a Controller
    
    Stem provided a couple high level functions for getting a Controller with
    minimal fuss: connect_port() and connect_socket_file(). These interacted
    directly with stdin and stdout making them undesirable for sophisticated use
    cases, but for commandline scripts provided a one-line method of geting an
    authenticated Controller.
    
    Personally I never used these myself. Not because I didn't need this, but
    because I had done better in arm. In arm's connection helper it...
    
    * Provided better, more useful error output upon authentication failure.
    
    * Attempted to connect to both a control port and socket, then was smart about
      the message it presented if both failed.
    
    On reflection the first belongs in Stem (hell, why not provide better error
    output?!?). As for the second I realized that having separate control_port()
    and control_sockeet_file() functions was a mistake.
    
    This deprecates the old connect_* functions in favor of a single new connect()
    that does essentially exactly what we do in arm: try to get a tor connection,
    and give nice advice if we can't.

commit 872b1e1647cb0dc31699045b0f2b90511a3fd07e
Merge: d70fa9c eee3a99
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Mar 30 20:38:32 2014 -0700

    General site revisions
    
    Lots of revisions to our site, most notably around our FAQ and examples
    section...
    
    * Adding scripts section with neat examples that have come up in the past.
    * Greatly improved the readability of our FAQ by making entries more concise.
    * Application entry for Exit Map, and added munin-tor and exit-funding below.
    * Torrc syntax highlighting.

commit eee3a9985008be210492904c9e668e4a71d93d08
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Mar 30 17:01:25 2014 -0700

    Dropping back button from top level tutorials
    
    On reflection the nav bar already links to the top level tutorial page so
    there's no need for a back button for that. I *am*, however, keeping the button
    on the example scripts since it's useful there.

commit ba26ef0d3941ae3ce23dedca881e8e5e3b9a1f1b
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Mar 30 16:51:45 2014 -0700

    Moving ExitMap to the applications
    
    We listed ExitMap a while back, but I just realized Philipp made a really nice
    site for his Spoiled Onions paper...
    
      http://www.cs.kau.se/philwint/spoiled_onions/
    
    Linking to that rather than his GitHub repository, and moving this up to the
    section reserved for sizable applications.

commit 1ffa990294ec9fca12f8610184d89ca2a260b385
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Mar 30 14:26:38 2014 -0700

    Back buttons for tutorials and example scripts
    
    Adding a '<< Back' button to our tutorials and example scripts to make the
    pages easier to navigate. Most pages on our site are a pretty flat hierarchy
    (download, faq, etc), but these are an exception to that so it's handy to be
    able to go up a level.

commit 57907d0d36d406a7d734600e3abb3a36f0956380
Author: Damian Johnson <atagar@torproject.org>
Date:   Sat Mar 29 16:25:28 2014 -0700

    Adding exit-funding to our examples
    
    Adding Moritz's script to determine how much funding exit operators should get.

commit 30290b73ff45134d4e76eda510337577405b3ba6
Author: Damian Johnson <atagar@torproject.org>
Date:   Thu Mar 27 09:53:46 2014 -0700

    Adding munin-tor to our examples
    
    Neat plugin from Martin for Munin...
    
      https://lists.torproject.org/pipermail/tor-relays/2014-March/004168.html

commit 7f463b14e32dff28b978264bb589ae62b7209b90
Author: Damian Johnson <atagar@torproject.org>
Date:   Thu Mar 27 09:35:49 2014 -0700

    Improving syntax highlighting
    
    Took a peek and Sphinx's docs for syntax highlighting, and using a bit of it...
    
    * Using the lighttpd lexer for torrcs since it both fades comments and
      emphasizes torrc keywords. This is a hack, and doesn't work if torrc entries
      have a ':', in which case I'm using a bash lexer instead.
    
    * Highlighting part related to event handling for its tutorial.
    
    * Specifying python highlighting for a couple python snippet in the faq.

commit 55f062fa9770319cf92fdd0d4439a554593a24b8
Author: Damian Johnson <atagar@torproject.org>
Date:   Wed Mar 26 09:57:55 2014 -0700

    Adding an example for listing circuit information
    
    This is an adapted from of the 'How do I get information about my exits?' FAQ
    entry I recently removed. Unlike that example, this provides information about
    the full circuit rather than just the last hop.

commit 4e81cb78d00d3d0b375261829b7f14a1671b0192
Author: Damian Johnson <atagar@torproject.org>
Date:   Wed Mar 26 09:42:28 2014 -0700

    Making CircuitEvent sortable
    
    Circuits should be sortable by their id. Making that the case so the following
    works...
    
      for circ in sorted(controller.get_circuits()):
        ... do stuff...

commit 79e924a9e7dc2f193c1869e9e36aea20292e076a
Author: Damian Johnson <atagar@torproject.org>
Date:   Wed Mar 26 09:18:40 2014 -0700

    Adding example for listing outdated relays
    
    Adding our script from ticket 9476 which prints contact information for relays
    prior to a given version. I picked example output that was especially obscured
    addresses, then modified them further to make them useless to scrapers. ;)

commit 3299a5ad68c85d6f33f20b7cbeb68ee175877d16
Author: Damian Johnson <atagar@torproject.org>
Date:   Wed Mar 26 09:01:04 2014 -0700

    Moving "Determine The Exit You’re Using" to the example scripts
    
    Moving this example from our client usage tutorials to the example scripts.
    This is a good standalone example, and unrelated to the other tasks in the
    tutorial.

commit c26169071a6a5de9c9c5bf2e9ef185e84355ea9f
Author: Damian Johnson <atagar@torproject.org>
Date:   Tue Mar 25 10:10:08 2014 -0700

    Adding a 'Scripts' section to our examples page
    
    Coderman suggested a cookbook section on #tor-dev. I like this idea. On
    occasion I write one-off scripts for specific tasks. These would make fantastic
    examples for new Stem users, so starting a section on our examples page for
    them.
    
    I recall writing another script for 'list the contact information of all
    outdated relays' for a ticket. I'll dig that up later and add it.

commit 8680265c7e27f1c9bb8c18ca96b1b204f3013003
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Mar 23 22:32:59 2014 -0700

    Improving our FAQ and making entries more succinct
    
    Reordering and rewording our FAQ. This moves examples for the 'How do I connect
    to Tor?' examples to their respective modules to both make the FAQ entry more
    readable, and the modules more informative.
    
    This also dropped the "How do I get information about my exits?" FAQ entry
    since it's largely redundant with the 'Determine The Exit You’re Using' example
    in our tutorials.

commit 4b667d253258bc0363c82e81d0689fc0eff416e9
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Mar 23 16:03:19 2014 -0700

    Minor tutorial revisions
    
    Took a quick read through our tutorials. Just minor reordering and rewording.

commit d70fa9cdd85924ef2e24ceebc2ce348f50634d80
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Mar 23 14:24:09 2014 -0700

    Controller sometimes provides microdescriptor router status entries
    
    As pointed out by mr-4 on...
    
      https://trac.torproject.org/7646
    
    Tor's 'GETINFO ns/*' methods provide standard v3 router status entries when Tor
    isn't using microdescriptors, and microdescriptor flavored entries when it is.
    Changing our Controller's get_netword_status() and get_network_statuses()
    methods to provide the right return type.
    
    This is a clunkier for our users but there's not much that Stem can do about
    that. Oh well. :(

commit 632de4498defe1002a9c6ee2fe8aac4a58866608
Author: Damian Johnson <atagar@torproject.org>
Date:   Sat Mar 22 12:25:55 2014 -0700

    Using sub-headers for connection/authentication methods
    
    Using headers rather than an unordered list for the sections so we can link
    directly to them.

commit 099a4f3f5518acdc486019b0a465218d802eec3b
Author: Damian Johnson <atagar@torproject.org>
Date:   Sat Mar 22 12:01:17 2014 -0700

    Capitalizing proper nouns
    
    I'm horribly inconsistent about this. Capitalizing 'Stem', 'Tor', and 'Python'.
    Probably missed a few.

commit 779e766d8569f760ec9da201160b796b4c1f5535
Author: Damian Johnson <atagar@torproject.org>
Date:   Sat Mar 22 11:54:44 2014 -0700

    Adding a FAQ entry for connecting to tor's control port directly
    
    Adding the "Can I interact with Tor's controller interface directly?" FAQ
    entry. This covers how to connect to tor's control port/socket in each
    scenario. This was inspired by Jen's StackExchange answer on...
    
      https://tor.stackexchange.com/questions/1449/authenticate-telnet-connection

commit 207dba02d6adcf794b19e00b330548348c950878
Author: Damian Johnson <atagar@torproject.org>
Date:   Tue Mar 18 09:48:50 2014 -0700

    Lowering logging about undelivered messages to the info level
    
    Our BaseController's test_msg_repeatedly integ test hammers the holy bejezus
    out of our controller socket in the hope of triggering exotic concurrency
    issues that might lead to issues like deadlock. This has been an impressively
    great test at ferreting out exotic issues and this is no different. Our Jenkins
    tests frequently log...
    
      03/12/2014 15:37:57 [NOTICE] BUG: the msg() function failed to deliver a
        response: Authentication required.
    
    After a couple hours of looking into this I gotta admit that I'm frustrated by
    the delicacy of our message handling. It works great in practice, but in theory
    issues such as socket errors or edge cases can cause undelivered messages.
    
    In this case rapidly connecting and closing the socket while simultaneously
    communicating on it causes the socket's recv() to occasionally raise
    exceptions. These exceptions are reported to callers, leaving enqueued messages
    that end up being undelivered (logging this notice).
    
    After much head scratching and digging into our socket class I've come to the
    realization that this is about as good as it's gonna get. If we use our recv
    queue to communicate *both* messages and exceptions then it is to be expected
    that exceptions can sometimes result in undelivered messages.
    
    Lowering the severity of the log message appropriately.

commit 863ddacb961ffe255f02eeea115515bd7f3ffd41
Author: Damian Johnson <atagar@torproject.org>
Date:   Mon Mar 17 09:19:32 2014 -0700

    Don't use @lru_cache for exit policy rules
    
    Lession learned today: @lru_cache is handy for efficiency but don't rely on the
    cache to function.
    
    Our ExitPolicy class expected its _get_rules() method to be called exactly once
    due to having cached results. However, pickling then unpicking an ExitPolicy
    class caused our @lru_cache to be cleared, resulting in a TypeError.
    
    Replacing this method's @lru_cache with a standard one, and adding a test for
    pickleability. Thanks to Nicholas Hopper for the catch!

commit d3bcdb32eb6c4942f524c0c513b5ce625f4ff9e8
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Mar 16 16:05:32 2014 -0700

    EventType mistakenly listed HS_DIR rather then HS_DESC
    
    Oops. Another mistake spotted by wfn.

commit fbe7505822d16810dad8f3255b99053116962882
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Mar 16 16:03:28 2014 -0700

    Adding HS_DIR to the EventType enum
    
    Oops, we documented HS_DIR but didn't actually include it in the enum. Spotted
    by wfn. Also sorting the enum to make it match the docs.

commit 9aadf0e989b8ecaa41628ddd8ce8edc099539ec4
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Mar 16 11:12:57 2014 -0700

    Noting when HS_DESC support was added
    
    Oops, forgot to note when we added HS_DESC event support. Spotted by wfn.

commit fe88fa7dce85741f0e42bba33d5b24b2892cdd65
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Mar 16 10:41:40 2014 -0700

    Don't cite features as coming in '1.1.0-dev'
    
    I've been inconsistent when mentioning when features are introduced. Sometimes
    I say '1.1.0-dev' while elsewhere I say '1.2.0'. The theory on the former was
    that the '-dev' suffix would mean 'unreleased things'. However, we know what
    the next version is gonna be so we might as well just say that.

commit d5eabee949f3bbee347db11525978be45b00725c
Author: Damian Johnson <atagar@torproject.org>
Date:   Mon Mar 3 15:59:17 2014 -0800

    Support for HS_DESC events
    
    Adding support for tor's now HS_DESC events...
    
      https://gitweb.torproject.org/torspec.git/commitdiff/a67ac4d
      https://trac.torproject.org/10807

commit 6c0962943c96a4683ce1634399289340f84b8b8a
Author: Damian Johnson <atagar@torproject.org>
Date:   Mon Feb 24 09:13:01 2014 -0800

    Controller methods get_ports() and get_listeners()
    
    Determining tor's control or socks port was once as simple as...
    
      GETCONF ControlPort
    
    However, tor has expanded its config options so these often provide more
    information than just the port number.
    
    Back in commit 3a2875f Sean added a get_socks_listeners() method that uses
    'GETINFO net/listeners/socks' to determine tor's socks port, and falls back on
    config options if that's unavailable.
    
    This change deprecates get_socks_listeners() in favor of more generic
    get_ports() and get_listeners() methods. The get_listeners() behaves like
    get_socks_listeners() but for several listener types, while get_ports()
    provides just the port numbers for local connections.

commit a6f0255673a949ca9950007aa07f2c35359e79ca
Author: Damian Johnson <atagar@torproject.org>
Date:   Sat Feb 22 07:42:44 2014 -0800

    Tutorial section for determining the exit you're using
    
    Neat idea from Arturo for a tutorial section showing users how to determine the
    exit node they're using at a given time.

commit 1f2ea0f2eb5ab19d272b72e022bd5f0266662780
Author: Damian Johnson <atagar@torproject.org>
Date:   Sat Feb 22 07:11:43 2014 -0800

    Recognize platform line for node-Tor relays
    
    We have a few relays in the wild running node-Tor, a JS counterpart for tor...
    
      https://github.com/Ayms/node-Tor
    
    These relays have a 'node-' prefix on their platform lines. For instance...
    
      'platform node-Tor 0.1.0 on Linux x86_64'
      https://atlas.torproject.org/#details/E0671CF9CB593F27CD389CD4DD819BF9448EA834
    
    Caught by sysrqb on...
    
      https://trac.torproject.org/11008

commit a254e5ff8529db70756758782a9a2646a71a1d94
Author: Damian Johnson <atagar@torproject.org>
Date:   Thu Feb 13 09:06:50 2014 -0800

    Moving pep8 and pyflakes helpers to stem.util.test_tools
    
    Twice now I've copied the part of stem's test/util.py for performing pyflakes
    and pep8 checks (for both arm and ExitMap). I don't want to vend this
    functionality but it's silly for us to keep copying this functionality.
    
    Generalizing the helper functions and moving them to our util. Like the log
    module, this has a note that it is not something we vend and that users should
    not rely on it to have a backward compatible API.

commit a9bb652a071b342ea74084b19cb28e3c479e2635
Author: Damian Johnson <atagar@torproject.org>
Date:   Tue Jan 28 07:12:31 2014 -0800

    Replace Signal.SIGHUP with Signal.HUP in FAQ
    
    Issue spotted by rdsoze on #tor.

commit 9f3bd3f6a9c1b3155efe123ad9390c5365d76192
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Jan 26 19:21:59 2014 -0800

    Resetting NEWNYM counter when wiping cache
    
    If we attach to a new (or maybe previous) tor instance then we shouldn't carry
    over the timestamp we last issued a NEWNYM signal.

commit c510c1b01599781b249f12c06062082309ea5f0e
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Jan 26 19:15:51 2014 -0800

    Adding controller methods to check NEWNYM availability
    
    Adding a couple methods to check if tor will respect a NEWNYM signal or not.
    This only works if signals are only sent through stem.

commit ed63439d9c0ed846ea0d526dc7fdc92569aa26c5
Author: Damian Johnson <atagar@torproject.org>
Date:   Mon Jan 20 09:32:19 2014 -0800

    Only check for extra tor processes once
    
    Well, that was unintuitive. Our test class' constructor is called once for each
    test, so self.is_extra_tor_running was always None for our setup block.
    
    Moving this out into a global so we only check this once. This has a couple
    advantages...
    
    1. Fewer system calls so our integ tests run faster. This amounts to about 0.5s
       on my system.
    
    2. Less confusing test output. Our jenkins tests had a handful of failures that
       was probably due to having multiple tor processes running...
    
       https://jenkins.torproject.org/job/stem-tor-ci/448/console
    
       The weird thing was that some tests properly skipped with 'multiple tor
       instances' while others didn't and in turn failed. Now we should either
       always skip or always run.
    
    One thing that has me concerned is that if a new tor instance spins up in the
    middle of our test run then we won't detect it. We might need to change this
    later to always check if we last detected only a single process. Even if we do
    this we'll get most of the runtime benefits since this now resides in a helper
    function rather than setup (so it's only triggered when relevant).

commit 660474f1ec101716662bfa773a30d684a1270a23
Author: Damian Johnson <atagar@torproject.org>
Date:   Mon Jan 20 08:58:42 2014 -0800

    Unit test for LSOF parsing on OSX
    
    Test to make sure we can handle output from lsof on OSX.

commit 2c8bfa84880fdcefe43137f0f097831bf06aa1a9
Author: Damian Johnson <atagar@torproject.org>
Date:   Thu Jan 9 09:30:11 2014 -0800

    Updating year in copyright notices
    
    Feels a little silly that we need to do this, but oh well.

commit 42bdd8307705ff33b762a60b2ba9d958650f4b59
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Jan 5 21:55:37 2014 -0800

    Utility function to provide port usage information
    
    Adding a stem.util.connection.port_usage() function that provides a brief
    description of a port's common use. This is a capability arm has long hand, and
    nicely complements our ability to query connection information.

commit 6837752b4c5d7f74bef8be0bca8c8fc7f6f3e8f7
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Jan 5 21:50:40 2014 -0800

    New succinct test output reported errors as successes
    
    We reported failures as failures but didn't interpret errors as failures as
    well.

commit b1081d4abb56439a7d4b8dfd254d079d32d9b976
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Jan 5 21:44:19 2014 -0800

    Increase --test scope to be any module substring
    
    Our --test argument only ran tests matching a given prefix but this was silly
    for a couple reasons...
    
    1. That's unintuitive. If I give 'util.conf' I expect it to run tests with
       'util.conf', not starting with that. There's no advantage to a prefix match.
    
    2. Now that we're displaying less verbose test output we strip off the
       'test.unit.' or 'test.integ.' prefix that all the module names have. With
       this change the user can copy-and-paste what we show them to just run that
       test.

commit 4cf84706db2416d11bc2ccd82a83a2397384cf0d
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Jan 5 21:39:00 2014 -0800

    Don't run static tests with the --test argument
    
    When we're running a single test it sucks to wait for static checks. They're
    now quick, but not that quick.

commit 46bfcad588b7e41cff109d72ea7a88717beb2c00
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Jan 5 11:05:27 2014 -0800

    Style issues suppressed pyflakes results
    
    When both pyflakes and pep8 reported issues about a file the pep8 results
    clobbered the pyflakes output. Properly combining the two instead.

commit 6f696e98c155434d6ac95806052eb634d36e1e8e
Author: Damian Johnson <atagar@torproject.org>
Date:   Sat Jan 4 15:14:31 2014 -0800

    Defaulting to provide less verbose test output
    
    Our test output is pretty sweet, but as we've added more tests it's gotten to
    be pretty overwhelming. This is especially troublesome for the RUN_ALL target
    which our jenkins test use.
    
    Dropping output on individual tests unless there's a failure. Instead, we now
    just print the test modules and their runtime. Users can get the more verbose
    output by including '--verbose' in their test run.

commit 68979148f1e09b7bca22bde876524029f419d1e5
Author: Damian Johnson <atagar@torproject.org>
Date:   Sat Jan 4 12:21:42 2014 -0800

    Checking for pep8.BaseReport
    
    Our jenkins tests are also failing because they have the pep8 module, but it
    lacks the BaseReport. Checking for that as well.

commit eaa7a9253ba8d8955a6d4ee911269bf94ed4f2aa
Author: Damian Johnson <atagar@torproject.org>
Date:   Sat Jan 4 12:14:17 2014 -0800

    Moving static checks to the start
    
    Rearranging our test run so the static checks (pyflakes and pep8) occure at the
    start and are listed among the initialization tasks. This makes it clearer that
    they're running and the runtime dedicated to them. It also gets rid of a silent
    pause at the end of the test run I've always disliked.

commit 32aadbc7f7918d5c9f47a748a288fad16ce5ca69
Author: Damian Johnson <atagar@torproject.org>
Date:   Sat Jan 4 11:44:51 2014 -0800

    Checking for the pyflakes modules we use
    
    Presently our jenkins tests are failing since the system has pyflakes version
    0.5 which evidently doesn't have the pyflakes.api module...
    
      https://trac.torproject.org/10539
    
    Checking explicitly for the modules we use when determining if pyflakes is
    avaialable.

commit 4655b2e7594b8796daf25a1abc674a0761d5563a
Merge: 5f8a2da 49bfd12
Author: Damian Johnson <atagar@torproject.org>
Date:   Thu Jan 2 09:09:47 2014 -0800

    Using pyflakes and pep8 apis
    
    Taking advantage of pyflakes and pep8 as python modules rather than shelling
    out, along with other general improvements for our static checks. This results
    in around a 60% reduction in the runtime for our static checks.

commit 49bfd123ef9ee2706b797958b8b6b5eea75302d9
Author: Damian Johnson <atagar@torproject.org>
Date:   Thu Jan 2 08:56:13 2014 -0800

    Using _python_files() for custom style checks
    
    Oops, we pretty much duplicated _python_files() for a bit of our checks.

commit 5a9e5fe8a41236588f339b80499c2bc96997f24d
Author: Damian Johnson <atagar@torproject.org>
Date:   Thu Jan 2 08:51:46 2014 -0800

    Moving files_with_suffix() to system util
    
    Our system module already has path manipulation helpers like expand_path() so
    probably a better home for files_with_suffix().

commit 157ca0fd4e56047880d8333612633dece1c3fca8
Author: Damian Johnson <atagar@torproject.org>
Date:   Thu Jan 2 08:16:09 2014 -0800

    Dropping unneeded pyflakes rules
    
    Removing rules for things that pyflakes 0.7.3 doesn't complain about. I'm not
    sure if this is due to changes over time in our code or pyflakes itself. If the
    later then we might add the rules back in later to prevent it from being noisy
    on platforms with other versions.

commit 5853a11f2d80f56ee3265374d6350b144f03fe02
Author: Damian Johnson <atagar@torproject.org>
Date:   Thu Jan 2 08:11:31 2014 -0800

    Subclassing pyflakes' Reporter
    
    Properly subclassing pyflakes' reporter rather than simply implementing its
    interface.

commit 7c6f4d9731195d9fb8e49bc8943d63dc063e8c65
Author: Damian Johnson <atagar@torproject.org>
Date:   Wed Jan 1 18:03:33 2014 -0800

    Always running style checks
    
    Running pep8 took substantially longer than all our unit tests, so we only ran
    it if the user included the '--style' argument. Now that the runtime's down to
    something reasonable we can include it in all test runs.

commit 44ae69fbeedee60c86550b52804d85a24ca33637
Author: Damian Johnson <atagar@torproject.org>
Date:   Wed Jan 1 17:55:29 2014 -0800

    Use pep8's api rather than shelling out
    
    Like pyflakes, pep8 is a python library (... albeit a lot more confusing to
    use). This provides us a 63% drop in the runtime of our style checks (from 8 to
    3 seconds on my system). This is down to the realm that I'm a little tempted to
    always run them...

commit 984b77b4f19592f3bc155f1fba895111ed9cba99
Author: Damian Johnson <atagar@torproject.org>
Date:   Wed Jan 1 16:30:44 2014 -0800

    Use pyflakes' api rather than shelling out
    
    We've been shelling out to pyflakes and parsing its output. This is all well
    and good except that it's... well, silly. Pyflakes is a python library, and
    provides us with well structured data faster if we use it like so. This halves
    the runtime of our unit tests (from 6 to 3 seconds on my system)!

commit f0a9211a8eae41c674d58d5bea41eefb4eed7969
Author: Damian Johnson <atagar@torproject.org>
Date:   Wed Jan 1 13:06:06 2014 -0800

    Style checks accidently clobbered 'path'
    
    Oops, we used the 'path' variable a little name overwriting it from the outer
    scope. This in turn likely broke our custom style checks making them apply to
    just the last PEP8 match rather than the full directory.

commit 0cbcfbb36c74019377cd3e0feb57b30e22d99570
Author: Damian Johnson <atagar@torproject.org>
Date:   Tue Dec 31 09:16:00 2013 -0800

    Helper function for ignored pyflakes issues
    
    Bit of this code is begging for a small helper function. Makes the loop far
    more readable.

commit 2a0d501384ec218d8e5dd8494feed6a6654d0fe3
Author: Damian Johnson <atagar@torproject.org>
Date:   Tue Dec 31 09:10:09 2013 -0800

    Dropping PYFLAKES_IGNORE
    
    Simple case of premature optimization. We cached our 'path => issue' mappings
    for pyflakes messages to ignore. This is pointless - we only do it once, and
    it's not even any substantial overhead to do repeatedly.

commit 5f8a2da5eb6617f27395635287cd671df1519a29
Author: Damian Johnson <atagar@torproject.org>
Date:   Sat Dec 28 19:21:47 2013 -0800

    Linking to the 14.1 slackware link
    
    Change requested by Markus for the next Slackware release, which will have stem
    version 1.1.1.

commit d865784767b4446c4068d7f70985789fb4f4f010
Author: Damian Johnson <atagar@torproject.org>
Date:   Wed Dec 18 08:07:53 2013 -0800

    Adding torirc to our examples

commit e16a8f8e8c8931c09d61d9b179005621d4785b73
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Dec 15 12:09:52 2013 -0800

    Noting stem's latest version and release date on the index page
    
    Another good suggestion from Markus.

commit 357b54c91dea9e6fd2f6a93e63529cfc30e3a8e0
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Dec 15 12:04:21 2013 -0800

    Linking to stem's tarball from the download page
    
    Suggestion from Markus. It wasn't obvious from our download page that tarballs
    were available from PyPI so explicitely linking to them.

commit b0b413af709dacfe6b60ea5d15cdc52f9e5d768f
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Dec 1 16:59:07 2013 -0800

    Adding Philipp's ExitMap project as an example
    
    Adding a project Philipp mentioned on tor-dev@...
    
    https://lists.torproject.org/pipermail/tor-dev/2013-November/005863.html
    https://github.com/NullHypothesis/exitmap

commit a6d025d63d576b9c0fae86f8d0ed2afe79d11e77
Author: Damian Johnson <atagar@torproject.org>
Date:   Fri Nov 15 09:00:15 2013 -0800

    No-op change for troubleshooting ticket 10132
    
    Helix requested a commit to help with troubleshooting...
    
      https://trac.torproject.org/10132

commit a2f022a007440998417f6bf184da9db4be141fc4
Author: Damian Johnson <atagar@torproject.org>
Date:   Sat Nov 9 11:48:30 2013 -0800

    PEP8 issue with a test we recently added
    
    Minor issue caused when we expanded our event tests...
    
    * /home/atagar/Desktop/stem/test/unit/response/events.py
      line 1266 - E203 whitespace before ':'
      line 1266 - E231 missing whitespace after ':'

commit c27dc313c0ead935bbc71e8b92938fe4a4b18168
Merge: e8c916b b1fb3e7
Author: Damian Johnson <atagar@torproject.org>
Date:   Sat Nov 9 11:46:25 2013 -0800

    Merge version 1.1.1 hotfix

commit b1fb3e7a2cbbef029f483f084da98940844a3058
Author: Damian Johnson <atagar@torproject.org>
Date:   Sat Nov 9 11:44:43 2013 -0800

    Stem release 1.1.1

commit 13d489c0b38e78cace3ea6758baa65ae7fd31e49
Author: Damian Johnson <atagar@torproject.org>
Date:   Sat Nov 9 11:38:42 2013 -0800

    Windows lacks the pwd module
    
    Python's pwd module is only available on Unix platforms. We didn't account for
    this, causing our system module to raise ImportErrors on Windows. Reported by
    realgame on...
    
    https://trac.torproject.org/10072
    
    This regression was introduced by our 1.1.0 release (1.0.1 didn't use pwd), so
    cutting a hotfix release for this fix.

commit e8c916b20cdd9570d6ead75bdba190edf02bc7a9
Merge: ae6d978 d6a95bf
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Nov 3 23:24:16 2013 -0800

    Supporting new event types from proposal 218
    
    Adding support for the new event types from proposal 218, "Controller events to
    better understand connection/circuit usage"...
    
    https://gitweb.torproject.org/torspec.git/commitdiff/6f2919a

commit d6a95bf778e6b90d9de9ea46aefcfce2f9103e68
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Nov 3 23:22:32 2013 -0800

    Adding support for TB_EMPTY events
    
    Last event type from...
    
    https://gitweb.torproject.org/torspec.git/commitdiff/6f2919a

commit ae6d97837a30066264c8ed02f916e7529c5f8349
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Nov 3 13:12:33 2013 -0800

    Checking constraints on the usecreatefast property
    
    New consensus property from...
    
      https://gitweb.torproject.org/torspec.git/commitdiff/6b55759

commit 5898557b596c1e2dfbd89c44a621aefb5286955a
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Nov 3 19:35:38 2013 -0800

    Adding support for CELL_STATS events
    
    Yet another event type from...
    
    https://gitweb.torproject.org/torspec.git/commitdiff/6f2919a

commit eb808565f5e2ea8885eabba682e6ff97873be056
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Nov 3 13:05:12 2013 -0800

    Adding support for CIRC_BW events
    
    Pretty much identical to their CONN_BW counterpart (minus a connection type).
    Also added in...
    
    https://gitweb.torproject.org/torspec.git/commitdiff/6f2919a

commit 41274f4658772cbab5a22750e56d48b1b4478b6f
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Nov 3 12:54:21 2013 -0800

    Adding support for CONN_BW events
    
    New event type added in...
    
    https://gitweb.torproject.org/torspec.git/commitdiff/6f2919a

commit 118f1bb1fde1dc2740cfea1fb6871e024e036711
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Nov 3 09:52:59 2013 -0800

    Citing version 1.1.0 event changes
    
    Oops, just looked for changed function signatures (def statements). Noting a
    couple event changes that were made in release 1.1.0.

commit dfa171070607c3c21667998d03dde7ad92c7625d
Author: Damian Johnson <atagar@torproject.org>
Date:   Sat Nov 2 22:43:57 2013 -0700

    Supporting ORCONN event's new ID attribute
    
    New event attribute in tor version 0.2.5.2-alpha. This is from...
    
    https://gitweb.torproject.org/torspec.git/commitdiff/6f2919a

commit f0c90e2b3f46884fcf710e1895e13a7ab36329f4
Author: Damian Johnson <atagar@torproject.org>
Date:   Tue Oct 29 08:47:29 2013 -0700

    Adding tbbscraper to our examples page
    
    Including Zack's project as another example.

commit c0e20264548d1566501eb2a38b2df4ddeabba87c
Merge: 1c853f2 f3d6063
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Oct 27 11:02:01 2013 -0700

    Testing our examples via doctest
    
    Exercising our interpretor style examples (ones with a '>>>') via python's
    doctest module. Sadly this does not include sphinx examples (those proceeded
    with a '::'), its own doctest module might do the trick...
    
    http://sphinx-doc.org/ext/doctest.html
    
    ... but I'm not clear if or how we can tie that into our unit tests. For now
    putting it on our backlog...
    
    https://trac.torproject.org/10036

commit f3d6063b761172eafd7ce027e727eeb8b5bc79a4
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Oct 27 10:58:56 2013 -0700

    Expanding doctest to cover the conf module
    
    Including a small bit of the conf module with our tests. We're skipping the
    part where we print CONFIG because an actual interpretor doesn't do a pretty
    print, so we'd need to make our example less readable to be correct.

commit daa2b6e0674257b6b673343e07d9b011f3fcad3f
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Oct 27 10:36:24 2013 -0700

    Dropping unnecessary imports from pydoc examples
    
    I added a handful of imports to our pydoc examples to allow doctest to work.
    However, with globs we can work around needing them (yay!).

commit 177104b20de090b3521c66c441cdeb05bbbb9e5c
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Oct 27 09:44:02 2013 -0700

    Extending doctests to cover the controller
    
    Doctests provides a 'globs' argument we can use for a mock controller object.
    This in turn lets us easily test the control.py module (I'm starting to really
    like doctest...).

commit 3abe1400567b3479a567b96f9da41cf9152b6fa4
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Oct 27 09:20:06 2013 -0700

    Using absolute paths for doctest
    
    By default doctests refuse absolute paths, which required us to do a gross
    hack. It turns out that the module has a module_relative argument that lets us
    accept them, so dropping the hack.
    
    Also making sure we run all doctests before failing (so we get output for all
    of them before aborting).

commit 10d1423d93bc68114ed22d909e17e96aca621bbe
Author: Damian Johnson <atagar@torproject.org>
Date:   Sat Oct 26 20:18:59 2013 -0700

    Testing interpretor-style examples in our pydocs
    
    Using python's doctest module to test interpretor examples (those with '>>>').
    Unfortunately this doesn't include sphinx code blocks (those started with a
    '::') nor some of our examples that aren't easy to mock.

commit 1c853f222c9d0093656c3b53832bbacf23e90acd
Author: Damian Johnson <atagar@torproject.org>
Date:   Thu Oct 24 09:38:41 2013 -0700

    Citing version when additions or changes to our API were made
    
    Using sphinx's versionadded and versionchanged to note the version when our API
    has changed.

commit be4eb5e9e1061db19bb03314dcb3026f4778018d
Author: Damian Johnson <atagar@torproject.org>
Date:   Tue Oct 15 08:49:24 2013 -0700

    Updating url for FreeBSD port
    
    While upgrading Carlo moved the FreeBSD port from security/stem to
    security/py-stem to better reflect their conventions.

commit 8ccc2e437e27c26e8813624d0affd15c47513eaa
Author: Damian Johnson <atagar@torproject.org>
Date:   Tue Oct 15 08:44:13 2013 -0700

    Summary for release 1.1
    
    Adding a brief summary to the changelog for release 1.1, most importantly
    pointing to the blog posting for it. Borrowed the summary from Lunar's weekly
    news post for this.

commit a5392292c829190940d43c34690b0d08e6eaaf1c
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Oct 13 18:37:04 2013 -0700

    Tagging version 1.1 changelog
    
    Revising our changelog to list the changes in version 1.1. Also re-adding the
    '-dev' suffix to our git version.

commit 2ef492467d13a121a76ac8ebfdc2dfbaa4b20e1d
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Oct 13 18:15:41 2013 -0700

    Stem release 1.1.0

commit 216937c0821e27301f60dd77a1addfb286b1b3ea
Merge: 242569a 6c81b10
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Oct 13 17:40:51 2013 -0700

    Correcting test issues with python 2.6 and 3.x
    
    Generally I just work with python 2.7, so other interpretor versions just get
    love prior to releases. Most of this is issues with our tests, but @lru_cache
    introduced a lot of legitimate regressions for python 3.x.

commit 6c81b101dd69cf9f4b9170aa089d98e38220f383
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Oct 13 17:25:34 2013 -0700

    Python 3 compatability for mapaddress test
    
    Quite a few byte vs unicode gotchas. Also, the behavior of indexing into byte
    strings changed in python 3 (it provides ints rather than characters).
    
    ======================================================================
    ERROR: test_mapaddress
    ----------------------------------------------------------------------
    Traceback (most recent call last):
      File "/home/atagar/Desktop/stem/test/data/python3/test/integ/control/controller.py", line 813, in test_mapaddress
        test.network.negotiate_socks(s, '1.2.1.2', 80)
      File "/home/atagar/Desktop/stem/test/data/python3/test/network.py", line 321, in negotiate_socks
        request = "\x04\x01" + struct.pack("!H", port) + "\x00\x00\x00\x01" + "\x00" + host + "\x00"
    TypeError: Can't convert 'bytes' object to str implicitly

commit 992c94bc6065cee6281266df6e482a6367dd56c6
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Oct 13 16:39:28 2013 -0700

    Fixing AttributeError in use_directory_mirrors()
    
    Correcting a couple issues, one in the tests and another in the remote
    descriptor module, causing integ failures.
    
    ======================================================================
    ERROR: test_use_directory_mirrors
    ----------------------------------------------------------------------
    Traceback (most recent call last):
      File "/home/atagar/Desktop/stem/test/integ/descriptor/remote.py", line 62, in test_use_directory_mirrors
        downloader.use_directory_mirrors()
      File "/home/atagar/Desktop/stem/stem/descriptor/remote.py", line 419, in use_directory_mirrors
        if Flag.V2DIR in desc.flags:
    AttributeError: 'str' object has no attribute 'flags'
    
    ======================================================================
    ERROR: test_using_authorities
    ----------------------------------------------------------------------
    Traceback (most recent call last):
      File "/home/atagar/Desktop/stem/test/integ/descriptor/remote.py", line 34, in test_using_authorities
        for authority, (address, dirport) in stem.descriptor.remote.DIRECTORY_AUTHORITIES.items():

commit bfd5a667f150d4fef77c6a730432494ee930610b
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Oct 13 13:20:08 2013 -0700

    Fixing python 3 testing issue with key certs
    
    Test file wasn't being opened in bytes mode, causing...
    
    ======================================================================
    ERROR: test_metrics_cert
    ----------------------------------------------------------------------
    Traceback (most recent call last):
      File "/home/atagar/Desktop/stem/test/data/python3/test/integ/descriptor/networkstatus.py", line 178, in test_metrics_cert
        cert = next(stem.descriptor.parse_file(cert_file))
      File "/home/atagar/Desktop/stem/test/data/python3/stem/descriptor/__init__.py", line 200, in parse_file
        for desc in file_parser(descriptor_file):
      File "/home/atagar/Desktop/stem/test/data/python3/stem/descriptor/__init__.py", line 241, in _parse_metrics_file
        for desc in stem.descriptor.networkstatus._parse_file_key_certs(descriptor_file, validate = validate, **kwargs):
      File "/home/atagar/Desktop/stem/test/data/python3/stem/descriptor/networkstatus.py", line 252, in _parse_file_key_certs
        yield stem.descriptor.networkstatus.KeyCertificate(bytes.join(b"", keycert_content), validate = validate)
    TypeError: sequence item 0: expected bytes, str found

commit a303b137a9ada7cc9a31a57ba2dcbeae89dd83a3
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Oct 13 12:55:24 2013 -0700

    Fixing python 3 compatability for remote descriptor unit tests
    
    ======================================================================
    ERROR: test_query_with_timeout
    ----------------------------------------------------------------------
    Traceback (most recent call last):
      File "/opt/python3.3/lib/python3.3/unittest/mock.py", line 1079, in patched
        arg = patching.__enter__()
      File "/opt/python3.3/lib/python3.3/unittest/mock.py", line 1132, in __enter__
        self.target = self.getter()
      File "/opt/python3.3/lib/python3.3/unittest/mock.py", line 1294, in <lambda>
        getter = lambda: _importer(target)
      File "/opt/python3.3/lib/python3.3/unittest/mock.py", line 988, in _importer
        thing = __import__(import_path)
    ImportError: No module named 'urllib2'

commit ab86475d484c9c727ba17b9cf39e1661d0e72a8a
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Oct 13 12:49:22 2013 -0700

    Fixing python 3 issue with orphaned annotation exceptions
    
    ======================================================================
    ERROR: test_annotations
    ----------------------------------------------------------------------
    Traceback (most recent call last):
      File "/opt/python3.3/lib/python3.3/unittest/mock.py", line 1087, in patched
        return func(*args, **keywargs)
      File "/home/atagar/Desktop/stem/test/data/python3/test/unit/descriptor/server_descriptor.py", line 224, in test_annotations
        self.assertRaises(ValueError, list, desc_iter)
      File "/opt/python3.3/lib/python3.3/unittest/case.py", line 570, in assertRaises
        return context.handle('assertRaises', callableObj, args, kwargs)
      File "/opt/python3.3/lib/python3.3/unittest/case.py", line 135, in handle
        callable_obj(*args, **kwargs)
      File "/home/atagar/Desktop/stem/test/data/python3/stem/descriptor/server_descriptor.py", line 157, in _parse_file
        raise ValueError('Content conform to being a server descriptor:\n%s' % '\n'.join(annotations))
    TypeError: sequence item 0: expected str instance, bytes found
    
    ----------------------------------------------------------------------
    Ran 31 tests in 0.028s
    
    FAILED (errors=1)

commit 1ed6e2b7e553414736913b3cd440843d66ccea94
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Oct 13 12:40:46 2013 -0700

    Hash functions for descriptor classes
    
    Ok, finally found out what this python 2 vs 3 hashing oddity is. If you define
    an __eq__() method in python3 then it doesn't inherit its parent's __hash__().
    This makes some sense, though it's unintuitive as hell. Oh well...
    
    http://stackoverflow.com/a/1608882/1067192

commit eaa89a67ebf6339a68972e705b76a8e01677d7b9
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Oct 13 12:21:06 2013 -0700

    Fixing python 3 compatablity for tordnsel test
    
    ======================================================================
    ERROR: test_parse_file
    ----------------------------------------------------------------------
    Traceback (most recent call last):
      File "/home/atagar/Desktop/stem/test/data/python3/test/unit/descriptor/tordnsel.py", line 55, in test_parse_file
        descriptors = list(_parse_file(io.BytesIO(TEST_DESC)))
    TypeError: 'str' does not support the buffer interface
    
    ----------------------------------------------------------------------
    Ran 1 test in 0.001s

commit e1bf7cbacb8797845c1bc2a778baa93d9748f4c9
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Oct 13 12:10:38 2013 -0700

    Fixing a couple python 3 network status document TypeErrors
    
    ======================================================================
    ERROR: test_duplicate_fields
    ----------------------------------------------------------------------
    Traceback (most recent call last):
      File "/home/atagar/Desktop/stem/test/data/python3/test/unit/descriptor/networkstatus/document_v3.py", line 247, in test_duplicate_fields
        if not is_consensus and lines[index].startswith('dir-source'):
    TypeError: startswith first arg must be bytes or a tuple of bytes, not str
    
    ======================================================================
    ERROR: test_misordered_fields
    ----------------------------------------------------------------------
    Traceback (most recent call last):
      File "/home/atagar/Desktop/stem/test/data/python3/test/unit/descriptor/networkstatus/document_v3.py", line 225, in test_misordered_fields
        elif not is_consensus and lines[index].startswith('dir-source'):
    TypeError: startswith first arg must be bytes or a tuple of bytes, not str
    
    ----------------------------------------------------------------------
    Ran 35 tests in 0.234s

commit efe5fbdd56b28b3f76de144e71901c0c75ebe5ac
Author: Damian Johnson <atagar@torproject.org>
Date:   Sat Oct 12 20:14:59 2013 -0700

    Caching hash values
    
    Well, even if we can't use @lru_cache we can still do it the old fashioned way. :P

commit d32d4ab45d27776385036b1a57d9329f270354fc
Author: Damian Johnson <atagar@torproject.org>
Date:   Sat Oct 12 20:11:23 2013 -0700

    Dropping @lru_cache for Version hashing
    
    The @lru_cache calls hash() so if ever called this would infinitely recurse.

commit 208c03cded57507f835265d7e4d2b4677d0e30e5
Author: Damian Johnson <atagar@torproject.org>
Date:   Sat Oct 12 20:07:52 2013 -0700

    Fixing python 3 issue concerning exit policy compression
    
    Oops, forgot about the byte vs unicode differences when doing compression for
    the ExitPolicy.

commit 4ef5ee1ee8fbecabeaee872f2681cdda1fb86584
Author: Damian Johnson <atagar@torproject.org>
Date:   Sat Oct 12 20:18:12 2013 -0700

    Adding hash functions to exit policy classes
    
    Huh, didn't expect that. To work the @lru_cache requires that all arguments
    (including the class in the ase of methods) are hashable. This makes perfectly
    sense, after all the cache is a 'argument => cached value' dictionary.
    
    Under python 2.x all seemed to be well, but under python 3.x the @lru_cache
    complained that our classes weren't hashable (which... well, they aren't). Why,
    then, did it work under python 2.x? Turns out there's a subtle difference where
    our object parent provides a __hash__ method for our id, but in python 3.x it's
    a little different (object still does, but for reasons I haven't been able to
    figure out it doesn't for our classes).
    
    The ExitPolicyRule can certainly be hashable. The ExitPolicy, however, is a lot
    trickier due to its lazy loading of rules. For now just opting for the same
    behavior as python 2.x and using the address.

commit 677ee1570cc1378b8abadb4071627ff53510cb8a
Author: Damian Johnson <atagar@torproject.org>
Date:   Sat Oct 12 19:23:04 2013 -0700

    Python 3 lru_cache isn't a collections annotation
    
    Oops, it's in functools, not collections.

commit 1dfa353ecfbef39ee606231e745b9b6318fd3a31
Author: Damian Johnson <atagar@torproject.org>
Date:   Sat Oct 12 17:35:55 2013 -0700

    Using @lru_cache for exit policy's str()
    
    Oops, missed one of our instances of manual caching.

commit e89c829fb75331fdc0d5aa03475c751371cb6c7e
Author: Damian Johnson <atagar@torproject.org>
Date:   Sat Oct 12 16:57:50 2013 -0700

    Using python3's unittest.mock module when available
    
    Guess it's been a while since I last tried to test under python3. From python
    3.3 on up the Mock library is built into the unittest module. Accounting for
    this so we can test under python3 again.

commit d09bd8b365819f4ea0d0a7d6b782b1021dba91c1
Author: Damian Johnson <atagar@torproject.org>
Date:   Sat Oct 12 16:37:02 2013 -0700

    Fixing python3 issue related to unicode exit policies
    
    Our recent exit policy caching caused a regression under python3...
    
    Traceback (most recent call last):
      File "./test/data/python3/run_tests.py", line 25, in <module>
        import test.runner
      File "/home/atagar/Desktop/stem/test/data/python3/test/runner.py", line 51, in <module>
        import stem.connection
      File "/home/atagar/Desktop/stem/test/data/python3/stem/connection.py", line 109, in <module>
        import stem.control
      File "/home/atagar/Desktop/stem/test/data/python3/stem/control.py", line 145, in <module>
        import stem.descriptor.microdescriptor
      File "/home/atagar/Desktop/stem/test/data/python3/stem/descriptor/__init__.py", line 546, in <module>
        import stem.descriptor.server_descriptor
      File "/home/atagar/Desktop/stem/test/data/python3/stem/descriptor/server_descriptor.py", line 91, in <module>
        REJECT_ALL_POLICY = stem.exit_policy.ExitPolicy("reject *:*")
      File "/home/atagar/Desktop/stem/test/data/python3/stem/exit_policy.py", line 164, in __init__
        self._input_rules = zlib.compress(','.join(rules))
    TypeError: 'str' does not support the buffer interface

commit c10eef255f0948bcc3cd86eab4221e2b335615eb
Author: Damian Johnson <atagar@torproject.org>
Date:   Sat Oct 12 17:13:56 2013 -0700

    Fixing python 2.6 compatability issue with lru_cache
    
    The recepie is using set syntax only available in python 2.7 and above...
    
    Traceback (most recent call last):
      File "./run_tests.py", line 18, in <module>
        import stem.prereq
      File "/home/atagar/Desktop/stem/stem/__init__.py", line 420, in <module>
        import stem.util.enum
      File "/home/atagar/Desktop/stem/stem/util/enum.py", line 43, in <module>
        import stem.util.str_tools
      File "/home/atagar/Desktop/stem/stem/util/str_tools.py", line 21, in <module>
        import stem.prereq
      File "/home/atagar/Desktop/stem/stem/prereq.py", line 29, in <module>
        from stem.util.lru_cache import lru_cache
      File "/home/atagar/Desktop/stem/stem/util/lru_cache.py", line 37
        fasttypes = {int, str, frozenset, type(None)},
                        ^
    SyntaxError: invalid syntax

commit 242569af36ebb1f30a5d2629254b55320cfd5298
Author: Damian Johnson <atagar@torproject.org>
Date:   Sat Oct 12 13:11:11 2013 -0700

    Replacing manual caching with @lru_cache
    
    Replacing instances where we do...
    
    def get_stuff():
      if self._stuff is None:
        self._stuff = ... calculated stuff...
    
      return self._stuff
    
    ... with a @lru_cache().

commit 94b4924a3970fe3877b276ad2d07ccd149ed8d3a
Author: Damian Johnson <atagar@torproject.org>
Date:   Thu Oct 10 08:51:59 2013 -0700

    Revert "Chaching version comparison and hash function"
    
    Wow, shame on me for not even running unit tests. This causes version
    comparisons to infinitely recurse - hot.

commit e28032aebb14043c2149fe949ef49ddb82083c21
Author: Damian Johnson <atagar@torproject.org>
Date:   Wed Oct 9 08:55:00 2013 -0700

    Mocking pydocs referenced functionality we've removed

commit 281db911a5912836ceb63247b55d8f8300b639ec
Author: Damian Johnson <atagar@torproject.org>
Date:   Tue Oct 8 09:11:48 2013 -0700

    Chaching version comparison and hash function
    
    Versions are intended to be read-only objects, so we might as well add caching
    for these methods.

commit ba9799e20e8046ef1316616a3c665f8e4558665a
Merge: d1218e0 1920baf
Author: Damian Johnson <atagar@torproject.org>
Date:   Tue Oct 8 00:42:46 2013 -0700

    Reducing memory usage of descriptor content
    
    Handful of improvements to reduce the memory usage of stem's descriptor content
    (with a special focus on server descriptors). This drops memory usage by
    roughly 20% without having a sizable impact on runtime.
    
    Script used for testing:
    
      import resource
      import time
    
      from stem.descriptor import reader
    
      print "memory (initial): %s" % resource.getrusage(resource.RUSAGE_SELF).ru_maxrss
    
      start_time = time.time()
    
      with reader.DescriptorReader(['/home/atagar/.tor/cached-descriptors']) as descriptor_reader:
        server_descriptors = list(descriptor_reader)
    
      print "memory (after read): %s" % resource.getrusage(resource.RUSAGE_SELF).ru_maxrss
      print "read time: %0.2f seconds" % (time.time() - start_time)
    
    Before:
    
      % python scratch.py
      memory (initial): 7468
      memory (after read): 50572
      read time: 6.40 seconds
    
    After:
    
      % python scratch.py
      memory (initial): 7532
      memory (after read): 40816
      read time: 6.31 seconds

commit 1920baff1ad557a2a556dcb0cb46609f50f3cde1
Author: Damian Johnson <atagar@torproject.org>
Date:   Tue Oct 8 00:37:11 2013 -0700

    Compressing unparsed exit policy content
    
    Exit policies constitute a rather substantial chunch of server descriptors. We
    already optimize our runtime by lazily parsing policies on demand. On
    reflection though, we can improve our memory usage quite a bit too by
    compressing the unparsed content. This drops our memory usage by roughly 6%
    without impacting runtime.

commit 2ce003ef33c8693234f7dce562fdd3cff4e37e07
Author: Damian Johnson <atagar@torproject.org>
Date:   Tue Oct 8 00:15:51 2013 -0700

    Caching parsed tor versions
    
    Reusing parsed tor versions saves us an impressive 3.7% memory usage without
    any noticable impact on parsing times.

commit dbee38d1b95d943435cbb6bc989a9a5024b4e8e8
Author: Damian Johnson <atagar@torproject.org>
Date:   Mon Oct 7 23:09:04 2013 -0700

    Referencing a single reject-all policy
    
    Oddly, the only exit policy I can find with greater than five occurances is the
    reject-all policy. Maybe a scripting bug. Reguardless, referencing a single
    reject-all instance saves us a little memory (1.3 MB with the present
    consensus, which is 1.6%).

commit a0ce8664bc5758030c912456fcf2ff33a619373f
Author: Damian Johnson <atagar@torproject.org>
Date:   Mon Oct 7 22:11:44 2013 -0700

    Storing a single IPv6 default exit policy
    
    Each server descriptor constructed its own default value for the IPv6 exit
    policy, which was foolish. ExitPolicy instances are read-only instances, so all
    descriptors might as well use the same default. This saves roughly 2.3 MB of
    memory when downloading all of the current server descriptors (or roughly 3%).

commit 19cca3a04b9b02e94d22ebb877af3ca2ca9ad5e4
Author: Damian Johnson <atagar@torproject.org>
Date:   Mon Oct 7 21:14:00 2013 -0700

    Using @lru_cache for exit policies
    
    The ExitPolicy and ExitPolicyRule classes are a perfect fit for @lru_cache.
    They're read-only classes that already do a fair bit of caching. The annotation
    lets us avoid doing this ourselves.

commit d1218e00feeb1d4afc93a105b9a99d38a4ffa841
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Oct 6 23:15:05 2013 -0700

    Switching to the https endpoint of www.atagar.com
    
    Now that we have SSL support there's little reason to point to the http
    endpoint.

commit d9fbdc968479b0d413d1ff875ca19c855e7ce2ae
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Oct 6 17:32:10 2013 -0700

    Adding python 2.x backport of @lru_cache
    
    Python 3.2 added a memoization annotation to python's functools module. This is
    very, very handy, allowing us to avoid the caching boilerplate I do way too
    often...
    
      def get_foo():
        if self._foo is None:
          ... stuff to calculate self._foo...
    
        return self._foo
    
    With a memoization function this becomes...
    
      @lru_cache()
      def get_foo():
        ... stuff to calculate self._foo...
    
    This is a MIT licensed backport from...
    
      http://code.activestate.com/recipes/578078-py26-and-py30-backport-of-python-33s-lru-cache/
    
    Looking forward to when we require python 3.2 so we can use the builtin!

commit e60a033941c63885cb349d3bc181bbbf66227acf
Author: Damian Johnson <atagar@torproject.org>
Date:   Wed Oct 2 09:19:38 2013 -0700

    Tests can fail with TypeError when unable to start tor process
    
    Traceback (most recent call last):
      File "./run_tests.py", line 404, in <module>
        main()
      File "./run_tests.py", line 245, in main
        println(exc, ERROR)
      File "/home/atagar/Desktop/stem/test/output.py", line 59, in println
        msg = term.format(msg, *attr)
      File "/home/atagar/Desktop/stem/stem/util/term.py", line 96, in format
        return (CSI % ";".join(encodings)) + msg + RESET
    TypeError: cannot concatenate 'str' and 'UnsupportedOperation' objects

commit bcd849f0cbf3e5a823049dcea51f9158baf897b9
Author: Damian Johnson <atagar@torproject.org>
Date:   Wed Oct 2 07:32:11 2013 -0700

    Adding a hash method to our Version class
    
    Our Version class lacked a __hash__() method, causing it to behave
    unintuitively in dictionaries and sets...
    
      >>> from stem.version import Version
      >>> foo = set([Version('0.2.4.9-alpha')])
      >>> bar = set([Version('0.2.4.9-alpha')])
      >>> foo.difference(bar)
      set([<stem.version.Version object at 0xb71fae0c>])
    
    This is because python opts for the object's identity when a hash method does
    not exist.

commit a5f9e9cd5b4662bc5d34e19621fa9667cf71a07d
Author: Damian Johnson <atagar@torproject.org>
Date:   Mon Sep 30 14:39:29 2013 -0700

    Halo for windrose icon
    
    Adding a blue halo for the center of the windrose. This doesn't address the
    main thing I dislike about the icon, which is the pixelation of the black
    lines, but still it makes it look a bit nicer. I've tried several things to
    address the black line pixilation (blur, thickening, etc) but this is the best
    improvement I've yet found.

commit 4866bd336cd70eedcd00a685df26737fd7c37939
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Sep 29 20:07:33 2013 -0700

    Adding utilities tutorial to the menu
    
    Oops, forgot one of the spots we need to add new pages...

commit b0be16b7e93f56e6189cea6b0b991cded1db6a02
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Sep 29 20:01:16 2013 -0700

    Adding connection resolution tutorial
    
    Introducing a new tutorial section called 'East of the Sun & West of the Moon'
    (... I love that fairytale) that introduces users to our utility modules.
    Presently this just has connection resolution, a spiffy new feature I added
    last weekend.

commit ec24345427ac804640a425bbb900bf41aae3be83
Author: Damian Johnson <atagar@torproject.org>
Date:   Sat Sep 28 16:49:25 2013 -0700

    Linking to the DocTor repository
    
    Oops, our example page was still linking to my tor-utils repository rather than
    DocTor's.

commit 276fb65ef4dbf0536be91e3fcb1912363d5ada73
Author: Damian Johnson <atagar@torproject.org>
Date:   Mon Sep 23 12:03:25 2013 -0700

    Only report connection resolvers that are in our PATH
    
    Having get_system_resolvers() check that resolvers are in our PATH before
    returning them.

commit 7c0002d40db176d02c6a57e400ec53b5fb7a63a4
Author: Damian Johnson <atagar@torproject.org>
Date:   Mon Sep 23 00:28:01 2013 -0700

    Proc unit tests didn't reflect protocol addition
    
    Oops, our unit tests didn't account for proc now providing the protocol. Caught
    by our jenkins tests.

commit 1082349b59eb6ecd89eca1a1f2aa2ab1df007315
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Sep 22 23:38:17 2013 -0700

    Connection resolution support
    
    Adding long overdue support for process connection resolution...
    
    https://trac.torproject.org/7910
    
    This is a highly popular capability of arm, and stem's counterpart for it is
    quite a bit cleaner (with tests!). That said, this still doesn't get around
    tor's annoying DisableDebuggerAttachment feature which screws up proc
    permissions. That's something I'll need to figure out before our next arm or
    stem release...

commit 87b0d512e2b83a2dcced709e33128eaed10cc439
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Sep 22 12:25:00 2013 -0700

    Adding function for getting the system's resolvers
    
    Adding a get_system_resolvers() function that provides the connection resolvers
    that are likely to work on a given platform.

commit aee7de80db712ab1003eb6d8ac52e78d5f0f18cc
Author: Damian Johnson <atagar@torproject.org>
Date:   Sat Sep 21 17:46:02 2013 -0700

    Adding a is_private_address() function to stem.util.connection
    
    Helper function for determining if an IPv4 address belongs to a private range
    or not.

commit f40c912ecb8fdb542a7bd12e7a440e5301ea9798
Author: Damian Johnson <atagar@torproject.org>
Date:   Sat Sep 21 17:41:13 2013 -0700

    Adding a get_vote() method to the DescriptorDownloader
    
    Stem is frequently being used for answering questions concerning directory
    authorities, so adding a method to more intuitively get their votes.

commit 1d2fe8a218768eb5a1713cd2daa6d54df0d6c7ca
Author: Damian Johnson <atagar@torproject.org>
Date:   Sat Sep 21 12:05:25 2013 -0700

    Disable caching of HiddenServiceOptions
    
    Stem's controller has pretty straight forward caching for tor's configuration
    options. If you call 'GETCONF foo' then the value of foo is cached until you
    call either 'SETCONF foo' or 'RESETCONF foo'.
    
    In general this is all well and good, but HiddenServiceOptions behave in a
    different fashion. With those the caller might call 'SETCONF HiddenServiceDir'
    and expect 'GETCONF HiddenServiceOptions' to change. As such, opting out of
    caching hidden service options.
    
    This was a bug uncovered by wayzard on...
    
    http://stackoverflow.com/questions/18777837/tors-stem-module-python-loading-but-not-unloading-config
    https://trac.torproject.org/projects/tor/ticket/9792
    
    Prior to this fix...
    
    >>> from stem.control import Controller
    >>> controller = Controller.from_port()
    >>> controller.authenticate()
    >>> controller.get_conf_map('HiddenServiceOptions')
    {'HiddenServiceOptions': []}
    >>> controller.set_options([('HiddenServiceDir','/tmp/my_hidden_service'), ('HiddenServicePort', '1236 127.0.0.1:1236')])
    >>> controller.get_conf_map('HiddenServiceOptions')
    {'HiddenServiceOptions': []}
    
    Now it behaves as expected...
    
    >>> from stem.control import Controller
    >>> controller = Controller.from_port()
    >>> controller.authenticate()
    >>> controller.get_conf_map('HiddenServiceOptions')
    {'HiddenServiceOptions': []}
    >>> controller.set_options([('HiddenServiceDir','/tmp/my_hidden_service'), ('HiddenServicePort', '1236 127.0.0.1:1236')])
    >>> controller.get_conf_map('HiddenServiceOptions')
    {'HiddenServicePort': ['1236 127.0.0.1:1236'], 'HiddenServiceDir': ['/tmp/my_hidden_service']}

commit cfec958ddec6c1b104def1fdb40cacbb4e73b79d
Author: Damian Johnson <atagar@torproject.org>
Date:   Sat Sep 21 11:32:03 2013 -0700

    Adding default and constraints for Support022HiddenServices
    
    Reflecting constraints for a new param in network status documents...
    
    https://gitweb.torproject.org/torspec.git/commitdiff/6c974c5

commit e2cff0be96640b584fa1e7044878891ff4bb69b0
Author: Damian Johnson <atagar@torproject.org>
Date:   Sat Sep 14 17:25:09 2013 -0700

    Dropping config's _raw_contents reference
    
    On reflection we never do anything with the _raw_contents. In fact, we don't
    even have getter methods for it, and never use it within the Config class
    itself. Dropping it to both save a little memory and make it easier to purge
    values.

commit fb3907913b09770ed6de5ff8914553e424fa8f47
Author: Damian Johnson <atagar@torproject.org>
Date:   Sat Sep 14 13:53:33 2013 -0700

    Logging tor's output during integ test runs
    
    Saving tor's logging output to disk to help with troubleshooting issues.

commit 00b97f1d711d0d713d03a9ace72ba42cf0e3003e
Author: Damian Johnson <atagar@torproject.org>
Date:   Mon Sep 9 12:19:04 2013 -0700

    Changing 'DocTor' spelling
    
    Karsten has been pretty consistent about calling the project 'DocTor' rather
    than 'Doctor' so I should do the same.

commit 7679276642ddf3a64aa8473f2c6de68549aea6df
Author: Damian Johnson <atagar@torproject.org>
Date:   Mon Sep 9 12:16:21 2013 -0700

    Adding TorPS to examples page

commit 032df08a5591afaf810dabdbca9177fcc528a7ee
Author: Damian Johnson <atagar@torproject.org>
Date:   Mon Sep 2 13:16:00 2013 -0700

    Adding stem.util.system.get_name_by_pid()
    
    Function for getting the command running under a given pid. This is the inverse
    of get_pid_by_name().

commit 26dadd28e70efc5fac826b62bf4f4b35b7acadeb
Author: Damian Johnson <atagar@torproject.org>
Date:   Mon Sep 2 09:30:34 2013 -0700

    Replacing DIRECTORY_AUTHORITIES constant with get_authorities()
    
    On reflection a DIRECTORY_AUTHORITIES constant is not something I want to vend
    in our next stem release. That would make it tricky to be flexible about where
    we get that information. For instance, we might want to get this from tor
    itself (if that ever becomes an option), or possibly a config file rather than
    hardcoded dict.

commit e5bfee6dc5ec66f46560e2b9bae68340569e1d77
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Sep 1 16:24:48 2013 -0700

    Typo correction in tutorial
    
    Caught and fixed by irregulator.

commit ec0c7eb0c3b96fc50ddc117bd83f4f6477c13f4c
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Sep 1 11:52:21 2013 -0700

    Minor improvements for connection examples
    
    Changes include...
    
    * more conventional example using the 'with' keyword
    * disconnecting the controller afterward
    * corrected indentation

commit 53068b2f3066df1a01be5f13a3578263e21fac54
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Sep 1 10:23:49 2013 -0700

    FAQ entry for 'How do I connect to Tor?'
    
    While code reviewing ra's RTT Prober work I realized that our site didn't
    explain the various ways a user can get a Controller. Adding a FAQ entry with
    examples that explains it.

commit 3288f61da61932664c677619fe303d1d076dbe83
Author: Damian Johnson <atagar@torproject.org>
Date:   Fri Aug 30 14:14:22 2013 -0700

    Fixing case for new faq entry
    
    Oops, FAQ entry titles shouldn't be all caps.

commit fdd84baa1edd30cf11d47ad7b5d1c490024c2990
Author: Damian Johnson <atagar@torproject.org>
Date:   Fri Aug 30 10:34:00 2013 -0700

    FAQ entry for alternate tor controllers
    
    Entry for our FAQ linking to other controller libraries. This came out of the
    following tor-dev@ thread...
    
    https://lists.torproject.org/pipermail/tor-dev/2013-August/005340.html

commit e34b8c943a7e59ac8d8cbe9a77424b44e60e35d5
Author: Damian Johnson <atagar@torproject.org>
Date:   Fri Aug 30 08:58:36 2013 -0700

    Minor typo correction
    
    Little typo I spotted while answering...
    
    http://stackoverflow.com/questions/18372615/tors-stem-module-python-failing

commit a7ec700c1b366b5cd96ba894916ad0a6e6fa0b4c
Author: Damian Johnson <atagar@torproject.org>
Date:   Thu Aug 29 10:13:48 2013 -0700

    Explaining python's 'with' keyword
    
    We've had a couple stem newcomers that saw the 'with' keyword in our examples
    then misused it in their scripts. Adding a little tutorial on the keyword and
    the common mistake they've been making.

commit 303b4dfdac10ecb6c348dafbb08f27cae9799347
Author: Damian Johnson <atagar@torproject.org>
Date:   Tue Aug 27 22:37:56 2013 -0700

    Adding tor directory authority information
    
    To work our remote descriptor fetching module needed the addresses and dirports
    of voting authorities. However, on reflection it's useful if we reflect the
    rest of the authority information from tor's config.c as well. For instance,
    the v3ident is handy if our users want to query authority key certificates.

commit 847d2377846bf1a64881934e74c10193ec3fb130
Author: Damian Johnson <atagar@torproject.org>
Date:   Mon Aug 26 21:27:50 2013 -0700

    Using remote module for last descriptor tutorial
    
    Using the remote descriptor fetching module for the last descriptor tutorial
    rather than the controller. Also updating our unit tests for the tutorials.

commit d5c02be90b3a9d200773e4e128303bd4cee062a8
Author: Damian Johnson <atagar@torproject.org>
Date:   Mon Aug 26 09:22:50 2013 -0700

    Adding remote descriptor fetching to our tutorials
    
    Replacing the "Where can I get the current descriptors?" subsection with an
    example using the remote descriptor fetching module. This is the simplest way
    for our users to get descriptor data without the headache of piggybacking on a
    tor instance.

commit 0416b071d4f7b8518ed4e8d36c0afeb8b01e327f
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Aug 25 18:12:45 2013 -0700

    Adding doctor to examples page
    
    Swapping our 'Descriptor Monitors' sub-entry with an entry with Doctor.

commit f1e771a37828f85e3bd8631ad7234f50b0efac6e
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Aug 25 11:45:08 2013 -0700

    Support for TRANSPORT_LAUNCHED events
    
    Adding support for George's new TRANSPORT_LAUNCHED events...
    
    https://gitweb.torproject.org/torspec.git/commitdiff/48f6dd0

commit 4a84b47b6ebbd3a740884fd8e24f499b79582028
Author: Damian Johnson <atagar@torproject.org>
Date:   Sat Aug 24 10:57:59 2013 -0700

    Adding support for extrainfo descriptor's 'bridge-ip-transports'
    
    Support for a new bridge-specific extrainfo descriptor field...
    
      https://gitweb.torproject.org/torspec.git/commitdiff/a01bb8e8e
    
    These are pretty much identical to bridge-ip-versions lines. Like those this is
    part of the ExtraInfoDescriptor class rather than BridgeExtraInfoDescriptor
    because the spec doesn't prohibit its appearance in public relays (though it
    doesn't really make sense there).

commit c076038e82fcd5f5188ec7f889c9c9dc5d5eafd3
Author: Damian Johnson <atagar@torproject.org>
Date:   Sat Aug 24 10:45:14 2013 -0700

    Handling bridge-ip-versions as a general extrainfo field
    
    In commit 0d01ad6 I added support for the 'bridge-ip-versions' lines. These are
    only relevant to bridge descriptors, and ineed don't presently appear in the
    extrainfo consensus. However, that once could be said about the 'bridge-ips'
    field too.
    
    It's wrong for bridge attributes to appear on public relays, but there's
    nothing in the spec prohibiting it. Hence moving this attribute's handler to
    the common ExtraInfoDescriptor parent class.

commit 003bbd7e8f0ad01300d4b0365302b31a921da37c
Author: Damian Johnson <atagar@torproject.org>
Date:   Fri Aug 23 09:08:18 2013 -0700

    Assigning stem's copyright to the Tor Project
    
    Revising the copyright notices throughout stem so both the Tor Project and I
    have copyright. This has a couple advantages...
    
    1. If I get nailed by the bus or otherwise somehow disappear then I want the
       Tor Project to have copyright. This will make life easier for any future
       stem maintainer by allowing them to share code with our other (mostly BSD
       licensed) projects.
    
    2. Contributors are understandably antsy about giving copyright to an
       individual rather than an organization. Thus far I've been able to largely
       sidestep those concerns by asking for contributions to be in the public
       domain, but there was one occasion where that was a no-go...
    
       https://trac.torproject.org/projects/tor/ticket/7566
    
       Hopefully assigning copyright to the Tor Project is something that'll make
       everyone happy.
    
    I've contacted Sean and he's fine with assigning the copyright for his stem
    contrutions to the Tor Project...
    
      Yes, I am still interested in and willing to assign my existing and
      future contributions (unless I explicitly say otherwise) to Stem to
      the Tor Project.  If the previous sentence is not legally binding
      enough, let me know.
    
    Tweaked the FAQ entry a bit to reflect this change.

commit d092810bb9810f4dfeb244b71ae10bd6031b52b3
Author: Damian Johnson <atagar@torproject.org>
Date:   Thu Aug 22 09:30:22 2013 -0700

    Adding TorDNSEL docs to the site

commit d7833f31c392623f8dad5a30e7b16713cff510aa
Author: Damian Johnson <atagar@torproject.org>
Date:   Thu Aug 22 09:20:20 2013 -0700

    Minor formatting changes for DNSEL addition
    
    Nothing functional, just rearranging a few things to satisfy my OCD. :)

commit 4631228400e0cca43d8c7ba514c40cbcbf2bda34
Author: Arlo Breault <arlolra@gmail.com>
Date:   Mon Aug 19 22:49:40 2013 -0700

    Parse exit list entry.
    
    Published by DNSEL or TorBEL to indicate what ip address exit relay X
    had at timestamp Y.
    
    See #8255

commit 4863c2281c26660a249378e65354a00e406fffbc
Author: Damian Johnson <atagar@torproject.org>
Date:   Mon Aug 19 18:15:47 2013 -0700

    Validating that votes only have a single authority entry
    
    Vote documents should only contain an entry from the authority that issued it.
    I was checking this in my consensus-checker monitor but Karsten made the good
    point that the check belongs in stem.

commit bba4069fdf70d422e4d6f4cbd8a50c0be6747732
Author: Damian Johnson <atagar@torproject.org>
Date:   Sat Aug 17 12:48:49 2013 -0700

    Don't fail tests upon lingering thread
    
    The chief cause of our present jenkins failures are lingering threads...
    
    https://trac.torproject.org/projects/tor/ticket/8896
    
    This is certainly an problem. It indicates either a bug with stem closing
    threads, or that we aren't closing a controller in the tests. However, I'm
    tired of the false alarms from the jenkins tests, besides which this is a very
    minor issue.

commit 5be9904711cc7f15f438cad9456dfcc31309c73d
Author: Damian Johnson <atagar@torproject.org>
Date:   Fri Aug 16 08:41:45 2013 -0700

    Propagating additional descriptor keyword arguments
    
    Adding a 'kwargs' argument to all methods for fetching descriptors. This
    argument is passed along to the descriptor contructor. I just ran into a need
    for this because the NetworkStatusDocumentV3 class has a 'default_params'
    argument that I couldn't access through parse_file(). We'll likely be adding
    more constructor args in the future so this will help to make those... well,
    useful.

commit e9f23a1996356bef3edf22c143898c1f78498486
Author: Arlo Breault <arlolra@gmail.com>
Date:   Mon Aug 12 23:36:59 2013 -0700

    Typo in FAQ.

commit ced3c4883056c23fa43d3975850880841e1677c7
Author: Arlo Breault <arlolra@gmail.com>
Date:   Mon Aug 12 22:13:05 2013 -0700

    FetchDirInfoExtraEarly requires FetchDirInfoEarly.
    
    Tor complains,
    
    [warn] Failed to parse/validate config: FetchDirInfoExtraEarly requires
    that you also set FetchDirInfoEarly

commit bb3de90a82ff927c5005fbadce3b2ea975a15aae
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Aug 11 13:49:30 2013 -0700

    Dropping document_handler from get_consensus()
    
    Oops, the document_handler is already a query parameter. There's no benefit to
    having a default value for it in get_consensus(), and that had the drawback of
    preventing us from asserting a default value.

commit 4fc65393374ed32a9c67c11758b0c5b94ed6f5f5
Author: Damian Johnson <atagar@torproject.org>
Date:   Wed Aug 7 09:49:25 2013 -0700

    Issuing DNS lookups via tor in client usage example
    
    Suggestion from Julian to issue DNS lookups via tor. This is based on...
    
    http://www.talesofacoldadmin.com/2012/11/13/proxying-dns-with-python.html

commit e0956015a1589dba607dc41ffa486e20c00f863b
Author: Damian Johnson <atagar@torproject.org>
Date:   Wed Aug 7 09:09:14 2013 -0700

    Correcting definition of a 'dirty circuit'
    
    A circuit becomes 'dirty' once it has serviced traffic, not when it expires.
    Thanks to Roger for the terminology correction.

commit 0a79385a89fabd14721ce3fd0e4a49c63c1c13da
Author: Damian Johnson <atagar@torproject.org>
Date:   Wed Aug 7 09:00:21 2013 -0700

    Dropping routers attribute from get_network_status_document_v2()
    
    We only have a single test using this mocking module function. The 'routers'
    attribute was both unused and unimplemented so simply dropping it. We can
    implement it later if we add a test that needs it.

commit ccf03a04fcc160a2b87fd0361e7b4c31c562f1b1
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Aug 4 16:49:14 2013 -0700

    Additions for our examples page
    
    Adding Robert's RTT Prober and updating the entry for my descriptor monitors.

commit e78f1b74efac02ed09f963c65a652b87ea80f5f2
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Aug 4 16:25:09 2013 -0700

    Having get_server_descriptor() warn when using microdescriptors
    
    Tor presently gets microdescriptors rather than server descriptors by default.
    More than one person has been confused by this, so adding a warning to our
    Controller when server descriptors are unavailable...
    
    >>> controller.get_server_descriptor('9695DFC35FFEB861329B9F1AB04C46397020CE31')
    Traceback (most recent call last):
      File "<stdin>", line 1, in <module>
      File "stem/control.py", line 1207, in get_server_descriptor
        raise ValueError(SERVER_DESCRIPTORS_UNSUPPORTED)
    ValueError: Tor is presently not configured to retrieve server descriptors. As
    of Tor version 0.2.3.25 it downloads microdescriptors instead unless you set
    'UseMicrodescriptors 0' in your torrc.
    
    This was suggested by Robert in...
    
    https://lists.torproject.org/pipermail/tor-dev/2013-July/005196.html

commit e7c165ca7122a12fd5baade33221887176de3fe7
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Aug 4 12:04:22 2013 -0700

    Adding a 'content' attribute to the Query class
    
    Including a Query attribute so the caller can get our raw descriptor content.
    I'm actually doing this to simplify the run() method's usage. It had provided
    an iterator so...
    
      query = Query(my_resource)
      print list(query)  # this would print the ist of descriptors
      print list(query)  # this would be an empty list
    
    The reason the second call is an empty list is because we already iterated over
    the query. This is confusing, especially since...
    
      query = Query(my_resource)
      query.run(True)
      print list(query)  # also an empty list
    
    ... due to run() returning a list under the covers. By making run() provide a
    fresh iterator each time I also now had the downloaded content handy so making
    it public made sense (it'll commonly be wanted by our callers).

commit 5c5c59f1e7b16ed1f7a5131ec072e5646d086e44
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Aug 4 11:38:28 2013 -0700

    Adding a 'block' argument to the Query class
    
    I'm finding it to be pretty common to run...
    
      query = Query(my_resource)
    
      query.run(True)
    
      if not query.error:
        # do something
      else:
        # report error
    
    Adding an argument to the Query constructor so we can drop the following run().

commit faae224eb833d7612e2779e34d0f1010f8cb2d08
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Aug 4 11:31:05 2013 -0700

    Query's run() method didn't block
    
    Well, that was confusing as hell. Say you wrote the following script...
    
      query = stem.descriptor.remote.Query(
        '/tor/server/all.z',
        timeout = 60,
      )
    
      query.run(True)
    
      if not query.error:
        print "Results downloaded: %i" % len(list(query))
      else:
        print "Got an error: %s" % query.error
    
    You'd expect run() to block, right? You should - that's what it was documented
    as doing. Instead it returned an iterator and we don't block until the
    list(query) call. This means that we would *never* report an error. This has
    been causing stacktraces for my monitors every time it encountered an error.

commit cf0a4b2f7cff17ff6f819c91e35b2a86ffcb6a81
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Aug 4 11:21:22 2013 -0700

    Defaulting Query's fall_back_to_authority to False
    
    When a user opts to use the Query class direcly they're doing so to use
    specific endpoints. We'll probably cause more confusion then help by falling
    back to the authorities here. We'll still fall back by default in the
    downloader, though.
    
    This also includes a tweak so users can override the downloader's endpoints.

commit 539cd19919a3f5fe0e5ab39259441f736c1a8579
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Jul 28 13:34:23 2013 -0700

    Style correction for event listing tutorial
    
    Oops, minor PEP8 correction for one of our tutorial examples. Not sure why I
    did camel case for this function...

commit b7ecd5951f1b3c1f47f4249c4d4822c00aa041d0
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Jul 28 13:15:24 2013 -0700

    Adding a couple missing changelog entries
    
    Entries for the remote descriptor fetching module and frontpage UI overhaul.

commit 7e786104dc1704d8a378918de08474c23c1d47e0
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Jul 28 13:05:07 2013 -0700

    Using a red download icon
    
    I opted for ColorCons' 'smoke' colored download icon because I thought it would
    be more subtle. However, all the other section icons are pretty bright primary
    colors so that just made it stand out more. Opting for red so it'll match the
    bug tracker icon.
    
    Also very minor alignment adjustments for the changelog and tutorial icons.

commit 8d39e338bedc1e6c67338feff5176c697e4e08bd
Author: Damian Johnson <atagar@torproject.org>
Date:   Sat Jul 27 19:39:44 2013 -0700

    Replacing buttons for our frontpage
    
    As a few people have noted our present blue buttons on stem's frontpage looks
    pretty aweful. It clashes with the site's color scheme and is pretty
    in-your-face. Swapping to another color scheme that's hopefully less
    offensive...
    
    http://www.atagar.com/transfer/stem_frontpage/before.png
    http://www.atagar.com/transfer/stem_frontpage/after.png

commit 5eda329ed6a288575f61f26ac2a457299c2f9d04
Author: Damian Johnson <atagar@torproject.org>
Date:   Fri Jul 26 09:17:07 2013 -0700

    Inverted conditional for reporting bugs for password exceptions
    
    Issue caught by str4d while porting stem to I2P.

commit d7b68d01aabc6fdcd544a479cfa2cac377eaddeb
Author: Damian Johnson <atagar@torproject.org>
Date:   Fri Jul 26 08:13:58 2013 -0700

    Having use_directory_mirrors() return the consensus
    
    Originally I was planning an on-disk cache so calling get_consensus() after
    use_directory_mirrors() would result in an on-disk read. However, that has been
    put on hold for now so having use_directory_mirrors() return the consensus it
    fetches in order to get the mirrors.
    
    We unfortunately already need to read the full consensus into memory before
    processing it due to how urllib2 works, so this shouldn't cause a memory usage
    hit. We might someday want to change this though if we get a constant time
    download/parsing scheme.

commit 7f050ebfa475aeb39f6b1b4a0f7ad53620931646
Merge: b6c23b0 713b046
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Jul 21 18:39:17 2013 -0700

    Remote descriptor fetching module
    
    What started as a tor-dev@ thread has finally accumulated in a surprisingly
    simple module. This provides the ability to download tor descriptors from
    directory mirrors or authorities, and is made of up of two classes...
    
    * Query
    
      The core of the module. This is a request to download a given descriptor
      resource from a pool of authorities and/or mirrors. This retries failed
      requests and can be iterated over to get the descriptor results.
    
    * DescriptorDownloader
    
      A configurable class for issuing Queries. This provides only two things:
      simple methods to get common descriptor types, and an easy way of specifying
      default Query parameters.
    
    https://lists.torproject.org/pipermail/tor-dev/2013-May/004924.html
    https://trac.torproject.org/8257

commit 713b04632e6ca1120c6d5c2661206fd84c01904b
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Jul 21 18:37:48 2013 -0700

    Adding remote descriptor sphinx docs to site
    
    Tidying up our pydocs and including it in our site.

commit 4d122b1a417fe318f0bb3d169688d25f3e749754
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Jul 21 17:10:26 2013 -0700

    Implementing a get_key_certificates() method
    
    Method for fetching key certificates for the authorities. This included a
    little work so parse_file() could return multiple certificates when they're
    concatenated together.

commit e95e00dd6431001000a79e2bfc009a7f3abbde80
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Jul 21 16:31:00 2013 -0700

    Adding a query_args parameter to all downloader methods
    
    Simple tweak in case callers want to do something dynamic (such as varying the
    timeout with each request).

commit 6f12acc9e54842371f52203550a6ef2f9cbfb835
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Jul 21 16:25:58 2013 -0700

    Simplifying DescriptorDownloader class
    
    The DescriptorDownloader is a very, very simple class that simply issues
    Queries on your behalf. Why should it pretend to be anything else?
    
    Dropping most of its attributes (and with it a lot of copy-and-pasted pydocs).
    Also making the query() method public.

commit 90ec648ed075245f6ed2bae42dd4c6968e15fab1
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Jul 21 15:57:47 2013 -0700

    Support for compressed descriptors
    
    Ummm... well, that was easy. When I was initially looking into tor's directory
    responses I had trouble getting valid compressed results. Kostas suspected
    that the responses might have been truncated. Oh well, maybe a wget thing. In
    either case adding compression support to our module was trivial.

commit d5b3ec93f44de01b21b27264e761fe8f09ec8012
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Jul 21 10:45:56 2013 -0700

    Fixing "cannot unmarshal code" errors
    
    Damnit python, your import scheme is stupidly confusing.
    
    The descriptor's __init__ module has a circular dependency with its contents.
    This is because the parse_file() function calls the constituent modules, while
    those modules need the Descriptor class from __init__.
    
    So far so good. Only trouble is that python's support for circular dependencies
    sucks. To address this I did lazy imports in __init__, so we imported within
    the parse_file() function.
    
    On the surface this seemed to work. All the tests certainly passed. The trouble
    is that this style of python import is buggy as hell. Turns out that lazy
    imports leave the module in question in a unexecutable state so this *only*
    works if you've also imported the module another time during the interpretor
    execution. Our tests did this, hence passing tests.
    
    I first encuntered "cannot unmarshal code" while writing the remote descritpor
    tests (both unit and integ). I was content to hack around this with superfluous
    import statements while this only manifested within the tests, but now I'm
    seeing it during general usage too...
    
    >>> from stem.descriptor.remote import DescriptorDownloader
    >>> list(DescriptorDownloader().get_microdescriptors('jzcx+1fHsi47Tu+vQIcyItgn4lKs6aKnFshQ0lZ2JTg'))
    Traceback (most recent call last):
      File "<stdin>", line 1, in <module>
      File "stem/descriptor/remote.py", line 311, in __iter__
        for desc in self.run(True):
      File "stem/descriptor/remote.py", line 300, in run
        for desc in self._results:
      File "stem/descriptor/__init__.py", line 154, in parse_file
        import stem.descriptor.server_descriptor
    RuntimeError: cannot unmarshal code objects in restricted execution mode
    
    Joy. After much head scratching and forum reading it sounds like there's
    something magical about 'from' imports so switching the descriptor modules to
    that, and moving the __init__ imports to the end. I'm not entirely clear on the
    magic going on here, but its elmiminated the errors.

commit 60ad230d88b383a259c531649fdba78d0acd6493
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Jul 21 09:03:39 2013 -0700

    Expanding remote descriptor pydocs
    
    Adding documentation and examples for the remote descriptor API. This includes
    some minor API tweaks and a missing import statement.

commit 25951d4f12a16a1fa6e42ea6b7479959d636139b
Author: Damian Johnson <atagar@torproject.org>
Date:   Sat Jul 20 10:00:04 2013 -0700

    Making descriptor validation optional
    
    Adding a 'validate' argument that can be passed thorough when parsing
    descriptors.

commit 749c8d37fd54ea6e41dfca04495c35b47a755f6a
Author: Damian Johnson <atagar@torproject.org>
Date:   Sat Jul 20 09:52:07 2013 -0700

    Adding a broken get_microdescriptors() method
    
    Huh. Not really sure why this isn't working. Adding a get_microdescriptors()
    for how the spec seems to indicate that the method works but tor gives an empty
    reply.
    
    % curl http://217.13.197.5:9030/tor/micro/d/6dCl6ab8CLo0LeMjxi/MZgVJiZgWN8WKTesWPBMtyTo
    
    Checking with karsten on irc t see if he knows what's up, and moving on to
    another part.

commit 4005a88becb68858ec4742455ea4d80e1ff9f827
Author: Damian Johnson <atagar@torproject.org>
Date:   Fri Jul 19 10:12:39 2013 -0700

    Implementing a use_directory_mirrors() method
    
    Method so we can balance load against directory mirrors rather than hammering
    the authorities. We can either request this during construction (which fails
    silently) or call this method explicitly (to get the exception).

commit 5514b2cfd7d313f429bfe1bb8a13c975f7c3413f
Author: Damian Johnson <atagar@torproject.org>
Date:   Thu Jul 18 09:59:30 2013 -0700

    Implementing a get_consensus() method
    
    Originally this was gonna be a get_network_status(fingerprint) method but
    evedently we can't request individual router status entries. Understandable
    since signatures are for the whole document but still a bit of a pity from an
    API perspective. Oh well.

commit a014b9b967e8b825a9a4c99514ce2098ab6ba614
Author: Damian Johnson <atagar@torproject.org>
Date:   Wed Jul 17 09:58:35 2013 -0700

    Implementing get_extrainfo_descriptors() method
    
    Very similar to the get_server_descriptors() counterpart.

commit 871a957f23097807f67e502fd6e2c9a9b9a6c456
Author: Damian Johnson <atagar@torproject.org>
Date:   Tue Jul 16 09:28:18 2013 -0700

    Rejecting requests for more than 96 descriptors
    
    In our tor-dev@ discussion Karsten mentioned that we could request at most 96
    descriptors at a time when polling by their fingerprints...
    
    https://lists.torproject.org/pipermail/tor-dev/2013-June/005005.html
    
    I've emailed him to clarify where this limitation comes from (the url length or
    something within tor?), but in the meantime adding a check for this to our
    get_sever_descriptors() method.

commit ac694d3a98ce1e56c674893f8006efe785eb41c9
Author: Damian Johnson <atagar@torproject.org>
Date:   Tue Jul 16 09:16:06 2013 -0700

    Implementing get_server_descriptors() method
    
    Implementing our first downloader method and added an ONLINE integ test.
    Initially I did a get_microdescriptors() method but turns out that tor didn't
    implement what we need...
    
      https://trac.torproject.org/9271

commit 7d04653d908f0c62e197bafa27a5cd94634cbb53
Author: Damian Johnson <atagar@torproject.org>
Date:   Mon Jul 15 09:16:54 2013 -0700

    Moving retry functionality to Query class
    
    It's far better if the Query class handles retries rather than the
    DescriptorDownloader. Advantages include...
    
    * The DescriptorDownloader no longer has a reason to support blocking queries.
      There's no advantage to them since the Query knows if/when the request fails
      (and hence can retry it on our behalf).
    
    * The Query class is easier to test. The more functionality we can push down
      into it the simpler the DescriptorDownloader will be.
    
    * More advanced use cases will be using Query instances rather than
      DescriptorDownloader. By having retry functionality there it'll be easily
      available to them.

commit 0b1c13553f842088fd5f5ae21600d28e25e6b633
Author: Damian Johnson <atagar@torproject.org>
Date:   Mon Jul 15 08:43:41 2013 -0700

    Initial pass at the DescriptorDownloader
    
    Implementation of the DescriptorDownloader's _query() helper method which will
    be the basis of its other methods. On reflection I should move retry
    fruntionality and probably caching down to the Query class.

commit d87f35c7c0f99d52a530cdf12d03ef6abd9cadb0
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Jul 14 14:06:12 2013 -0700

    Performing integ test queries in parallel
    
    What good is designing an asynchronous descriptor fetching API if you poll
    things serially? Trivial tweak to reduce this test's runtime from 2.4s to
    0.4s.

commit dc6632b5afba37111b9b2d6fb0c316cca1d9e046
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Jul 14 11:44:57 2013 -0700

    Integ test to exercise each of the authorities
    
    Adding an integration test that fetches moria1's descriptor from each of the
    directory authorities. This obviously requires network activity so it's run via
    the ONLINE target.
    
    This uncovered a couple interesting finds...
    
    * This is our first time actually using urllib2 (it was mocked previously), and
      its 'file like object' is incomplete. It lacks tell() and seek() which means
      that our parsers don't have random access. As such we need to read this all
      into memory and use a BytesIO.... damn.
    
    * The moria1 authority has an extra newline in its descriptor content. Why?
      Haven't a clue. Maybe it's running a different version of tor or maybe this
      is an artifact of fetching its own descriptor. Whatever it is, it's the only
      authority to do so. Simply stripping the content to avoid having our parser
      complain about this.

commit 61f00819dc3f18b17af0d8d9d3f4f90791364e39
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Jul 14 11:07:40 2013 -0700

    Dropping Tonga from remote descriptor fetching
    
    Karsten reports that we shouldn't use authorities that lack 'v3ident'. At
    present that's just Tonga.

commit 762b7239e4866ba1b98212259e9751723e0865df
Author: Damian Johnson <atagar@torproject.org>
Date:   Sat Jul 6 10:54:58 2013 -0700

    Workaround for screwy RuntimeError related to mock causing imports
    
    The following isn't used by this directly, but we're still importing it due
    to a screwy aspect of how mock works. If patched() results in an import that
    we haven't done before then we can fail with...
    
      ======================================================================
      ERROR: test_query_download
      ----------------------------------------------------------------------
      Traceback (most recent call last):
        File "/usr/local/lib/python2.7/dist-packages/mock.py", line 1201, in patched
          return func(*args, **keywargs)
        ...
        File "/home/atagar/Desktop/stem/stem/descriptor/__init__.py", line 156, in parse_file
          import stem.descriptor.networkstatus
      RuntimeError: cannot unmarshal code objects in restricted execution mode
    
    I've only seen this arise when running this test directly (without the rest
    of the unit tests, some of which import networkstatus on their own).

commit 762f0ad396dd752f0f807871e0715c142cdbf475
Author: Damian Johnson <atagar@torproject.org>
Date:   Fri Jul 5 19:18:02 2013 -0700

    Class for issuing remote descriptor queries
    
    Adding a Query class which does most of the heavy lifting for downloading
    descriptors.

commit 65924aff93ef70c879175510e9cd2307e8507a9e
Author: Damian Johnson <atagar@torproject.org>
Date:   Thu Jun 20 08:57:36 2013 -0700

    Stub for a remote descriptor fetching module
    
    Starting a module for remote descriptor fetching. Presently this just includes
    a no-op DescriptorDownloader class. Guts of this sucker are coming soon!

commit b6c23b0c2934b6c1b1c51530754cc48f6ef4e38e
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Jul 7 13:35:50 2013 -0700

    Typo in descriptor reader pydocs
    
    Correction from Roger. Honestly I had to look this one up. Both 'run' and 'ran'
    sound right when I read them to myself. Oh well, grammar is most certainly not
    my strong suit.

commit 5cd89263f0acc5a7b6fcdd4021efa09a4f1634ab
Author: Damian Johnson <atagar@torproject.org>
Date:   Thu Jul 4 13:41:22 2013 -0700

    Pyflakes and PEP8 corrections
    
    After upgrading both they each complained about a few new things. Mostly
    pyflakes getting confused by pydoc comments, but there were a couple fair
    catches.

commit d0ce002d568627876c59c3ff23d6d86fbb049aa9
Author: Damian Johnson <atagar@torproject.org>
Date:   Thu Jul 4 13:34:56 2013 -0700

    Checking for testing prereq of mock 0.8.0
    
    We had a requirement on mock 0.7.0 but it turns out that we're using a 0.8.0
    feature too. Spotted this while trying to use ubuntu jaunty's apt-get
    version...
    
    Traceback (most recent call last):
      File "./run_tests.py", line 405, in <module>
        main()
      File "./run_tests.py", line 184, in main
        for test_class in test.util.get_unit_tests(args.test_prefix):
      File "/home/atagar/Desktop/stem/test/util.py", line 130, in _get_tests
        module = __import__(module_name)
      File "/home/atagar/Desktop/stem/test/unit/tutorial.py", line 23, in <module>
        class TestTutorial(unittest.TestCase):
      File "/home/atagar/Desktop/stem/test/unit/tutorial.py", line 24, in TestTutorial
        @patch('sys.stdout', new_callable = StringIO.StringIO)
    TypeError: patch() got an unexpected keyword argument 'new_callable'

commit 8662332c844827b2be4ab7ab1c77027738e5723d
Author: David Triendl <david@triendl.name>
Date:   Sat Jun 22 09:03:50 2013 +0200

    Fix parsing of IPv6 address:port pairs in stream events (fixes #9181)

commit 00d78f244bda322f30ecb5d31f3278eeeaa96056
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Jun 30 10:46:11 2013 -0700

    Adding Slackware to our download page
    
    Markus just added stem to slackbuilds (hazaa!)...
    
    http://slackbuilds.org/repository/14.0/python/stem/

commit 003fa8e9e4b38304ccbb28e75a3f646ab6ba1ab2
Author: Damian Johnson <atagar@torproject.org>
Date:   Tue Jun 25 08:57:42 2013 -0700

    Switching get_network_status() to provide v3 entries
    
    Turns out 'GETINFO ns/*' provides v3 directory information rather than the v2
    documented in the spec. Now that the spec is fixed swapping us over to take
    advantage of it...
    
    https://trac.torproject.org/7953
    https://gitweb.torproject.org/torspec.git/commitdiff/d2b7ebb
    
    RouterStatusEntryV3 provides a superset of the attributes of
    RouterStatusEntryV2 so backward compatability shouldn't be a concern.

commit 5f65f786dee22089323febc899bf2c85a53c99aa
Author: Damian Johnson <atagar@torproject.org>
Date:   Mon Jun 24 09:23:16 2013 -0700

    Clarifying why test's load_conf() expects an exception
    
    For a long while I've been puzzled why this load_conf() call asserted an
    exception. When I ran it in a cusom prompt it ran fine - turned out that it was
    relying on us having a custom DataDir. Tor balks (rightfully) when we'd shift
    our DataDir out from a running tor instance.
    
    Doing a better job explaining what's up in the comment.

commit 042fcfce009e5abc86f066c8ef0788cef871998f
Author: Damian Johnson <atagar@torproject.org>
Date:   Fri Jun 21 09:27:45 2013 -0700

    Test runner tried to use non-existant print_error() function
    
    In commit e751397 we removed the test.output.print_error() function in favor of
    something less verbose. Somehow we missed its usage in test.runner - weird that
    pyflakes didn't catch this...
    
    Traceback (most recent call last):
      File "./run_tests.py", line 405, in <module>
        main()
      File "./run_tests.py", line 212, in main
        integ_runner.start(target, args.attribute_targets, args.tor_path, extra_torrc_opts = test.util.get_torrc_entries(target))
      File "/home/atagar/Desktop/stem/test/runner.py", line 310, in start
        self._start_tor(tor_cmd)
      File "/home/atagar/Desktop/stem/test/runner.py", line 718, in _start_tor
        test.output.print_error("  failed to start tor: %s\n" % exc)
    AttributeError: 'module' object has no attribute 'print_error'
    
    Also, the runner had a couple calls of...
    
    test.runner.get_runner()
    
    Those should obviously just be 'get_runner()', and only worked because of our
    test.output import (damn python's transitive imports are stupidly confusing).

commit 456bc64f2fbd41918dd2db711eaf259a90f200e3
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Jun 16 14:44:30 2013 -0700

    FAQ entry about how to reload your torrc

commit d921dfdfe2f085cd7de986ed16956b2a7361e32a
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Jun 16 12:50:50 2013 -0700

    Renaming FAQ categories
    
    Trivial change to rename 'Usage' to 'General Information', and 'Tasks' to
    'Usage'.

commit e8a278cfed828be68d83486deefbff86fb548b0d
Author: Damian Johnson <atagar@torproject.org>
Date:   Sat Jun 15 20:40:01 2013 -0700

    FAQ entry about how to get information about your present exits
    
    Answer for a question I like on Stack Overflow...
    
    http://stackoverflow.com/questions/9777192/how-do-i-get-the-tor-exit-node-ip-address-over-the-control-port

commit 69ff2a6eec5b99a7b13a57f09de2e2abbd87b91d
Author: Damian Johnson <atagar@torproject.org>
Date:   Sat Jun 15 19:26:15 2013 -0700

    FAQ entry for how to request a new tor identity
    
    A common question on Stack Overflow reguarding tor goes along the lines of 'how
    do I get a new identity?'. For instance...
    
    http://stackoverflow.com/questions/17013707/how-can-i-change-my-tor-process-endpoint-in-stem
    http://stackoverflow.com/questions/16987518/how-to-request-new-tor-identity-in-terminal
    
    Tor doesn't support cycling your IP, so adding a FAQ entry explaining why and
    telling them how NEWNYM works.

commit 792557ccdb475cdd95be09b71a69d38f7770b3c7
Author: Damian Johnson <atagar@torproject.org>
Date:   Sat Jun 15 15:45:02 2013 -0700

    Requiring mock version 0.7.0 or later
    
    Our jenkins tests presently have mock version 0.6.0, but we're using mock's
    patch.dict which was introduced in 0.7.0. This causes the tests to fail with...
    
    Traceback (most recent call last):
      File "./run_tests.py", line 394, in <module>
        main()
      File "./run_tests.py", line 173, in main
        for test_class in test.util.get_unit_tests(args.test_prefix):
      File "/srv/jenkins-workspace/workspace/stem-tor-ci/test/util.py", line 130, in _get_tests
        module = __import__(module_name)
      File "/srv/jenkins-workspace/workspace/stem-tor-ci/test/unit/version.py", line 20, in <module>
        class TestVersion(unittest.TestCase):
      File "/srv/jenkins-workspace/workspace/stem-tor-ci/test/unit/version.py", line 22, in TestVersion
        @patch.dict(stem.version.VERSION_CACHE)
    
    Making run_tests.py balk if we're using a version of mock prior to 0.7.0.

commit a5dc68b06d049df62f29f308f2029bdbd4521507
Author: Damian Johnson <atagar@torproject.org>
Date:   Sat Jun 15 15:16:28 2013 -0700

    Warning that the twitter example is broken
    
    Twitter has deprecated the 1.0 version of their API, which we used on...
    
    https://stem.torproject.org/tutorials/to_russia_with_love.html#reading-twitter
    
    Warning our users about this. The issue is being tracked on...
    
    https://trac.torproject.org/9003

commit 101cf0b71bab55d72a831eff0236dcef5edbff0f
Merge: 65846e8 2b634a9
Author: Damian Johnson <atagar@torproject.org>
Date:   Thu Jun 13 09:48:30 2013 -0700

    Migrating to the mock library
    
    Our homemade mocking framework has served us well, but over time it's taught me
    one very important lesson: writing a mocking framework is hard. On the surface
    it seems pretty simple: apply and revert a set of monkey patches. But how do
    you monkey patch class methods? What about alias imports like the os module?
    And god forbid you want to mock python's open() function.
    
    I'm finally taking a lesson from one of my coworkers and using a library for
    this. Python has several options but the most common is PyPI's mock module,
    which became part of the standard library in Python 3.3...
    
    http://www.voidspace.org.uk/python/mock/

commit 2b634a98e16c3b2437cab27c7198acd6a738fd13
Author: Damian Johnson <atagar@torproject.org>
Date:   Thu Jun 13 09:30:07 2013 -0700

    Accounting for GetInfoResponse entries having bytes
    
    Oops. I forgot to update this test when we switched the entries attribute to
    bytes in commit a94f1f0.

commit c7ac81546dcdf1fb9639fdbf0e4997e8ee39ba38
Author: Damian Johnson <atagar@torproject.org>
Date:   Wed Jun 12 21:59:41 2013 -0700

    Python3 mock compatability
    
    Ahhh, more unicode vs bytes joy.

commit 35b44e3c7d5090806922cd0775775bb2985f8a9b
Author: Damian Johnson <atagar@torproject.org>
Date:   Wed Jun 12 21:48:44 2013 -0700

    Dropping homemade mocking functions
    
    Done replacing our mocking methods with the mock module. It's nice to finally
    be able to drop these...

commit da365bc6ea5312d467c33f14942695c66c6f4e10
Author: Damian Johnson <atagar@torproject.org>
Date:   Wed Jun 12 21:39:25 2013 -0700

    Using mock for system integ tests
    
    Unfortunately I'm not spotting a nice method via the mock module to get the
    original function. The patch() function has a get_original() method which looks
    promissing, but I didn't spot a method for accessing it. Oh well...

commit f38959c05a5dbedcf4a90ed5fc6c1f9809ca5d62
Author: Damian Johnson <atagar@torproject.org>
Date:   Wed Jun 12 19:53:35 2013 -0700

    Using mock for protocolinfo integ tests

commit 98fd433b09c2449e5ea6dc6d381e729ba32a6099
Author: Damian Johnson <atagar@torproject.org>
Date:   Wed Jun 12 19:44:34 2013 -0700

    Dropping mock from server descriptor integ test
    
    Well, that's odd. We revert mocking in these integ tests but never use it. Oh
    well.

commit 21cd260745a1b824c908e3eacac4083fe16750a6
Author: Damian Johnson <atagar@torproject.org>
Date:   Wed Jun 12 19:42:48 2013 -0700

    Dropping mock from descriptor reader integ test
    
    I was gonna migrate this call over but it looks to be unneeded. Test passes so
    guess we probably replaced the problematic descriptor content with a real
    descriptor.

commit 625472df56748195c5b0474209278dd57a66c338
Author: Damian Johnson <atagar@torproject.org>
Date:   Wed Jun 12 19:38:11 2013 -0700

    Using mock for process integ tests

commit 752a957698550afc112ded236e3a7cceea500245
Author: Damian Johnson <atagar@torproject.org>
Date:   Wed Jun 12 19:29:23 2013 -0700

    Using mock for descriptor export unit tests

commit 320d3ba383ab32ec4cecfc4158e9c7336df11c1e
Author: Damian Johnson <atagar@torproject.org>
Date:   Wed Jun 12 19:26:06 2013 -0700

    Using mock for server descriptor unit tests

commit 6c0af9db6169b7edb4eeb83f3555b9e5d6cc2d6e
Author: Damian Johnson <atagar@torproject.org>
Date:   Wed Jun 12 09:32:37 2013 -0700

    Using mock for descriptor reader unit tests
    
    We get to replace some icky open() mocks. Yay!

commit 33eeb9bbcc4a877d02f227d9f9b76a4631f3053e
Author: Damian Johnson <atagar@torproject.org>
Date:   Wed Jun 12 09:14:43 2013 -0700

    Using mock for system unit tests
    
    Pretty much a drop-in replacement for these.

commit 298a08c4b5488bf756c4dbce75ee0ebf4eeb2b0b
Author: Damian Johnson <atagar@torproject.org>
Date:   Tue Jun 11 09:27:08 2013 -0700

    Dropping tempfile usage from controller unit test
    
    Now that I have a better understanding of the magic behind mocking open,
    there's no need for us to make a temporary file in our unit tests.

commit 8e90c1029e650536cf07ee42ddeb06300f0aa002
Author: Damian Johnson <atagar@torproject.org>
Date:   Tue Jun 11 09:09:05 2013 -0700

    Using mock for proc unit tests
    
    Now that I have a rough understanding of the open mock it's quite a bit nicer
    than our prior version (which got especially icky for python 3 compatability).

commit 8303c8d99ac6728367dabec3f6b2c9e43bb68c69
Author: Damian Johnson <atagar@torproject.org>
Date:   Tue Jun 11 08:43:05 2013 -0700

    Using mock for controller unit tests
    
    Another heavy mock user. Nice improvements, I'm really liking this library!

commit 5089ded80aaa4fd5bc260c2b7fb5bf03e69b2133
Author: Damian Johnson <atagar@torproject.org>
Date:   Mon Jun 10 08:50:44 2013 -0700

    Using mock for protocolinfo unit tests
    
    Oooh, I like this change.

commit f79278eec35de5520158923563256c45aa00f066
Author: Damian Johnson <atagar@torproject.org>
Date:   Mon Jun 10 08:42:16 2013 -0700

    Using mock for event unit tests
    
    We don't really need a mock in this test, guess we do so to be more faithful to
    the example.

commit 1007a0a2d1963f350444c3b762cab6be8bda6eda
Author: Damian Johnson <atagar@torproject.org>
Date:   Mon Jun 10 08:30:16 2013 -0700

    Using mock for authentication unit tests
    
    Mostly sorting out another thorny test that exhaustively exercises all
    authentication use cases.

commit 9c0f1d37c0febbaacd2b6b73a2d094d3583869ba
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Jun 9 18:20:49 2013 -0700

    Using mock for tutorial unit tests
    
    The unit tests for our tutorials are some of the ugliest we have since they
    make heavy use of mocks. Hence a good next step for mock.
    
    The mock module makes the controller mocking considerably nicer. That said,
    mock's open() mocking is crap. Their mock_open() docs...
    
    http://www.voidspace.org.uk/python/mock/helpers.html#mock.mock_open
    
    Tripped me up for well over an hour because their examples are hardcoded for
    the __main__ namespace (so it works when I do it in an interpretor, but not the
    tests). Even with that fixed the mock object it returns is buggy as hell (it's
    documented as supporting readlines() but that's a lie). They'd get a lot more
    mileage if they used an io.BytesIO instead.

commit e50a62fd56aec4f5b9f96bf0828338356cc903e9
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Jun 9 14:28:43 2013 -0700

    Using mock for tutorial unit test stdout
    
    Mock's patch() docs include an example for mocking stdout. Using it for our
    tutorial unit tests...
    
    http://www.voidspace.org.uk/python/mock/patch.html#mock.patch

commit 9109b6c078496c56b8ba1b85b0932b405be7d953
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Jun 9 14:10:01 2013 -0700

    Using mock for version unit tests
    
    First replacement of our mocking module with mock. This is actually both quite
    a bit cleaner, and also checks that our caching is working.

commit 606ccfbb5001d5a13bce8b7a51cea283c074f3c1
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Jun 9 12:14:56 2013 -0700

    Adding the mock module as a test dependency
    
    Mocking is hard. We've gotten a lot of mileage by writing our own mocking
    helpers, but they're clunky and complicated. It's about time for us to use a
    more standard, mature option.
    
    The pypi mock module is not only well documented, but looks to be the direction
    the python world is going. As of python 3.3 it's now part of the standard
    library.
    
    As the first step of swapping us over I'm adding it as a dependency for
    run_tests.py. This warns the user if it's unavailable...
    
      atagar@morrigan:~/Desktop/stem$ ./run_tests.py --unit
      To run stem's tests you'll need mock...
    
      https://pypi.python.org/pypi/mock/
    
      You can get it by running 'sudo pip install mock'.

commit 65846e81628040779e4d28041d1400f53719468c
Author: Damian Johnson <atagar@torproject.org>
Date:   Sat Jun 8 13:22:12 2013 -0700

    Correcting Controller pydoc links
    
    Handful of mistakes in the stem.control module that prevented sphinx's internal
    linking. Pity sphinx doesn't provide warnings about this...

commit 2257f7954a0d9dba46905a4813b828fcc0b52086
Author: Damian Johnson <atagar@torproject.org>
Date:   Thu May 30 08:43:10 2013 -0700

    Minor fixes for ONLINE testing fixes
    
    Just some minor tweaks to fix the style checker and s/range()/xrange().

commit b5273658f6470a643b70b7ef96654248788eef2f
Author: Jeremy <saturn5971@gmail.com>
Date:   Wed May 29 23:53:11 2013 -0400

    Made attachstream and mapaddress tests more robust
    
    Modified the attachstream and mapaddress integ tests so that they don't
    fail as easily in the face of minor network failures unrelated to stem
    (like temporary issues building a circuit, or an exit node having a
    different IP from the one Tor reports).
    
    This is to address...
    
    https://trac.torproject.org/8692

commit d7d14a82e7d28ff863c71b4b027c9922e17a6661
Author: Damian Johnson <atagar@torproject.org>
Date:   Wed May 29 20:44:23 2013 -0700

    Methods to query user tor is running as
    
    Couple additions to make it easier to determine the user tor is running as:
    
    * stem.util.system.get_user(pid) => determines the user a process is running as
    * Controller.get_user() => provides the user that tor is running as

commit f5bdd944df426410fe6b21088280cf3779709ed1
Author: Damian Johnson <atagar@torproject.org>
Date:   Wed May 29 08:53:12 2013 -0700

    Checking is_caching_enabled() when using cache
    
    Adding a is_caching_enabled() call to our getter/setter for the Controller's
    cache. This has a couple advantages...
    
    * It prevents us from accidently caching stuff when the cache should be
      disabled. In at least one point we were using the cache without checking
      is_caching_enabled(), which was probably an error.
    
    * Lets us simplify our code a bit by making is_caching_enabled() optional for
      the cache getter/setter callers.

commit 341091492edf7c060609b73b8619b18eda322ebd
Author: Damian Johnson <atagar@torproject.org>
Date:   Wed May 29 08:44:44 2013 -0700

    Supporting get_pid() remotely via GETINFO
    
    One of get_pid()'s resolution methods (GETINFO process/pid) works remotely, so
    attempting it before checking that tor is running locally.

commit 31456707624847f8b0404b2e84ebcc2dc7fe22fd
Author: Damian Johnson <atagar@torproject.org>
Date:   Wed May 29 08:19:54 2013 -0700

    System module's call() function ignored exit statuses
    
    Well... oops. Our call() method was documented as raising an OSError (or
    returning the default value) when the call fails but it completely ignored the
    exit status. In practice the function only behaved as documented when Popen
    failed - otherwise it returned an empty list. Fixing this behavior and updating
    most of our callers since they expected call() to not raise any exceptions.

commit 18aa77f4d6074e54db84f93e630aaacd5e3fbcb3
Author: Damian Johnson <atagar@torproject.org>
Date:   Tue May 28 17:32:11 2013 -0700

    System utility for getting FreeBSD jail paths
    
    Adding a util to better support FreeBSD jails (a rather common way to run tor
    on that platform).

commit 24d9377cdc2d1ee3531238b825621934053bae9f
Author: Damian Johnson <atagar@torproject.org>
Date:   Tue May 28 09:32:13 2013 -0700

    System utility for getting process start times
    
    Adding a get_start_time() to the system utils to provide the unix timestamp for
    when a given pid started.

commit 292ef5c36e38dd2820ed00e34ab270f2bb28ecb6
Author: Damian Johnson <atagar@torproject.org>
Date:   Mon May 27 21:28:55 2013 -0700

    Performing pid resolion via getinfo when able
    
    Oops, forgot that I had added a 'GETINFO process/pid' option to tor for just
    this case. Using it when it's available.

commit 0f7d5d118d83db000dd57b646ba91d4152c44e91
Author: Damian Johnson <atagar@torproject.org>
Date:   Mon May 27 21:20:42 2013 -0700

    Controller method to query tor's pid
    
    Adding a get_pid() method to the controller to make it simpler to figure out
    its pid. This attempts resolution via the PidFile, process name, control port,
    and control socket file.

commit 0efbdf80f94574805b0fa080965bb509d535a4db
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun May 26 21:27:43 2013 -0700

    Allowing ControlMessage.from_str() to include conversion
    
    For txtorcon or anything else using our ControlMessage.from_str() function the
    following is very, very common...
    
    msg = stem.response.ControlMessage.from_str(getinfo_content)
    stem.response.convert("GETINFO", msg)
    
    Adding a 'msg_type' argument to from_str() so the two calls can be combined.
    This addresses...
    
    https://trac.torproject.org/8605

commit 7b396bdcebe7165df6ea6aaa911707e74974fa38
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun May 26 18:14:15 2013 -0700

    Dropping validation on bandwidth-weights contents
    
    Our validation of network status documents included checking for the
    bandwidth-weights specified in the spec. This is because, according to the
    spec, they were all mandatory and new weights could not be added. Tor has
    loosened this restriction...
    
    https://gitweb.torproject.org/torspec.git/commitdiff/ec3eaca
    https://trac.torproject.org/6872

commit 08c4d273c67e1bb4d273ba5de188703d27a0568c
Author: Damian Johnson <atagar@torproject.org>
Date:   Sat May 25 20:57:12 2013 -0700

    Noting additions in the change log
    
    Adding items from our commit history I forgot to include with the change log
    earlier.

commit 03f4313b04285745f0c46cd83ac26fcc57bf0a6f
Author: Damian Johnson <atagar@torproject.org>
Date:   Sat May 25 20:26:11 2013 -0700

    Adding Ubuntu to the download page
    
    Stem is now on Launchpad, evidently pulled from Debian for the Saucy Salamander
    release of Ubuntu.

commit ad82c905347f3e5849930fdb3e63721b294d38b4
Author: Damian Johnson <atagar@torproject.org>
Date:   Tue May 21 21:30:49 2013 -0700

    Processing controller descriptors as bytes
    
    When descriptor content was fetched by the Controller it was first converted to
    unicode, then back into bytes. As a result descriptors with content that
    couldn't be converted (usually on the contact line) got mangled, and this in
    turn caused our check of its signature to fail.
    
    Caught thanks to aj00200 on...
    
    https://trac.torproject.org/8755

commit a94f1f0a51faacf1fda5350cdfd489d45b41adc4
Author: Damian Johnson <atagar@torproject.org>
Date:   Mon May 20 09:35:45 2013 -0700

    Support for getting byte content from get_info
    
    Adding an optional flag to get byte content from get_info rather than a str.
    This only effects python 3.x.

commit 0362564cc8e1d48ebf7b61c75550fa9e1c4fd321
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun May 19 17:29:43 2013 -0700

    Normalize ControlMessage content to be bytes
    
    The socket module's recv_message function converted read content to be a str
    (bytes in python 2.x and unicode in python 3.x). In 99.9% of the cases this is
    exactly what we want, but in a few edge cases we actually want byte content
    under python 3.x.
    
    For instance, in #8755 descriptors with non-unicode contact lines are being
    altered by the socket module, causing our validation of their signature to
    fail.
    
    Functionally this commit should have no effect besides adding the option to get
    byte content from the ControlMessage. The tests seem happy so fingers crossed!

commit 525f2f9cee559fb8b77cb8daf46c68737487c63b
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun May 19 14:59:41 2013 -0700

    Using a real descriptor for test_non_ascii_descriptor
    
    Our test_non_ascii_descriptor test used an altered descriptor with katakana
    (Japanese characters) in its contact line. When we use doctored descriptors we
    can no longer exercise _validate_content since the signature won't match.
    Replacing the example descriptor with the one that's causing issues in #8755.

commit ba50df27f2b69e05ce3470c4c1127974420a93bc
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun May 19 14:11:39 2013 -0700

    Mocking's sign_descriptor_content() incompatible with python 3.x
    
    I didn't have a python 3.x copy of pycrypto installed, so there were some code
    paths I didn't previously encounter. Unit tests failed due to
    sign_descriptor_content() not explicitly using bytes at several points.
    
    ======================================================================
    ERROR: test_mirror_mirror_on_the_wall_4
    ----------------------------------------------------------------------
    Traceback:
      File "/home/atagar/Desktop/stem/test/data/python3/test/unit/tutorial.py", line 169, in test_mirror_mirror_on_the_wall_4
        exit_descriptor = mocking.sign_descriptor_content(exit_descriptor)
      File "/home/atagar/Desktop/stem/test/data/python3/test/mocking.py", line 984, in sign_descriptor_content
        public_key_string = public_key_string[:64] + "\n" + public_key_string[64:128] + "\n" + public_key_string[128:]
    TypeError: can't concat bytes to str
    
    ----------------------------------------------------------------------

commit b816137fc07d139808dd80a410eba04fd662fdba
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun May 19 12:52:30 2013 -0700

    Minor simplifications for dependency module
    
    When we dropped python 2.5 support our _check_version() only had a single
    caller, making it not a very helpful helper. We were also missing pydocs for
    is_crypto_available().

commit b626f0c5156e8f5d2a89558ce54890b931648758
Author: Jeremy <saturn5971@gmail.com>
Date:   Sat May 18 22:08:57 2013 -0400

    Revise approach to owning Tor in integ tests
    
    The integ tests now only try to own the Tor process via control
    connection if controllers have a way to access Tor. This is needed to
    successfully run under the RUN_NONE target.

commit 29086a71cd508614d247f70888df884028d51185
Author: Jeremy <saturn5971@gmail.com>
Date:   Thu May 16 23:23:35 2013 -0400

    Asserting ownership over the integ tests
    
    Ticket #8634. Integ tests now assert ownership over the tor process, but avoid
    accidentally terminating tor mid-test.

commit 13dc7861ae7bfa280fda8536ca39fcf6135d7b56
Author: Damian Johnson <atagar@torproject.org>
Date:   Thu May 16 09:20:11 2013 -0700

    Integ tests resulted in temporary directories
    
    Our integ test runner created temporary directories for our control socket but
    failed to clean them up. On reflection it's simpler for us to use a UUID rather
    than tempfile.mkdtemp() here so our start() and stop() methods can perform the
    creation/cleanup.
    
    Tested by running our integ tests with a control socket...
    
    ./run_tests.py --integ --target RUN_SOCKET
    
    ... and confirming both that a temporary resource is made with our control
    socket and that it's cleaned up afterward.
    
    Issue caught thanks to help from Ashish on...
    
    https://trac.torproject.org/8622

commit ffd7274c8bc97557d4027257b958b388911cb429
Author: Damian Johnson <atagar@torproject.org>
Date:   Tue May 14 08:30:54 2013 -0700

    Re-enabling test_event_handling
    
    Oops, I confused this test with another. I bumped the timeouts on
    test_reattaching_listeners rather than this...
    
    https://gitweb.torproject.org/stem.git/commitdiff/a5f8168
    
    Re-enabling the test with similar timeouts to see if jenkins is still happy.
    However, this is definitely still code stink indicating that we need to do
    something smarter for these tests.

commit 73b5ed39da299109c8515bdbd6c18397a18a9634
Author: Damian Johnson <atagar@torproject.org>
Date:   Mon May 13 09:59:42 2013 -0700

    Client usage example for polling twitter
    
    Adapting a script from Ashish for polling a twitter feed as another tutorial
    example...
    
    https://pastee.org/ghbhp

commit 1b965a4c81d0734d7f94a0283dbdd4b8793c4fa3
Author: Damian Johnson <atagar@torproject.org>
Date:   Mon May 13 09:31:33 2013 -0700

    Making SocksiPy work with official version
    
    Ashish's SocksiPy was based on a fork of the main project...
    
    https://code.google.com/p/socksipy-branch/
    
    This caused my attempts to run it to fail with...
    
    Traceback (most recent call last):
      File "twitter_script", line 12, in <module>
        socks.wrapmodule(urllib)
    AttributeError: 'module' object has no attribute 'wrapmodule'
    
    Making this work with the official upstream project is trivial so making the
    tweak.

commit a72e22512e86653d86ec2015bbf3416a3de52aae
Author: Damian Johnson <atagar@torproject.org>
Date:   Mon May 13 08:45:51 2013 -0700

    Using SocksiPy for client usage tutorial
    
    Exemplifying using tor with both SocksiPy and PycURL. It's quite a bit simpler
    with SocksiPy so I'll probably use this for most other examples. Change is
    thanks to Ashish.

commit c4b47fc89582dc96b75c90d8eb7629d88304b06d
Merge: 76f82d7 e96440e
Author: Damian Johnson <atagar@torproject.org>
Date:   Sat May 11 19:37:48 2013 -0700

    Controller cache thread safety
    
    Making our caching operations thread safe. Patch thanks to Akshit...
    
    https://trac.torproject.org/8607

commit e96440eda20e1bbd89ed542654b4f080b8ecb064
Author: Damian Johnson <atagar@torproject.org>
Date:   Sat May 11 18:36:44 2013 -0700

    Revisions for cache thread safety
    
    Handful of changes for the prior couple commits. Most are stylistic, but
    there's a couple funcitonal ones:
    
    * _set_cache() could accidently remove 'exit_policy'
    * _confchanged_listener didn't use the new thread safe operations

commit f208da6d4ca07ee4d241bd67085ba331bcc07d4b
Author: Akshit Khurana <axitkhurana@gmail.com>
Date:   Sun May 12 03:03:50 2013 +0530

    Add function for single param cache query
    
    Separate functions for single param cache query and multiple params.
     * get_conf : takes single param, returns value
     * get_conf_map: takes list of params, return dict

commit 2c51c6a10cef7b68d9acc7703014bea2e4bd3101
Author: Akshit Khurana <axitkhurana@gmail.com>
Date:   Thu Apr 4 18:09:06 2013 +0530

    Make controller cache thread safe
    
    reads and writes take place under cache lock
    https://trac.torproject.org/8607

commit 76f82d74960df9bccececff6792aa7dab88cd77b
Author: Damian Johnson <atagar@torproject.org>
Date:   Sat May 11 17:30:29 2013 -0700

    Allowing for instantanious closure in test_status_notifications
    
    Well, that's a little odd. Our jenkins instance reported a failure of
    test_status_notifications...
    
    ======================================================================
    FAIL: test_status_notifications
    ----------------------------------------------------------------------
    Traceback:
      File "/srv/jenkins-workspace/workspace/stem-tor-ci/test/integ/control/base_controller.py", line 224, in test_status_notifications
        self.assertTrue(state_observer.timestamp < time.time())
    AssertionError
    
    ----------------------------------------------------------------------
    
    In the past we've seen test failures due to dixie being far, far faster than my
    netbook. I'm a little dubious that state_observer.timestamp truely equaled
    time.time() (that would imply that the above statements took zero nanoseconds)
    but oh well. I've only seen this happen once and there's little reason not to
    pass when they're equal.

commit 2f69e4de1e5d9982dfe94a90c62da3c71edf96a2
Author: Damian Johnson <atagar@torproject.org>
Date:   Sat May 11 17:21:13 2013 -0700

    Disabling test_event_handling
    
    Well damn. Even with expanded sleeps test_event_handling is occasionally
    failing on the jenkins host. No test is better than a flaky test so disabling
    this for the time being.
    
    Ticket for fixing this test...
    
    https://trac.torproject.org/8865

commit 7c0b3ca25596123b5cfbc9251bdfbe630d23ffed
Author: Damian Johnson <atagar@torproject.org>
Date:   Sat May 11 17:09:52 2013 -0700

    Support for pulling multiple pids with get_pid_by_name()
    
    A leading cause of test failures in our jenkins environment is
    test_get_pid_by_name_lsof. This is because the test assumes that there is only
    a single tor process, but that's often not the case on the dixie host.
    
    This not only fixes the test, but expands get_pid_by_name() to include a
    'multiple' flag to pull all pids for a given process name. This includes unit
    test coverage.

commit bbd736d71e25db09af6b6be05a4a33ef2ff17465
Author: Damian Johnson <atagar@torproject.org>
Date:   Thu May 9 08:47:24 2013 -0700

    Download page entry for Fedora
    
    Juan's package is now live so dropping our Red Hat entry in favor of Fedora
    (where the package is actually available).

commit 76909729f3169af14d194a2f57e78e1604af7132
Author: Tomasz Kunikowski <tomasz.kunikowski@gmail.com>
Date:   Mon May 6 19:36:34 2013 +0200

    Fixing DescriptorReader links in 'Mirror Mirror...' tutorial
    
    Links to DescriptorReader class were pointing to a wrong location.

commit de576cad4bbdd4901ee1857334a7420593ef2458
Author: Sreenatha Bhatlapenumarthi <sreenatha.dev@gmail.com>
Date:   Thu Apr 25 06:36:27 2013 +0530

    Updating GETCONF cache after CONF_CHANGED events
    
    https://trac.torproject.org/7713

commit f7d3a232a40ec93fec8c64f46fefba71a7fe9648
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun May 5 18:22:56 2013 -0700

    Handle relative targets in the DescriptorReader
    
    The _handle_file() funciton expects to receive absolute paths so expanding
    relative inputs. This is a slight modification of wfn's patch from...
    
    https://trac.torproject.org/8815

commit a5f81683e1c29ba37cc4e97f0581d20c3949eb8b
Author: Damian Johnson <atagar@torproject.org>
Date:   Mon Apr 29 08:11:52 2013 -0700

    Bumping sleep for test_reattaching_listeners
    
    On our jenkins instance we're seeing this test fail roughly 1/24 of the time
    (breaking one target in 1/3 of the test runs). We *should* be doing some kind
    of activity guarenteed to trigger an event rather than rely on a BW event being
    emitted each second. For now trying to simply bump its sleeps though to see if
    that relieve the symptoms.
    
    This adds around eight seconds to our integ runtime so definitely something we
    should look into doing right later.

commit 3d047cb483f0692ef94b5b0cdac478da448957b0
Author: Sean Robinson <seankrobinson@gmail.com>
Date:   Fri May 3 17:28:48 2013 -0700

    Use the more idiomatic staticmethod decorator
    
    This is just a coding style change and not a functional change.  Funnily
    enough, there was already one of these decorators added in
    commit 5da6b9790da266f9.  So, this standardizes on the more Pythonic
    form.
    
    Signed-off-by: Sean Robinson <seankrobinson@gmail.com>

commit f5d690e5e241c8b53f6c4b0efa9f2519819a024e
Merge: 1773eba 411f8cc
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun May 5 18:05:43 2013 -0700

    Using new syntax for exception variables
    
    Python has two styles for exception variables...
    
    * Python 2.7 and earlier (discontinued on 3.x)
    
      except ValueError, exc:
    
    * Python 2.6 and later (started in 2.5)
    
      except ValueError as exc:
    
    Change is thanks to Sean on...
    
    https://trac.torproject.org/8823

commit 411f8ccb508ae5eb941f5b8008909e4f1254374c
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun May 5 18:00:11 2013 -0700

    Expanding comments for exception style check
    
    Just adding a bit more of an explanation to the new style check. I'm a little
    tempted to make the second conditional "',' in content" so it'll catch
    exceptions by other names, but that might be too loose.

commit 113f8c14723db3df5dacc02c5efaf54aeca6e688
Author: Sean Robinson <seankrobinson@gmail.com>
Date:   Thu May 2 16:29:18 2013 -0700

    Convert all except clauses to new grammar
    
    Use the try..except...as grammar available in Python 2.6/2.7 and required
    in Python 3.
    
    Signed-off-by: Sean Robinson <seankrobinson@gmail.com>

commit e65930b402cf4edee8ae18a812af4b3ea1aeeb21
Author: Sean Robinson <seankrobinson@gmail.com>
Date:   Thu May 2 16:15:26 2013 -0700

    Check that except clauses are not using old grammar
    
    This tests that code matches PEP3110 and is more Python 3 compatible
    out of the box.  This is possible because we no longer support
    Python 2.5.
    
    Signed-off-by: Sean Robinson <seankrobinson@gmail.com>

commit 1773ebaab470206653ce6d84c3ef1276f81c5d0a
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Apr 28 18:13:12 2013 -0700

    Updating download page entry for debian
    
    Debian was having some issues getting new packages to be reflected on
    'packages.debian.org'...
    
    https://lists.debian.org/debian-infrastructure-announce/2013/04/msg00000.html
    
    Now that it's been resolved we can link to the package Derek made for us. Yay!

commit f13c439c6b5e3702dce29d90b3daf24a4232487d
Author: Damian Johnson <atagar@torproject.org>
Date:   Thu Apr 25 09:28:28 2013 -0700

    Typo in FAQ entry for 'how to run tests'
    
    Oops, s/static/style in "but static checking is run separately...".

commit a1149f5489065cf7445f83137f3747a4866351e1
Author: Damian Johnson <atagar@torproject.org>
Date:   Wed Apr 24 21:01:06 2013 -0700

    Standardizing on digest() providing unicode
    
    Our digest() method provided bytes with python 2 and unicode with python 3. I'm
    trying to avoid these sort of version-dependent differences since they're a
    headache when we're support both serieses. The comparison for digest validation
    was also still failing in python 3 due to types. Caught thanks to aj00200.

commit 92af5b8d50e3dac52e2380cd44ff706c88d9332e
Author: Damian Johnson <atagar@torproject.org>
Date:   Wed Apr 24 09:35:52 2013 -0700

    Server descriptor digest validation failed for python 3
    
    When validating the digest for server descriptors via python 3 we forgot to
    explicitly use byte values (rather than unicode). This is an adaptation of a
    patch from aj00200...
    
    https://trac.torproject.org/8755

commit c7ed4c84b30c8555ba8e2e63c158b74876d08db2
Author: Damian Johnson <atagar@torproject.org>
Date:   Wed Apr 24 09:27:07 2013 -0700

    Helper for getting torrc of a target
    
    Breaking a chunk of run_tests.py into a get_torrc_entries() helper function to
    improve readability. The runner could use an overhaul, and might later take on
    this functionality.

commit 2a205415ed9bb1601a1ac65ec7c48f056561b3c8
Author: Damian Johnson <atagar@torproject.org>
Date:   Mon Apr 22 07:40:35 2013 -0700

    Checking pycrypto version when running tests
    
    Adding a check similar to python, pyflakes, and pep8 for the version when we
    run our tests. Bundling in various other small testing tweaks.

commit 8adc55c0139ff9f0925541be1254bea4767716ed
Author: Tomasz Kunikowski <tomasz.kunikowski@gmail.com>
Date:   Thu Apr 18 23:54:25 2013 +0200

    Extra spaces were inserted into process names via set_process_name()
    
    After running set_process_name() ps would report spaces within our process
    name. For instance, when running our integ tests our name would become...
    
    p   y   t   h   o   n       .   /   r   u   n   _   t   e   s
    
    Fixed thanks to ragwater, who figured out that ctypes.memmove() wanted unicode
    rather than byte content...
    
    https://trac.torproject.org/8631

commit 3d2f54327d64937016542381816a3529dcbfaa84
Author: Damian Johnson <atagar@torproject.org>
Date:   Wed Apr 17 10:27:57 2013 -0700

    Client usage tutorial can be disrupted if tor is running
    
    If you already have a tor instance running then the 'To Russia With Love'
    tutorial will fail to bootstrap due to a conflicting data directory. Thanks to
    Sreenatha for reporting this!

commit 3ba0e6571bd0593c547bf27dd702679e12f802ef
Author: Damian Johnson <atagar@torproject.org>
Date:   Wed Apr 17 09:26:32 2013 -0700

    Adding a :spec: role
    
    Generalising our roles to also support a :spec: alias for torspec commits.

commit 1ad1f71be638fa21b8268d2f9cebec2c82ff17dc
Author: Damian Johnson <atagar@torproject.org>
Date:   Tue Apr 16 09:02:27 2013 -0700

    Dropping '-dev' suffix for stem version on the site
    
    Like arm we're appending a '-dev' suffix for our git repository (to
    differentiate it from releases). However, for our site we just want the version
    itself.

commit 5b58537814dcc4c2c2e474adb49b899add2fd0c4
Author: Damian Johnson <atagar@torproject.org>
Date:   Mon Apr 15 20:40:41 2013 -0700

    Shrinking FAQ icon
    
    Reducing the size of the FAQ icon a little bit to more closely match the
    download icon. Ain't perfect, but closer.

commit f5aacc8bff0056748e8bc16e15f98d13e4dad024
Author: Damian Johnson <atagar@torproject.org>
Date:   Mon Apr 15 20:30:14 2013 -0700

    Raising FAQ category types
    
    Changing the category types so...
    
    'subcategories' => 'categories'
    'subsubcategories' => 'subcategories'
    
    This better emphasizes the questions and gives them a slight horizontal ruler.
    I'd like to get a more emphasized divider to better split up the questions but
    the only way I know of to do that is a table, which would be gross.

commit 6b7b50c5c7834f76ddba0a78f337a5f1e4998599
Author: Damian Johnson <atagar@torproject.org>
Date:   Mon Apr 15 09:29:32 2013 -0700

    Adding a FAQ page
    
    Introducing a page with FAQ items for the most common questions that I've seen
    so far. Suggested by gsathya on...
    
    https://trac.torproject.org/8577

commit f17e370bb75c28c36e5aae1fe942b5bc97ca5438
Merge: fae5b1d 4bdcba0
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Apr 14 16:07:18 2013 -0700

    Custom sphinx role for :trac:
    
    Thanks to ragwater we now have a :trac: role for our docs. With this we no
    longer need to hardcode ticket urls, and gives a nice template we can use for
    other customizations.
    
    https://trac.torproject.org/8671
    http://doughellmann.com/2010/05/defining-custom-roles-in-sphinx.html

commit 4bdcba090b5a29e2a64c229a5ba9246ddbb59a69
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Apr 14 16:05:03 2013 -0700

    Style revisions
    
    Our trac.py is based on an external tutorial...
    
    http://doughellmann.com/2010/05/defining-custom-roles-in-sphinx.html
    
    As such it naturally had different stylistic conventions from stem. There were
    also some minor points that had some room for simplification.

commit 5ab172051665101ce3c8797f3aac24a6d79459e7
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Apr 14 15:37:17 2013 -0700

    Using the :trac: role
    
    Replacing our hardcoded trac links with our fancy new :trac: role.

commit d5ae78b127d1103927a6febb44587f62d1ed03d1
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Apr 14 15:26:24 2013 -0700

    Truncating generated trac urls
    
    Trac expands short urls. For instance, when visited...
    
    https://trac.torproject.org/8596
    
    ... is expanded to...
    
    https://trac.torproject.org/projects/tor/ticket/8596
    
    I kinda prefer using the shortened version in our docs so copied links are more
    readable.

commit 02fa064867d186a3c9bbcc984f93ac0c20669ba9
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Apr 14 15:17:39 2013 -0700

    Including docs in our pyflakes and pep8 checks
    
    Including source from our docs directory in static checks.

commit 0567974e7c3e0610dfa62e54b0a96ef54fd59866
Author: Tomasz Kunikowski <tomasz.kunikowski@gmail.com>
Date:   Sun Apr 14 22:29:06 2013 +0200

    Implemented custom sphinx role :trac: for trac tickets
    
    Modified:
    	docs/conf.py
    
    Added:
    	docs/trac.py
    
    In accodrance to ticket #8671
    Using :trac:`1234` will display 'ticket #1234'

commit fae5b1db09ff925ac41d8bfab36621e29dbf0e69
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Apr 14 14:47:35 2013 -0700

    Checking for unused tests
    
    Well... shame on me. We've always had a hardcoded list of our tests, but
    somehow when I moved it to our settings.cfg I missed a few. I'm not so much
    troubled about that mistake, but more that this mistake went undetected.
    
    Adding a check at the start of our tests for this kind of misconfiguration.

commit b36a9e3dc44adfda40390527fbb667a174a4736d
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Apr 14 14:20:10 2013 -0700

    Revising ATTACHSTREAM 555 response handling
    
    Thanks to Roger we now know that a 555 response means that a stream's in a
    state where it can't be attached. Swapping the exception we raise to
    UnsatisfiableRequest and adding a little test for this.

commit 5268d28c885509de174e5b7c1a657bc0278fd797
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Apr 14 13:22:54 2013 -0700

    Catching 555 response from ATTACHSTREAM
    
    ATTACHSTREAM should only respond with 250, 552, or 551 according to the spec
    but someone came across a 555 response in the wild...
    
    https://trac.torproject.org/8701
    
    Tentatively handling this with OperationFailed until the spec is updated with
    more information.

commit ae5193f93ec7f3c9db74e1b0452939a7cb1196c4
Merge: 314876a 62413a2
Author: Damian Johnson <atagar@torproject.org>
Date:   Sat Apr 13 21:27:29 2013 -0700

    Testing framework overhaul
    
    Over time we've accumulated quite a bit of cruft. Rewriting run_tests.py and
    related modules.

commit 62413a29dbc73377ef3dd2231da1e9f35e4f30a9
Author: Damian Johnson <atagar@torproject.org>
Date:   Sat Apr 13 21:22:40 2013 -0700

    Rewriting run_tests.py
    
    Now that the building blocks are in place giving run_tests.py a long overdue
    rewrite. This pushes a great deal of the work to the test utils in the form of
    Tasks, units of work we can do in groups.

commit 8a09c4951afb3b806a75fed00e70f280287a76f2
Author: Damian Johnson <atagar@torproject.org>
Date:   Sat Apr 13 12:54:51 2013 -0700

    Dropping direct term usage in run_tests.py
    
    Our use of the output module is trending more toward printing message
    categories rather than specific terminal attributes. This will let us customize
    how things are rendered through the output module rather than chasing down all
    of the individual println() calls.

commit 24e4f0fca0fefa865aee1be527e5bb491f32aab8
Author: Damian Johnson <atagar@torproject.org>
Date:   Sat Apr 13 12:47:35 2013 -0700

    Dropping direct use of print
    
    Replacing our print calls with println(). This is both to standardize how we
    print our output as well as make later customization easier (for instance, if
    we want a --quiet option).

commit e7513978c0a39fb815eecaff2f8d9a8c958236df
Author: Damian Johnson <atagar@torproject.org>
Date:   Sat Apr 13 12:41:22 2013 -0700

    Less verbose usage of the test.output module
    
    We use the print_line() function throughout the runner and run_tests.py.
    Shortening it to 'println()' (pity we can't call it print()) and making its
    usage a little nicer by flattening the input attributes.

commit b1f3504ac7fac93b5a26fd02525cc962228aaea2
Author: Damian Johnson <atagar@torproject.org>
Date:   Sat Apr 13 10:05:57 2013 -0700

    Dropping stem.prereq.is_python_26()
    
    The is_python_26() check was used to support python 2.5 hacks. Dropping this
    and the hacks that it was supporting.

commit 00edd58211c9f67a0499aa6c04d5c4fa97580708
Author: Damian Johnson <atagar@torproject.org>
Date:   Sat Apr 13 10:00:37 2013 -0700

    Making check_requirements() require python 2.6
    
    Oops, the prereq module was checking for python 2.5. We're now only compatable
    with 2.6 and above.

commit 3d7bcee1aeba0f2ec2b8d808a1b57ba45ef731ae
Author: Damian Johnson <atagar@torproject.org>
Date:   Fri Apr 12 23:14:06 2013 -0700

    Merging static_checks.py with the test utils
    
    Revising the static check functions and merging them with the test util module.

commit 6076f4cf8375565acdde8dfbfffe2be4a2327480
Author: Damian Johnson <atagar@torproject.org>
Date:   Fri Apr 12 09:13:30 2013 -0700

    Moving clean_orphaned_pyc() to test utils
    
    Moving the functional bit of clean_orphaned_pyc() to the test utilities (the
    module specifically will *not* be used for generating output).

commit 49c55af78b8adf699f934bcd48248539acc83d6b
Author: Damian Johnson <atagar@torproject.org>
Date:   Fri Apr 12 08:57:50 2013 -0700

    Moving funcions for getting tests into util
    
    Now that we've freed up the util namespace I'm gonna gobble it up again for
    testing framework helpers. Hopefully this will be able to replace quite a few
    of our functions.

commit e28971e61ec41ec76be74d9b703cd728d7ec0d0f
Author: Damian Johnson <atagar@torproject.org>
Date:   Fri Apr 12 08:40:16 2013 -0700

    Merging test.network and test.util
    
    Both modules are to support tests for the ONLINE target. The main difference is
    that one module was made by Ravi and the other by Sean. At some point we should
    truely unify their functionality, but for now sticking them in the same place.

commit 02fb92e92892f58c18c4f2de1bcf831ee43f4ff6
Author: Damian Johnson <atagar@torproject.org>
Date:   Fri Apr 12 08:33:34 2013 -0700

    Dropping runability of static_checks.py
    
    Once upon a time static_checks.py had a single function that did a fair bit
    more validation. At that time it made sense for this to be runable as a
    standalone script. However, nowadays it's mostly just helpers for pyflakes and
    pep8.

commit f141a007655ae4d667942745b1acafa77391e0d0
Author: Damian Johnson <atagar@torproject.org>
Date:   Fri Apr 12 08:31:49 2013 -0700

    Supporting list of paths in static checker functions
    
    Reudcing a bit of redundancy by having the static_checks module support list of
    paths.

commit 90cb6e347fc02dd60e19011a13e9947e0eed7381
Author: Damian Johnson <atagar@torproject.org>
Date:   Fri Apr 12 08:10:56 2013 -0700

    Moving ERROR_ATTR to output module
    
    The ERROR_ATTR was defined in both run_tests.py and the runner. Making both
    modules a little cleaner by moving it to the output module.

commit 10d0bd80985c6dbdf8423890d0cd5f7f346ae559
Author: Damian Johnson <atagar@torproject.org>
Date:   Fri Apr 12 07:56:32 2013 -0700

    Untangling integration targets from configuration
    
    Even I was starting to get confused by 'em. We've always implicitely had two
    kinds of targets: run targets which constitute an integraion test run and
    attribute targets which have a non-torrc change on all test runs (such as being
    in a chroot).
    
    Making this division more explicit and dropping the confusing configuration
    dance we were doing.

commit d46ecdfafd6883ac39bf24841af988d45d2fd64e
Author: Damian Johnson <atagar@torproject.org>
Date:   Thu Apr 11 09:28:18 2013 -0700

    Dropping the argument.* config options
    
    Global state is icky, and in essence all stem.util.conf usage is global state.
    As mentioned in earlier commits the argument.* options were never used. Happily
    they were only consumed within run_tests.py so narrowing their scope is
    trivial.

commit a8d1eb06768335ac2d95af78195608ba0f091f7b
Author: Damian Johnson <atagar@torproject.org>
Date:   Thu Apr 11 08:58:05 2013 -0700

    Dropping load_user_configuration() helper
    
    One step closer to simplifying our arg parsing. The load_user_configuration()
    was mostly there to unify our configuration and commandline arguments. Now that
    the new-world-order will only have the later we should drop the helper to
    simplify the code.

commit 5ccfcfcc1827e38901754dd3fab20c3f9dcba42b
Author: Damian Johnson <atagar@torproject.org>
Date:   Thu Apr 11 08:50:20 2013 -0700

    Dropping support for a --config argument
    
    Lets face it, no one ever uses this. I doubt anyone besides me even knows
    *what* the hell it even does. Dropping this will let us simplify the test
    runner quite a bit.

commit 930e3608cfef3678357f9e4ad4168f24da19ddf6
Author: Damian Johnson <atagar@torproject.org>
Date:   Thu Apr 11 08:44:23 2013 -0700

    Dropping argument.no_color
    
    Disabling output colorization stopped being a runner argument a long time ago.
    Like git, stem's test runner makes a pretty good guess about if colored output
    is supported or not. If it's wrong then we can fix the check.

commit 347d2859073672e9c0354727901769245fb3b758
Author: Damian Johnson <atagar@torproject.org>
Date:   Thu Apr 11 08:35:31 2013 -0700

    Moving test filter to helper function
    
    Shifting support for the '--test' argument to the helper. Oh, and the integ
    helper was running the unit tests instead. ;)

commit 76e751f9c8fd338c73752a8547cedc92a95363de
Author: Damian Johnson <atagar@torproject.org>
Date:   Wed Apr 10 10:16:35 2013 -0700

    Moving test imports to the runner module
    
    Ideally the run_tests.py module should be as simple as possible, simply parsing
    the user input and calling helper functions to run the tests. To this end I'm
    moving the code for enumerating unit and integration tests into the runner
    module.

commit 314876a6a7ad2067a5e630faae2b88de180cfd62
Author: Damian Johnson <atagar@torproject.org>
Date:   Mon Apr 8 09:10:10 2013 -0700

    Adding a link to our jenkins setup
    
    Link at the bottom of our index for our automated testing.

commit 8774d00808a33dc6265d994d05d61a8823d24c75
Author: Damian Johnson <atagar@torproject.org>
Date:   Mon Apr 8 08:13:39 2013 -0700

    Missing runner import for stem.connection
    
    One thing I dislike about python imports is that they can sometimes happen
    transtively. If modoule A imports module B which imports module C then module A
    seems to have a reference to module C. This gets confusing as hell because when
    you see that the 'import B' is unused and remove it you get completely
    unrelated errors.
    
    Anywho, I got a slew of stacktraces while running the integ tests about a
    missing import for stem.connection in the runner module...
    
    ======================================================================
    ERROR: test_get_pid_by_port_netstat
    ----------------------------------------------------------------------
    Traceback:
      File "/home/atagar/Desktop/stem/test/integ/util/system.py", line 250, in test_get_pid_by_port_netstat
        elif not runner.is_ptraceable():
      File "/home/atagar/Desktop/stem/test/runner.py", line 415, in is_ptraceable
        tor_version = self.get_tor_version()
      File "/home/atagar/Desktop/stem/test/runner.py", line 569, in get_tor_version
        control_socket = self.get_tor_socket()
      File "/home/atagar/Desktop/stem/test/runner.py", line 536, in get_tor_socket
        stem.connection.authenticate(control_socket, CONTROL_PASSWORD, self.get_chroot())
    AttributeError: 'module' object has no attribute 'connection'
    
    I'm not really sure when this was introduced, but fixing it.

commit 744941e781c0597b05166001bae00b81ec8aaab1
Author: Damian Johnson <atagar@torproject.org>
Date:   Sat Apr 6 13:25:38 2013 -0700

    Moving list of test modules to settings.cfg
    
    Further cleaning up our overly-verbose run_tests.py by moving the list of test
    modules to our settings.

commit 76a7a12ae041cf9bab120264acd52a08a318d8d7
Author: Damian Johnson <atagar@torproject.org>
Date:   Sat Apr 6 12:57:01 2013 -0700

    Dynamically importing test modules
    
    Whenever we add a new test we need to add it to both the imports and UNIT_TESTS
    or INTEG_TESTS tuple. This is both a little clunky and, now that we have a crap
    ton of tests, it makes run_tests.py really long.
    
    Using __import__() to dynamically import the tests as we run them. This might
    have a slight runtime advantage too since we're just importing what we need,
    though it's not noticeable. This trick comes from...
    
    http://effbot.org/zone/import-string.htm

commit 29e7169d9a9947b86fe7af557a7230932fcc49f8
Merge: b7d8cad c719b1e
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Apr 7 17:25:34 2013 -0700

    Site navbar menu
    
    Replacing the normal sphinx 'previous/next' navigation with a navbar menu.
    Hopefully this will make site navigation far, far easier...
    
    https://trac.torproject.org/8431

commit c719b1e5680898e9d1f6ede953b3169d12580f64
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Apr 7 17:22:17 2013 -0700

    Simplifying site navigation via a navbar menu
    
    Using a CSS style navbar to make site navigation easier. This is based on the
    one from...
    
    http://aext.net/2009/09/elegant-drop-menu-with-css-only/

commit 174d39e9e5b6825da3ebb0490b3ebffb7d858fff
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Apr 7 11:33:49 2013 -0700

    Replacing paging nav bar with categories
    
    Sphinx wants the layout of sites to be like a book, with a 'previous' and
    'next' page. I'm at a loss for how that could possibly be a good idea. Sites
    like stem's have categories (tutorial, api, download, etc) which our navbar
    should provide a quick method to access.

commit bc8ec1da82bd45e2ec7b694ea824fedc49ae6395
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Apr 7 11:32:17 2013 -0700

    Forking the haiku theme
    
    The haiku theme has limited customizability. In particular we can't...
    
    * Overwrite the normal nav elements (previous, contents, next) with something
      else since they aren't within a block. The only way to overwrite them it to
      clobber the contents block, which kinda defeats the point of using their
      layout.
    
    * The css uses text layout right but we want text layout left.
    
    Hence I'm copying in the haiku layout and css so I can customize them. This is
    the first step toward a proper navbar for our site...

commit b7d8cadd12ff630bfe204e3f575bd624e9fae224
Author: Damian Johnson <atagar@torproject.org>
Date:   Sat Apr 6 22:14:45 2013 -0700

    Favicon for our site
    
    Mmmm, 32x32 favicon. I tried to get an ico as the sphinx config suggests but
    that didn't work. Oh well, just about every browser except maybe IE can handle
    pngs so I'd prefer to go with that anyway.

commit ad6973d05a0b25dc80768264a41cb717326c75f3
Author: Damian Johnson <atagar@torproject.org>
Date:   Sat Apr 6 21:47:44 2013 -0700

    Adding a change log page
    
    As changes accumulate we need a page to convey them to our users. Adding a
    change log that both has this, and information about what our versioning means.

commit 64fef2d9ee6ab5aefc597eb4f68c910df8f0a197
Author: Damian Johnson <atagar@torproject.org>
Date:   Sat Apr 6 18:13:35 2013 -0700

    Settling on a logo for stem
    
    Using Jakub Jankiewicz's WPClipart image as the logo for stem. This image is
    under the public domain, and a very nice fit for our library. :)

commit 9c8208474758862b7ae451c5c7eb93795df1015a
Author: Damian Johnson <atagar@torproject.org>
Date:   Sat Apr 6 17:43:17 2013 -0700

    Noting alternate onion images
    
    Citing some other more artistic (but less iconic) images that I came across
    while looking for a logo for stem. Might come in handy in the future and are
    under Creative Commons (thanks Andrea!).

commit 46d39df76cc51132c8e38c4fcbaabd45844e0c1c
Author: Damian Johnson <atagar@torproject.org>
Date:   Sat Apr 6 16:52:09 2013 -0700

    Support for the ADDRMAP event's CACHED flag
    
    Adding support for the new CACHED flag added by Desoxy...
    
    https://trac.torproject.org/8596
    https://gitweb.torproject.org/torspec.git/commitdiff/25b0d43a9ebe89541625e9f1a090e4a701748c76

commit 5879995bf9118792a9c27376a93361e779ec4fc2
Author: Damian Johnson <atagar@torproject.org>
Date:   Fri Apr 5 09:19:48 2013 -0700

    Skipping test_get_pid_by_port when connection resolvers are unavailable
    
    Our jenkins setup revealed that when netstat, sockstat, and lsof are all
    unavailable test_get_pid_by_port fails. Skipping instead since those connection
    resolvers are dependencies for the test.

commit 95e9d663796a49fdc2427c7b70fe5f557b0e2cb3
Author: Damian Johnson <atagar@torproject.org>
Date:   Fri Apr 5 09:02:59 2013 -0700

    Improving error message when get_system_tor_version() can't find tor
    
    When tor is unavailable the error output from get_system_tor_version() is
    pretty sucky...
    
    Traceback (most recent call last):
      File "./run_tests.py", line 525, in <module>
        our_version = stem.version.get_system_tor_version(CONFIG["argument.tor"])
      File "/home/atagar/stem/stem/version.py", line 84, in get_system_tor_version
        raise IOError(exc)
    IOError: [Errno 2] No such file or directory
    
    Making it more developer friendly.

commit f5971e1da626425062d8922a35b7b87447faa238
Author: Damian Johnson <atagar@torproject.org>
Date:   Fri Apr 5 08:47:34 2013 -0700

    Still passing when tor's stime is zero
    
    The stime proc field is an integer, rounded down to the number of seconds that
    a process has been running. On my piddly little netbook tor takes long enough
    to start that this is always non-zero, but on our jenkins systems it's so quick
    that the test fails. Thanks to weasel for all of the help!

commit a920e5cfc2e3d0283bdb467a9a78bd281b8ee2a2
Author: Damian Johnson <atagar@torproject.org>
Date:   Wed Apr 3 08:33:40 2013 -0700

    Python 2.6 doesn't support assertIsNotNone()
    
    The controller integ tests included a couple assertIsNotNone() calls, which
    wasn't added until python 2.7. Caught and fixed by Desoxy - thanks!
    
    https://trac.torproject.org/8629

commit 5c9efa028b3e61d038d6fbf617e3f7807a75a1f3
Author: Damian Johnson <atagar@torproject.org>
Date:   Tue Apr 2 10:15:20 2013 -0700

    Adding resource for event tutorial logo
    
    Including the full sized image used for the 'Tortoise and the Hare' tutorial.

commit ec40da3a8a5959b92897c17d284d5883082567bd
Merge: d3f1d80 c713715
Author: Damian Johnson <atagar@torproject.org>
Date:   Sat Mar 30 18:50:19 2013 -0700

    Revising the download page
    
    Expanding our download page to include packaging done for our 1.0.1 release.
    Many thanks to everyone involved!

commit c71371521ef0b8a294755f00a7689a935ab67f32
Author: Damian Johnson <atagar@torproject.org>
Date:   Sat Mar 30 18:43:19 2013 -0700

    Emphasising installation commands
    
    Using a preformatted block for installation commands since this is what
    visitors are likely most interested in.

commit c9122fbd24f32b288eebfa60dc7c77e802e58935
Author: Damian Johnson <atagar@torproject.org>
Date:   Sat Mar 30 18:24:15 2013 -0700

    Adding Red Hat to the download page
    
    Linking to the ticket Juan filed to add our stem release to redhat/fedora.

commit 170e44d3380b4cac140dc0ee52c280692d6aec0f
Author: Damian Johnson <atagar@torproject.org>
Date:   Sat Mar 30 18:07:49 2013 -0700

    Resizing FreeBSD logo
    
    Shrinking the logo a little bit to match the other entries.

commit 302ad96b7eaacc40784dfef43d4a3cdbcba4986e
Author: Damian Johnson <atagar@torproject.org>
Date:   Sat Mar 30 18:02:59 2013 -0700

    Using the official git logo
    
    I'm a bit torn between our custom git logo and the official one. Opting for the
    later in large part because it's now next to FreeBSD which has a red logo, so
    this looks a little better.

commit ee0089ba76d3c4357113fe11d3302682afca50de
Author: Damian Johnson <atagar@torproject.org>
Date:   Sat Mar 30 17:10:19 2013 -0700

    Instructions links for ArchLinux and FreeBSD
    
    Adding the instruction links for installing via AUR and ports.

commit c3b37286675617930f7bd3aad2d8581bab2752d3
Author: Damian Johnson <atagar@torproject.org>
Date:   Sat Mar 30 16:20:15 2013 -0700

    Adding FreeBSD to our download page
    
    Adding the stem port Carlo made for our release.

commit 74dc0846a647b4a7c55b51e39fd9b3c6d8a24e0d
Author: Damian Johnson <atagar@torproject.org>
Date:   Sat Mar 30 16:06:50 2013 -0700

    Citing ITP request in debian download page entry
    
    Pointing the request Dererk filed for adding our release to debian.

commit 3db5fd85b275a9413c518760e8e78dd35272974e
Author: Damian Johnson <atagar@torproject.org>
Date:   Sat Mar 30 16:01:59 2013 -0700

    Updating ArchLinux download url
    
    Sjon has uploaded a new AUR package for our 1.0.1 release. Pointing our
    download page at that instead.

commit 626f8247b74e8500a4557b4da55f94f533f3ed3c
Author: Damian Johnson <atagar@torproject.org>
Date:   Sat Mar 30 15:58:15 2013 -0700

    Revising download page entry for the source repository
    
    Placing the source repository at the bottom of the download page and renaming
    it.

commit 9e4d1b9adde0414efaec23bb1547f055b8db0f92
Author: Damian Johnson <atagar@torproject.org>
Date:   Sat Mar 30 15:48:45 2013 -0700

    Adding PyPI to download page
    
    Stem is now available on the python package index...
    
    https://pypi.python.org/pypi/stem/
    
    Thanks to refnode for providing us with the namespace!

commit d3f1d80483d88deed04871aac4403377458fb406
Author: Damian Johnson <atagar@torproject.org>
Date:   Wed Mar 27 09:41:58 2013 -0700

    Stem release 1.0.1

commit 4ee02d05f266a0fd60f470d28992026f6a6d49d6
Author: Damian Johnson <atagar@torproject.org>
Date:   Wed Mar 27 09:37:58 2013 -0700

    Avoiding stem imports in setup.py
    
    Our setup.py may be ran under python 2.x or 3.x. Because of this the file and
    anything it imports needs to run under both python serieses *without* a 2to3
    conversion.
    
    We were importing basic module information from __init__ which in turn brought
    in the enum and str_tools utils...
    
    atagar@morrigan:~/Desktop/stem$ python3 setup.py install
    Traceback (most recent call last):
      File "setup.py", line 5, in <module>
        from stem import __version__, \
      File "/home/atagar/Desktop/stem/stem/__init__.py", line 504, in <module>
        "ERR",
      File "/home/atagar/Desktop/stem/stem/util/enum.py", line 64, in UppercaseEnum
        return Enum(*[(v, v) for v in args])
      File "/home/atagar/Desktop/stem/stem/util/enum.py", line 77, in __init__
        if isinstance(entry, (bytes, unicode)):
    NameError: global name 'unicode' is not defined
    
    Bug caught by Dererk.

commit 07553f7b4cb3e21b74b5582f035a2f22477183c4
Author: Damian Johnson <atagar@torproject.org>
Date:   Tue Mar 26 09:21:06 2013 -0700

    Stem release 1.0.0

commit 8bc11004558a1362f61f75d967a221183777672d
Author: Damian Johnson <atagar@torproject.org>
Date:   Tue Mar 26 08:29:13 2013 -0700

    Another python3 authentication issue with mixed str types
    
    Fixing another failure in our python3 integ tests with cookie authentication.
    The hmac function provides us with bytes but we need to be careful to use
    unicode in the formatted string to avoid a b'' wrapper.

commit c75ab2812b90a730e135b5970ff35d431fa2c4a4
Author: Damian Johnson <atagar@torproject.org>
Date:   Mon Mar 25 08:33:57 2013 -0700

    Safecookie authentication broken when using python 3
    
    The os.urandom() provides bytes so there's no need to convert that, but we
    needed to be more careful about using the converted hex in the formatted
    string. It too was bytes, causing an extra embedded b''...
    
    >>> "hello %s" % b"damian"
    "hello b'damian'"
    
    Tor in turn rejected the nonce as being invalid. I don't get why python3 does
    it. With python2 bytes and unicode could both be used in a reasonable fashion
    for formatted strings - these extra characters are almost always undesirable.
    Oh well...

commit 83b99dbe6579af04f18553740b175d6de44fa27d
Author: Damian Johnson <atagar@torproject.org>
Date:   Mon Mar 25 08:12:30 2013 -0700

    Integ tests failed to create a control socket
    
    The RUN_SOCKET test was failing while trying to make the control socket because
    it tried to change the permissions of /tmp to 700 (which, of course, normal
    users can't).
    
    Tor rejects to start if the control socket is in a globally readable directory,
    so making a temporary directory we can set the permissions on.

commit 89974d0f67f09f44c0fb8b3f2344a78b27280dc4
Author: Damian Johnson <atagar@torproject.org>
Date:   Mon Mar 25 08:10:36 2013 -0700

    Only running RUN_OPEN by default or if requested
    
    We were configured to always run the RUN_OPEN target, even if something else
    had been requested. This bug lasted quite a while because we usually either run
    the default or RUN_ALL (which includes RUN_OPEN).

commit 5e6b5407f087b6b31d28ed5047e44b07f082d197
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Mar 24 21:05:14 2013 -0700

    Controller provided unicode microdescriptors with python 3
    
    When using python 3 the get_info() method provides unicode content. We were
    passing this content to descriptor constructors, causing its raw_content to be
    unicode rather than bytes. This in turn caused a stacktrace when calling
    methods like hashlib.sha256().
    
    This doesn't effect python 2.x, where str is bytes anyway.

commit fa0fbd195d0531980a6e250ee2e32c99a0708259
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Mar 24 20:52:07 2013 -0700

    Allowing stem.descriptor.parse_file() to handle paths
    
    Several times now I've passed a string path to parse_file() rather than a file
    object and been confused for a sec by the stacktrace. On reflection there's no
    reason *not* to accept paths - that's commonly what we want it for after all
    and eliminating the extra open() lets our callers have much nicer code.

commit e10b6124e22fd9febd7bd23abcc4b820353fbf8b
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Mar 24 20:35:22 2013 -0700

    Simplifying use of digest values for microdescriptors
    
    To be useful a microdescriptor often needs to be matched against its
    corresponding router status entry. The design of microdescriptors makes this
    suck - the only way to do so is to iterate over all router status entries
    looking for one with the corresponding digest.
    
    Adding examples for doing this and making the following changes to make the
    matching easier...
    
    * changing the digest value of RouterStatusEntryMicroV3 from base64 to hex
    * adding an attribute with the hex digest to Microdescriptors

commit b05bf7a7eeb9807bf003518b39677f8c6abc39c8
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Mar 24 19:40:23 2013 -0700

    Having ExitPolicyRules report /0 as a wildcard
    
    ExitPolicyRules can apply to both IPv4 and IPv6. Because of this I treated * as
    a wildcard, but *not* /0 (since 0.0.0.0/0, though it applies to all IPv4
    addresses, doesn't cover IPv6). However, in most cases (everywhere except the
    torrc?) Tor's exit policies are limited to IPv4. As such, /0 should usually be
    treated as a wildcard. Change suggested by Aaron Johnson.

commit caee7d6c968fd6cd9912dc4a554d66e303316b61
Author: Damian Johnson <atagar@torproject.org>
Date:   Sat Mar 23 19:50:52 2013 -0700

    Switching exit policy's can_exit_to() and is_match() be permissive
    
    Switching how the ExitPolicy's can_exit_to() and ExitPolicyRule's is_match()
    handle an undefined address or port. Previously we reported if we matched or
    allowed exiting to *all* instance of the defined destination. Now, however,
    rather if we match against *any*.
    
    Change was requested by Aaron Johnson. You can still get the old behavior by
    setting the 'strict' argument.

commit cefe584cd57c45a77379428a4c15fb225c0afdcc
Author: Damian Johnson <atagar@torproject.org>
Date:   Sat Mar 23 19:17:31 2013 -0700

    Testing errors when descriptors are unavailable
    
    Fixing a couple testing errors spotted by Dererk. These arise when we're either
    unable to fetch descriptors (disconnected with a fresh test data directory) or
    possably if descriptors are still in the process of being fetched.
    
    ======================================================================
    ERROR: test_get_microdescriptors
    ----------------------------------------------------------------------
    Traceback:
      File "/home/dererk/stem/stem/test/integ/control/controller.py", line 843, in test_get_microdescriptors
        for desc in controller.get_microdescriptors():
      File "/home/dererk/stem/stem/stem/control.py", line 1050, in get_microdescriptors
        raise exc
    OperationFailed: Data directory doens't contain cached microescriptors
    
    ======================================================================
    FAIL: test_get_microdescriptor
    ----------------------------------------------------------------------
    Traceback:
      File "/home/dererk/stem/stem/test/integ/control/controller.py", line 823, in test_get_microdescriptor
        test_relay = self._get_router_status_entry(controller)
      File "/home/dererk/stem/stem/test/integ/control/controller.py", line 1018, in _get_router_status_entry
        self.fail("Unable to find any relays without a nickname of 'Unnamed'")
    AssertionError: Unable to find any relays without a nickname of 'Unnamed'
    
    He also got a third error that mystifies me a bit. Fingers crossed that earlier
    changes have addressed it, if not then I'll need repro steps to dig in
    further...
    
    ======================================================================
    ERROR: test_get_network_status
    ----------------------------------------------------------------------
    Traceback:
      File "/home/dererk/stem/stem/test/integ/control/controller.py", line 922, in test_get_network_status
        self.assertRaises(stem.ControllerError, controller.get_network_status, "blargg")
      File "/usr/lib/python2.7/unittest/case.py", line 476, in assertRaises
        callableObj(*args, **kwargs)
      File "/home/dererk/stem/stem/stem/control.py", line 1166, in get_network_status
        raise exc
    ValueError: Router status entries must have a 'r' line:

commit 73ba530be8d7df7600e1b9a29df904de29a94831
Author: Damian Johnson <atagar@torproject.org>
Date:   Sat Mar 23 19:03:46 2013 -0700

    Switching network status document routers to a dict
    
    Changing the 'routers' attribute of NetworkStatusDocuments to a dict mapping
    fingerprints to the router status entry. This is generally far more convenient
    to work with - thanks to gsathya for the idea!

commit ea060119690650b4997c5f4c25f036b3ddeda3ac
Author: Damian Johnson <atagar@torproject.org>
Date:   Sat Mar 23 16:24:47 2013 -0700

    Presently no quoted GETCONF responses exist
    
    As per ticket #6172 the GETCONF response currently returns each result on a
    separate line, so quotes are unnecessary. If tor does add quoted values then
    we'll need to see at that time how it should be handled.

commit b3c00c4a6d0565939745e6eba2064b17aaff491a
Author: Damian Johnson <atagar@torproject.org>
Date:   Sat Mar 23 15:55:13 2013 -0700

    Dropping python 2.5 compatibility hacks
    
    As discussed on tor-dev@ there's a lot of arguments against maintaining support
    for python 2.5 and precious few for...
    
    https://lists.torproject.org/pipermail/tor-dev/2013-March/004551.html
    
    Dropping all the hacks we adopted to support it.

commit 88c3b1a6ae4152f1724fcc7267b7a5b69aae5a74
Author: Damian Johnson <atagar@torproject.org>
Date:   Sat Mar 23 15:06:08 2013 -0700

    Changing isinstance() checks to look for both bytes and unicode
    
    Commit b12e9c0 broke a couple of our integration tests because it caused us to
    call controller methods with unicode rather than str arguments...
    
    https://trac.torproject.org/8576
    
    This should be fine - python 2.x can usually use bytes and unicode inputs
    interchangeably. The problem was that we routinely use isinstance() checks to
    see if an input is a string and, if it isn't, assume it's a collection. As a
    result we were calling...
    
    GETINFO m d / n a m e / f o o
    
    ... rather than...
    
    GETINFO md/name/foo
    
    Tor in turn errored saying that those single character getinfo options didn't
    exist. To fix this I'm changing most of our isinstance() checks to look for
    both bytes and unicode.

commit cba36249020b0f322ce0ca6438d31dd5d4281905
Author: Damian Johnson <atagar@torproject.org>
Date:   Sat Mar 23 12:33:56 2013 -0700

    Issuing exit status 1 if there's any testing failures
    
    We explicitely set an exit status at several points but we don't set one for
    the most important situation: testing success/failure at the very end. Caught
    by weasel.

commit bee3c2b53653976a36b16a7cefb6e11bb56e4045
Author: Damian Johnson <atagar@torproject.org>
Date:   Fri Mar 22 20:32:07 2013 -0700

    Running python 3 tests errors when done with python 2.6
    
    When running tests with '--python3' we were using the named tuple
    sys.version_info. This was just a normal tuple prior to python 2.7, causing an
    error when run with python 2.6. Caught and fixed by Desoxy...
    
    https://trac.torproject.org/8565

commit c7f34c929a4f091b0527bec30d340472b55eacab
Author: Damian Johnson <atagar@torproject.org>
Date:   Fri Mar 22 19:49:06 2013 -0700

    Swapping contact and platform attributes to bytes
    
    The 'contact' and 'platform' lines in a server descriptor can have any
    arbitrary byte content. This isn't necessarily unicode, so we can't provide
    that to our callers without potentially mangling the data.
    
    Non-unicode contact lines are surprisingly common (fourteen instance in one
    cached-descriptors, around 0.4%).

commit b12e9c01c318863f4e4cddacf341abfd197ff412
Author: Damian Johnson <atagar@torproject.org>
Date:   Wed Mar 20 18:28:55 2013 -0700

    Storing raw descriptor content as bytes
    
    Tor descriptors are byte strings. While most content is ASCII (and hence maps
    to UTF8) there are a couple exceptions: the server descriptor's contact and
    platform lines which are arbitrary byte content. Usually this is unicode but on
    occasion it isn't (14 of 3044 in my old consensus cache).
    
    In those cases we converted the content to unicode and replaced the
    un-decodeable characters. This in turn caused our _verify_digest() check to
    report the descriptor content as being malformed if the user had pycrypto
    installed.
    
    Changing the raw contents the Descriptor class tracks to be bytes instead of
    unicode. This actually leads to far more elegant code, letting us drop the
    UnicodeReader which was always a pretty gross hack.
    
    This breaks python 2.5 compatability by using the io.BytesIO class. Presently
    I'm checking with tor-dev@ to see if anyone objects with dropping python 2.5
    support entirely...
    
    https://lists.torproject.org/pipermail/tor-dev/2013-March/004551.html
    
    If the answer is...
    
    * yes, drop support: we'll replace test.mocking.BytesBuffer with io.BytesIO
      (they both do the exact same thing)
    
    * no, keep support: we'll need to move test.mocking.BytesBuffer to a util and
      use it instead of io.BytesIO

commit 98cb69522254ddfd7bdd3c8df3b0dc7020c8e0a3
Author: Damian Johnson <atagar@torproject.org>
Date:   Wed Mar 20 17:34:07 2013 -0700

    Avoiding use of sign_descriptor_content()
    
    The test.mocking.sign_descriptor_content() function is slow. When the user has
    pycrypto the runtime of our unit tests jump from 17 to 83 seconds.
    
    This is a no-go since it discourages the use of our tests (our unit tests were
    already taking too long imho before this jump). By dropping
    sign_descriptor_content() the digest validation checks fail, so mocking those
    out.

commit 617661308bbc70c08b2d45767965969c690ac9f9
Author: Damian Johnson <atagar@torproject.org>
Date:   Wed Mar 20 09:50:12 2013 -0700

    Test still used old arg name for socket connections
    
    Oops. When running other targets we were sometimes hitting an instance that
    still used 'socket_path' rather than 'path'. Caught by gsathya.

commit dd220882e6c73863cc574ec4ba3833ee478314cb
Author: Damian Johnson <atagar@torproject.org>
Date:   Tue Mar 19 13:40:10 2013 -0700

    Dropping support for port lists in descriptors
    
    The 'or-address' and 'a' descriptors supported comma separated lists of ports.
    However, as per spec commit 99a9587 tor has never supported this, and the spec
    no longer includes this capability.

commit cbd83abf6e91955d84a87d3dada8548ad13ab99f
Author: Damian Johnson <atagar@torproject.org>
Date:   Tue Mar 19 08:25:06 2013 -0700

    Commenting tutorial use of curses.wrapper()
    
    Suggestion from Lunar for a rough spot in the tutorials.

commit 32244cdc3e8fbfff0cb9ca17f848ce8ede8ade3b
Author: Damian Johnson <atagar@torproject.org>
Date:   Tue Mar 19 08:15:19 2013 -0700

    Tutorial wording revisions
    
    Addressing various suggestions from Sean for improving the tutorials.

commit 796ea199b44fbd0fe4d2b55faad1a1bdcd64bef0
Author: Damian Johnson <atagar@torproject.org>
Date:   Tue Mar 19 07:09:50 2013 -0700

    Switching the server descriptor's family to a set
    
    Suggestion from gsathya. Duplicate family entries are moot and order doesn't
    matter, so might as well make this a set.

commit decc35249d2605644aec5a3ef5bb337cd0d41175
Author: Damian Johnson <atagar@torproject.org>
Date:   Mon Mar 18 18:40:13 2013 -0700

    Test accidently left around a file in /tmp
    
    The test_save_processed_files_malformed checks that save_processed_files()
    fails when presented with malformed data. However, this function still writes
    out a blank file. I noticed this because I just tried running the tests as a
    different user from prior test runs, causing...
    
    ======================================================================
    ERROR: test_save_processed_files_malformed
    ----------------------------------------------------------------------
    Traceback:
      File "/home/atagar/Desktop/stem/test/integ/descriptor/reader.py", line 172, in test_save_processed_files_malformed
        self.assertRaises(TypeError, stem.descriptor.reader.save_processed_files, "/tmp/foo", listing)
      File "/usr/lib/python2.7/unittest/case.py", line 465, in assertRaises
        callableObj(*args, **kwargs)
      File "/home/atagar/Desktop/stem/stem/descriptor/reader.py", line 229, in save_processed_files
        with open(path, "w") as output_file:
    IOError: [Errno 13] Permission denied: '/tmp/foo'
    
    ----------------------------------------------------------------------
    Ran 21 tests in 1.558s

commit 8099efdecf3d64abef787d1b19b537c4b9c30088
Author: Damian Johnson <atagar@torproject.org>
Date:   Mon Mar 18 18:32:28 2013 -0700

    Only query by name for relays with the Named flag
    
    Our integ tests pick a relay at random from its present consensus to test the
    'GETINFO desc/name/*', 'md/name/*', and 'ns/name/*' functions. However, this
    could fail if we're querying a relay without the Named flag.
    
    ======================================================================
    ERROR: test_get_microdescriptor
    ----------------------------------------------------------------------
    Traceback:
      File "/home/atagar/Desktop/stem/test/integ/control/controller.py", line 826, in test_get_microdescriptor
        md_by_nickname = controller.get_microdescriptor(test_relay.nickname)
      File "/home/atagar/Desktop/stem/stem/control.py", line 1001, in get_microdescriptor
        raise exc
    InvalidArguments: GETINFO request contained unrecognized keywords: md/name/MukiMukiAmaguri
    
    ======================================================================
    ERROR: test_get_network_status
    ----------------------------------------------------------------------
    Traceback:
      File "/home/atagar/Desktop/stem/test/integ/control/controller.py", line 928, in test_get_network_status
        desc_by_nickname = controller.get_network_status(test_relay.nickname)
      File "/home/atagar/Desktop/stem/stem/control.py", line 1165, in get_network_status
        raise exc
    InvalidArguments: GETINFO request contained unrecognized keywords: ns/name/MukiMukiAmaguri
    
    ----------------------------------------------------------------------
    Ran 31 tests in 11.307s

commit 6862dc4994996e78ebf4516094c29aad66ceb524
Author: Damian Johnson <atagar@torproject.org>
Date:   Mon Mar 18 18:20:35 2013 -0700

    Skipping tests that fail when run as root
    
    Some of our integ tests rely on permission failures for files we lack access
    to, or path expansions. Running as root causes these to fail. Caught by
    Dererk...
    
    https://trac.torproject.org/7925

commit 98fd0a7ba4787340d05d0baf341594555da87d00
Author: Damian Johnson <atagar@torproject.org>
Date:   Mon Mar 18 16:36:11 2013 -0700

    The 'name' attribute of TarInfo classes can't be set in python 3
    
    Workaround for the 'name' attribute being unwriteable in python 3. On
    reflection this is a little more elegant than our prior hack. :)
    
    Exception in thread Descriptor Reader:
    Traceback (most recent call last):
      File "/home/atagar/Python-3.3.0/Lib/threading.py", line 639, in _bootstrap_inner
        self.run()
      File "/home/atagar/Python-3.3.0/Lib/threading.py", line 596, in run
        self._target(*self._args, **self._kwargs)
      File "/home/atagar/Desktop/stem/test/data/python3/stem/descriptor/reader.py", line 435, in _read_descriptor_files
        self._handle_file(target, new_processed_files)
      File "/home/atagar/Desktop/stem/test/data/python3/stem/descriptor/reader.py", line 514, in _handle_file
        self._handle_archive(target)
      File "/home/atagar/Desktop/stem/test/data/python3/stem/descriptor/reader.py", line 557, in _handle_archive
        entry.name = target
    AttributeError: attribute 'name' of '_io.BufferedReader' objects is not writable

commit c40ea0fb2f2188d540655cfc4c6975bffc9585b2
Author: Damian Johnson <atagar@torproject.org>
Date:   Mon Mar 18 16:19:39 2013 -0700

    Fixing open() mock for python 3
    
    Our unit tests were broken under python 3 due to needing a slightly different
    mock for the open() function.
    
    ======================================================================
    ERROR: test_mirror_mirror_on_the_wall_2
    ----------------------------------------------------------------------
    Traceback:
      File "/home/atagar/Desktop/stem/test/data/python3/test/unit/tutorial.py", line 107, in test_mirror_mirror_on_the_wall_2
        tutorial_example()
      File "/home/atagar/Desktop/stem/test/data/python3/test/unit/tutorial.py", line 95, in tutorial_example
        for desc in parse_file(open("/home/atagar/.tor/cached-consensus")):
    FileNotFoundError: [Errno 2] No such file or directory: '/home/atagar/.tor/cached-consensus'

commit bc155d6ee800c1741fb7b1b7780cf696217115f4
Author: Damian Johnson <atagar@torproject.org>
Date:   Mon Mar 18 14:00:45 2013 -0700

    Dropping the memory usage assertion when reading descriptors
    
    Our integ test for reading descriptors tries to check that we aren't consuming
    gobs of memory. Unfortunately this assertion seems to be platform dependent (it
    fails on OSX) so dropping the assertion. Yea, yea, I should be fixing it but we
    haven't had this issue for a very long while and it isn't likely to reoccure.

commit c614080d911cec936a90b1f106e777f962ad8249
Author: Damian Johnson <atagar@torproject.org>
Date:   Mon Mar 18 13:53:17 2013 -0700

    Tor switched from server to microdescriptors in 0.2.3.3

commit bf5bac34abf95f1e12f0ce4030c305c364939c1f
Author: Damian Johnson <atagar@torproject.org>
Date:   Mon Mar 18 13:34:41 2013 -0700

    Digest validation fails for 'non-ascii_descriptor'
    
    The 'non-ascii_descriptor' test descriptor fails digest validation due to being
    slightly modified. Finding that descriptor was a PITA so simply mocking out the
    digest validation rather than trying to dig up the original.

commit b8d79e24b4599b59df1d68bd99273cebb11a8038
Author: Damian Johnson <atagar@torproject.org>
Date:   Sat Mar 16 11:30:36 2013 -0700

    Unescaped characters shouldn't be considered in further unescaping
    
    When we unescape responses we should process the string from start to end, and
    when something is unescaped it needs to be removed from further consideration.
    For instance, '\\t' should be unescaped to '\t', not a tab. Caught on...
    
    https://trac.torproject.org/8471

commit a124b62f26c8ae1cee01f780a0383389275ee873
Author: Damian Johnson <atagar@torproject.org>
Date:   Sat Mar 16 10:12:57 2013 -0700

    Supporting 'Unmeasured' in router status entries
    
    Spec commit c3860e3 added a new 'Unmeasured' key/value entry to the 'w' lines
    of v3 router status entries.

commit cb7915bb4734742f487519dad6ce0ec2a84b5bb7
Author: Damian Johnson <atagar@torproject.org>
Date:   Sat Mar 16 09:42:41 2013 -0700

    Including param constraints for UseOptimisticData
    
    We were missing the bounds for the UseOptimisticData parameter.

commit 2f90285dd88db3fdac5dc14441b7ffe19ce8da38
Author: Damian Johnson <atagar@torproject.org>
Date:   Sat Mar 16 09:05:22 2013 -0700

    Chaning GuardEvent to match spec revisions
    
    Nick has clarified GUARD events in...
    
    https://trac.torproject.org/7619
    
    Updating our enum docs to reflect the revisions and changing our 'name'
    attribute to reflect that it could contain either a fingerprint or
    fingerprint/nickname pair. This is a similar pattern to what we use for
    ORConnEvent.

commit 0ce65a43d68291388a5a0f61be2427d78ce7167f
Author: Damian Johnson <atagar@torproject.org>
Date:   Thu Mar 14 09:23:21 2013 -0700

    Providing default ipv6-policy entries
    
    The server descriptor's newish 'ipv6-policy' lines are now documented as being
    reject-all if it's missing...
    
      A missing "ipv6-policy" line is equivalent to "ipv6-policy reject 1-65535".
    
    https://gitweb.torproject.org/user/nickm/torspec.git/commitdiff/ef5513b1ad3671153f20b3c3929e1acba1b873bc

commit 8474971d99da327169e5827db660f8f1f91bbd59
Author: Damian Johnson <atagar@torproject.org>
Date:   Wed Mar 13 09:38:19 2013 -0700

    Dropping the V3Dir flag
    
    Nick just pushed a change noting that the V3Dir flag has never existed, so
    updating our enum too.
    
    https://gitweb.torproject.org/torspec.git/commitdiff/67768b16c247f937a4345af94beb58a4238b0730

commit 89e8fb8f37ebaad8d2009fedba766d1d42831dd8
Author: Damian Johnson <atagar@torproject.org>
Date:   Wed Mar 13 09:14:33 2013 -0700

    More uniformly renaming to 'tutorials'
    
    Several of our resources, including individual tutorial pages, were still under
    'tutorial'. I'm also dropping the old 'tutorial.rst' (I'm not getting any
    replies to the tor-dev@ email and having a stale copy is confusing).

commit c1abfa73fc24528713be233347cbd0f8796c537e
Author: Damian Johnson <atagar@torproject.org>
Date:   Wed Mar 13 09:09:54 2013 -0700

    'Tortoise and the Hare' tutorial
    
    Adding a tutorial for event listening. This has the most substantial example
    yet, making a curses graph for tor's bandwidth usage.

commit 92d395c8515e72e9c9b9b89d9e84512419f51aa4
Author: Damian Johnson <atagar@torproject.org>
Date:   Tue Mar 12 06:55:22 2013 -0700

    Tutorials still referenced a control_port arg
    
    Oops. When updating the tutorial tests I guess that I forgot to update the
    examples. :(

commit fb35fc7a9dd9d0217bedbc38bda51f58579d5f77
Author: Damian Johnson <atagar@torproject.org>
Date:   Mon Mar 11 19:01:16 2013 -0700

    Filling in a description for MEASURE_TIMEOUT
    
    Nick added a description to address...
    
    https://trac.torproject.org/7626
    
    I'm not quite sure what it means (does "see how long it takes" mean measure the
    time to make the circuit? or the time it takes before being timed out like the
    name suggests?), so just copying what he put in the spec.

commit 98f878087dfb5eeac3fd2720b47b4ffe1fe1bc75
Author: Damian Johnson <atagar@torproject.org>
Date:   Mon Mar 11 18:28:24 2013 -0700

    Dropping 'aka' from tutorial labels
    
    The labels look a little nicer this way. Suggested by Josh Barr.

commit 2c9710060e6194e30d6971377ddc80fa681eeaa9
Author: Damian Johnson <atagar@torproject.org>
Date:   Mon Mar 11 18:07:54 2013 -0700

    More changes for tutorial rename
    
    Drats, I pushed the prior commit before I had intended to. Fixing the buttons
    too to reflect the rename.

commit 48938b1d95d25ef255c19cfdd7a8a30714a80b76
Author: Damian Johnson <atagar@torproject.org>
Date:   Mon Mar 11 00:22:43 2013 -0700

    Pluralizing the tutorials page
    
    Renaming the 'tutorial' page to 'tutorials'. I can't remove the old page yet since I just sent it to tor-dev@, but now that its only link is swapped over we should be able to move it in a few weeks.

commit 74b80d61fe3279ca006ecae86271557523e33967
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Mar 10 23:07:48 2013 -0700

    Making all labels links
    
    Among the tutorials the labels (ie. the text summary for a section) was a link
    but on the download and example pages they weren't. Standardizing on them being
    links.

commit 7d13f767c08e35d55324186832deb7c6df6de62d
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Mar 10 22:59:23 2013 -0700

    More clearly stating tutorial topics
    
    While our cutesy titles are fun, they shouldn't get in the way of our tutorial
    page making sense. Dropping them to be a subheading, in favour of a clearer
    summary of what the tutorial's about.

commit 4d89032ba6f7d1c2babd54c593668c8e74b23f98
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Mar 10 22:40:11 2013 -0700

    Adding an examples section to our site
    
    Example sections containing projects and scripts using stem. Presently this is
    pretty small - hopefully it'll grow soon!

commit 99dbc604fb6781163d2cdf5262b759cbdc62c71a
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Mar 10 17:41:58 2013 -0700

    Making stem.util.term public
    
    Now that we're using it for a tutorial we should vend this module. I'm a little
    unsure about the name of the format() function since there's a builtin by that
    name, but I'm having a hard time thinking of something better.

commit ecc5f7bcd7d9669521e3b3b9275b18dff98c4270
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Mar 10 11:28:58 2013 -0700

    'To Russia With Love' tutorial
    
    Soviet themed tutorial for programmatically starting tor and reading a site
    through it. I've been wanting to write this for quite a long time...
    
    https://trac.torproject.org/7505

commit 860e89bed7a4d6769d9d4376a770e9af19de684b
Author: Damian Johnson <atagar@torproject.org>
Date:   Sat Mar 9 23:13:25 2013 -0800

    Dropping 'last updated' timestamp from site
    
    While I'd kinda like to have this on our site, it's stupidly broken. This is
    probably due to sphinx caching (it only makes static files for things that have
    changed). Presently it says that our site was last updated on December 31st
    which is... very wrong. No date is better than the wrong date so dropping it.
    
    https://trac.torproject.org/7780

commit a7fae56f9dab6cf766699c229edb2fd0531b7bd9
Merge: d45f89d aab3bf5
Author: Damian Johnson <atagar@torproject.org>
Date:   Sat Mar 9 23:10:26 2013 -0800

    Marking stem.util modules and functions as being private
    
    The stem.util space has several things that I'd rather not vend. Things that
    are either likely to change in the future or simply don't make sense outside of
    stem's internal use. Marking functions and some entire modules as being
    private.

commit aab3bf57a87bb09d4d572195e568e73da489f38a
Author: Damian Johnson <atagar@torproject.org>
Date:   Sat Mar 9 23:07:23 2013 -0800

    Marking stem.util.str_tools functions as being private
    
    Swapping several of the functions that we don't want to vend as being private.
    The to_bytes() and to_unicode() functions in particular are simply there for
    python 3.x support, so they'll disappear if/when we drop python 2.x support.

commit 7f4b7a93d2ff55388a8566919fc19baf2f1a48df
Author: Damian Johnson <atagar@torproject.org>
Date:   Sat Mar 9 22:47:05 2013 -0800

    Marking the log, proc, term, and tor_tools utils as being private
    
    More modules that I'd rather not yet vend to stem users. They're more than
    welcome to use them, but I can't yet promise a stable API (and in many of these
    cases there's little reason they ever should be used outside of stem).

commit ec0b5538a95a39f7e2b3a3fbcf47a03739f16a6b
Author: Damian Johnson <atagar@torproject.org>
Date:   Sat Mar 9 22:33:07 2013 -0800

    Notice to stem users not to use stem.util.ordereddict
    
    The ordereddict module is to allow us to support python 2.5 and 2.6. Adding a
    notice that it may be dropped in the future.

commit f8b538b00bd16fece4d368c892a7977dd0f8260b
Author: Damian Johnson <atagar@torproject.org>
Date:   Sat Mar 9 22:29:37 2013 -0800

    Making several stem.util.connection functions private
    
    The connection module has several functions that I'd rather not vend. Marking
    them as private to discourage their use.

commit 26c854e7c032d2f7df822316f56b0d62075d29d2
Author: Damian Johnson <atagar@torproject.org>
Date:   Sat Mar 9 22:18:22 2013 -0800

    Renaming stem.util.connection.get_mask()
    
    Renaming the function to get_mask_ipv4() to match the module conventions now
    that we have ipv6 support.

commit 08c5f3d6020c860077125a976a336f076f9b9e7c
Author: Damian Johnson <atagar@torproject.org>
Date:   Fri Mar 8 09:37:35 2013 -0800

    Renaming stem.util.connection.is_valid_ip_address()
    
    Changing is_valid_ip_address() to is_valid_ipv4_address() so it'll be in better
    keeping with the modules conventions now that it also supports IPv6. We might
    add is_valid_ip_address() later to check if it's an IPv4 *or* IPv6 address.

commit d45f89dbce487aec2a3988138966387da55adaf5
Author: Damian Johnson <atagar@torproject.org>
Date:   Fri Mar 8 07:57:28 2013 -0800

    Clarifying requirements for timing out launch_tor()
    
    The signal timeout we were doing isn't just *nix specific, but relies on global
    state. It turns out that no languages really have a good method for doing this
    sort of arbitrary timeout - pity...
    
    http://eli.thegreenplace.net/2011/08/22/how-not-to-set-a-timeout-on-a-computation-in-python/

commit a564ae2a6c24aebb822e777e7dea8bda3cffcf68
Author: Damian Johnson <atagar@torproject.org>
Date:   Thu Mar 7 09:33:37 2013 -0800

    stem.process.launch_tor() doesn't work without stdout logging
    
    The launch_tor() function uses tor's stdout logs to figure out when it has
    finished bootstrapping. This, of course, doesn't work if tor isn't logging to
    stdout...
    
    https://trac.torproject.org/7677
    
    Changing launch_tor_with_config() to slip in a 'Log NOTICE stdout' option so it
    always works, and adding a note to launch_tor() warning users of the
    requirement.

commit 32d39439b3a1cb2a72b2efc9d3010d2c90b174ee
Author: Damian Johnson <atagar@torproject.org>
Date:   Wed Mar 6 20:12:06 2013 -0800

    Making the arrived_at arg of events optional
    
    The kwargs of stem.response.convert() are documented as being optional, however
    the arrived_at argument for events was mandatory. Caught by meejah.

commit f40ab20110a1979efbffaa7854eca5ff77a5e9c3
Author: Damian Johnson <atagar@torproject.org>
Date:   Wed Mar 6 19:56:57 2013 -0800

    Dropping the _get_pid() helper from stem.process
    
    Huh, that's odd. There's a comment saying that I tried to use the mocking
    module for os.getpid() but it was a no-go, necessitating an ugly hack. I just
    tried again and it worked - maybe a bug we have since fixed with the mocking?

commit de9b6220b21f0c09239181ab17a9f7554ea601eb
Author: Damian Johnson <atagar@torproject.org>
Date:   Wed Mar 6 09:39:34 2013 -0800

    Mocking didn't properly revert static methods
    
    When working on our tutorials I expanded our mocking module to handle static
    methods. This worked well for our unit tests, but when we reverted the mocks we
    did so as standard rather than static methods.
    
    This in turn broke all of our integ tests that relied upon
    Controller.from_port(). This went undetected because it only manifests when
    *both* unit and integ tests are run together (and I've only been running one or
    the other recently).

commit 27630c4d7f17052975238a0f7622ec3418bdbd5e
Author: Damian Johnson <atagar@torproject.org>
Date:   Tue Mar 5 11:01:56 2013 -0800

    Replacing Controller's enable_caching constructor arg with setter
    
    It's clunky for cache toggling to be a constructor arg since most of our users
    will be using from_port() or from_socket_file() instead.

commit 0c4cb0d9c0178a353df4894bb87ccb835bca2ace
Merge: 954bced 7d4efa2
Author: Damian Johnson <atagar@torproject.org>
Date:   Mon Mar 4 00:11:59 2013 -0800

    Revising the tutorials
    
    Changing our tutorial page to be a friendly listing of the tutorials rather
    than a wall of text. Also rewrote our present tutorials and their corresponding
    tests.

commit 7d4efa2102727a1135bd19204e7d35f7b8900ec4
Author: Damian Johnson <atagar@torproject.org>
Date:   Mon Mar 4 00:10:07 2013 -0800

    Tests for descriptor tutorial examples
    
    Unit tests for our new 'mirror, mirror' tutorial examples, and writing our
    prior tests to conform with the way-less-sucky style that separates the mocking
    from the example.

commit a86d250b6702f7dae9ed74778a6e0a5cb2f9358a
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Mar 3 23:11:30 2013 -0800

    Rewriting the descriptor tutorial
    
    Replacing the 'Mirror, Mirror' tutorial with a new one that gives a better
    overview of the various descriptors and how to get/use them. This keeps the old
    example (listing the fastest exits), but otherwise is a full rewrite.

commit fce9b2e92f4d6bf9a01431f993fd0e42dcd6f6ad
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Mar 3 16:12:24 2013 -0800

    Adding microdescriptors to our api docs

commit 478ba3a44f3291367eeaea9ba9ce0f4cab24f517
Author: Damian Johnson <atagar@torproject.org>
Date:   Sat Feb 23 11:49:02 2013 -0800

    Cleaning up 'The Little Engine that Could' tutorial test
    
    Of all our tests the tutorial example tests stick out as being... just
    aweful. They work I guess but their mix of heavy mocking and the example being
    tested is both damn confusing and unmaintainable.
    
    Breaking it up so the mocking is entirely separate from the tutorial code.

commit 1749855559044f2547920fa206f72c6fdf7c86f4
Author: Damian Johnson <atagar@torproject.org>
Date:   Fri Feb 22 08:53:21 2013 -0800

    Mocking stdout for tutorial tests
    
    Mocking stdout so the tests can be a little more faithful to the tutorial
    examples.

commit 63bad222dc4de6b7e3c8510e4704ac7af0cabcdb
Author: Damian Johnson <atagar@torproject.org>
Date:   Fri Feb 22 08:55:14 2013 -0800

    Revising 'The Little Relay that Could' tutorial
    
    Changing small bits if the tutorial page and 'hello world' tutorial, adding a
    little detail here and cleaning up the wording there.

commit a3e486856810e99cfa065df9ebf24961ec7a3bff
Author: Damian Johnson <atagar@torproject.org>
Date:   Tue Feb 19 09:23:11 2013 -0800

    Rearranging contents
    
    The contents determine the next/previous links in the page's upper right. In
    general these don't make sense (there's not really a logical order to our API),
    but for the tutorial it's nice if they link to each other.

commit f4d2b20b2d954852faa59d39ce9f38f7cb11dcd2
Author: Damian Johnson <atagar@torproject.org>
Date:   Mon Feb 18 22:12:01 2013 -0800

    Moving tutorials to sub-pages
    
    Making pages for each of the tutorials and making tutorial.rst a pretty listing
    similar to the download page. This should hopefully make this page far more
    approachable by newcomers.

commit 0fde6ad67f7250b3de573726343844eb7ea573fe
Author: Damian Johnson <atagar@torproject.org>
Date:   Mon Feb 18 08:58:10 2013 -0800

    Moving download images into subdirectory
    
    I'm about to use '_static/section' for tutorial images, so moving the download
    page's resources to keep them separate.

commit 954bced4f16b05bd6a4923cfe3a8297f0e3347a6
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Mar 3 15:08:01 2013 -0800

    Only first 'transport' line was being used
    
    The extrainfo descriptor parser only utilized the first 'transport' line,
    causing further lines to be ignored. Caught by asn.

commit 7f3f8722d99b2747cafd2247b14e362c743d5290
Author: Damian Johnson <atagar@torproject.org>
Date:   Sat Mar 2 22:16:20 2013 -0800

    Adding get_microdescriptors() method to the Controller
    
    Controller method to fetch all microdescriptors. This is modeled after its
    counterparts for server descriptors and network status documents. However, as
    mentioned in 'https://trac.torproject.org/8323', the controller interface
    presently lacks a method to get them.
    
    In the meantime we're reading them from disk.

commit db19cafb398e9626502cf9d1226803a5fb4cb4b1
Author: Damian Johnson <atagar@torproject.org>
Date:   Sat Mar 2 19:57:57 2013 -0800

    Replacing get_server_descriptor() and get_network_status() tests
    
    Our integration tests for get_server_descriptor() and get_network_status() have
    been skipped for quite some time due to...
    
    https://trac.torproject.org/7163
    
    Replacing them with a simpler (and hopefully more reliable) test like what
    we're now doing for get_microdescriptor().

commit f5c7c226321f801e448f759e2ba3617c0ef5814b
Author: Damian Johnson <atagar@torproject.org>
Date:   Sat Mar 2 19:28:06 2013 -0800

    Adding get_microdescriptor() method to the Controller
    
    Adding a method to query individual microdescriptors. This is very similar to
    its server descriptor and network status counterparts.

commit 23d2332b2514fd9194e64cb1859614014087394b
Author: Damian Johnson <atagar@torproject.org>
Date:   Thu Feb 28 09:14:01 2013 -0800

    Tor microdescriptor support
    
    Adding parsing support for tor microdesriptors...
    
    https://trac.torproject.org/8253
    
    These have replaced server descriptors as the self-published descriptor content
    tor fetches by default. They're a bit clunckier to use compared to server
    descriptors, and lack much of the information controllers might be interested
    in, but the lighter weight of microdescriptors make them better for the overall
    network.
    
    Next up is to add support for these to our Controller. Unfortunately the tor
    control protocol only supports querying microdescriptors individually...
    
    https://trac.torproject.org/8323

commit d25f946d06a26e2ee0947eca5b1944f190e6299f
Author: Damian Johnson <atagar@torproject.org>
Date:   Sat Feb 23 12:16:32 2013 -0800

    Notice that server descriptors are no longer available by default
    
    As of Tor 0.2.3.25 relays stopped fetching server descriptors by default. This
    is an important thing to know since it makes get_server_descriptor() and
    get_server_descriptors() useless unless you set 'UseMicrodescriptors 0'.
    
    velope has been emphatically pointing out that we want to discourage stem
    developers from disabling microdescriptors so advising them against it.

commit ec3d0c01c9ba4aa30541ceb19e499fbe732453cb
Author: Damian Johnson <atagar@torproject.org>
Date:   Wed Feb 27 07:35:00 2013 -0800

    Don't pass unsupplied optional args to wrapped file
    
    Karsten reports that the descriptor reader is failing for him with...
    
      ParsingFailure: readlines() takes exactly 1 argument (2 given)
    
    This is because to add python 3.x support we had to wrap the parse_file()'s
    file argument with a wrapper. In most cases this wrapper is a passthrough, but
    it converts the read() and readlines() output to unicode.
    
    I based the methods of the wrapper on a StringIO file object, but evidently
    other files (most likely the tarfile) deviate a bit. Addressing the readlines()
    instance and one other that might cause troubles.

commit 3872befa5c62a91eb83d0d1376741b51a91acdb6
Author: Damian Johnson <atagar@torproject.org>
Date:   Sat Feb 23 16:07:19 2013 -0800

    Renaming controller and socket keyword arguments
    
    Less is more. I'm not sure why I called these keyword arguments 'control_addr',
    'control_port', and 'socket_path' but these will be highly used constructors.
    We should aim to have them be as user friendly a possible, and that means less
    verbose.

commit be9a5323a37ea0f1b7d497d7fc33e101453eb2cf
Author: Karsten Loesing <karsten.loesing@gmx.net>
Date:   Wed Feb 20 12:26:29 2013 +0100

    Change fingerprints and digests to upper-case hex.

commit 13de78a989b4e9ba68ffcecdd6022335baae4b39
Author: Damian Johnson <atagar@torproject.org>
Date:   Mon Feb 18 07:42:46 2013 -0800

    Catching unexpected exception from libc.setproctitle()
    
    Sathyanarayanan reports that on OSX libc.setproctitle() can raise an
    AttributeError...
    
    ERROR: test_set_process_name
    ----------------------------------------------------------------------
    Traceback:
      File "/Users/sathya/Documents/stem/test/integ/util/system.py", line 412, in test_set_process_name
        stem.util.system.set_process_name(initial_name)
      File "/Users/sathya/Documents/stem/stem/util/system.py", line 774, in set_process_name
        _set_proc_title(process_name)
      File "/Users/sathya/Documents/stem/stem/util/system.py", line 831, in _set_proc_title
        libc.setproctitle(ctypes.byref(name_buffer))
      File "/opt/local/Library/Frameworks/Python.framework/Versions/2.7/lib/python2.7/ctypes/__init__.py", line 366, in __getattr__
        func = self.__getitem__(name)
      File "/opt/local/Library/Frameworks/Python.framework/Versions/2.7/lib/python2.7/ctypes/__init__.py", line 371, in __getitem__
        func = self._FuncPtr((name_or_ordinal, self))
    AttributeError: dlsym(0x7fff6a41d1e0, setproctitle): symbol not found
    
    https://trac.torproject.org/8266

commit bdbb508ae2ffcaa5480992d33c28ec52a6e61b7e
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Feb 17 20:34:11 2013 -0800

    Making get_process_name()'s ps lookup work on OSX
    
    The get_process_name() function uses a couple approaches to determine our
    process name, the first being to query ps. This tends to work pretty well
    across various platforms (barring Windows, of course), but there's a slight
    difference in the header on OSX/BSD. Accounting for this...
    
    Example ps output:
    
    stem git:(master) : ps -p 60437 -o args
    ARGS
    tor --socksport 9050
    
    Caught by Sathyanarayanan on...
    
    https://trac.torproject.org/8266

commit 08529723708ed514f6f5e2489d3c1be8c0e9ae36
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Feb 17 18:09:58 2013 -0800

    Accounting for NULL access by ctypes
    
    Evidently accessing argc can raise a ValueError...
    
    https://trac.torproject.org/8266

commit 1a099106c43e37bf41f5c1f803f27cd2aad270f5
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Feb 17 13:57:15 2013 -0800

    Providing a string when str() is called on descriptors
    
    Python 2.x gets pretty confused when an object's __str__ method provides a
    unicode string. Calling...
    
    >>> str(desc)
    Traceback (most recent call last):
      File "<stdin>", line 1, in <module>
    UnicodeEncodeError: 'ascii' codec can't encode character u'\xab' in position 28: ordinal not in range(128)
    
    Providing an ascii str in python 2.x and unicode str in python 3.x. Thanks to
    Sathyanarayanan for the catch!

commit d70a2d394f24e471379906e561d80fb47ecd2230
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Feb 17 13:22:54 2013 -0800

    Adding copyright headers
    
    Uggg I hate IP law. As pointed out by Juan on...
    
    https://trac.torproject.org/7954
    
    ... we need copyright headers to properly comply with the requirements of being
    under the LGPL. I'm not looking forward to keeping this up to date (and likely
    won't), but oh well.
    
    I've added the header to all python source files except the unit and integ
    tests (patches welcome if someone wants to spend the time adding those too).
    These headers...
    
    * Declare a copyright from the year of the file's creation to now (2013).
    
    * Include Sean if he worked on it (he is the only contributor that hasn't made
      his contributions public domain to avoid copyright headaches).

commit 4a2e7e74652c2c93654035bede41f203397ed16b
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Feb 17 12:25:43 2013 -0800

    Cleaning up our TODO comments
    
    Several of our TODO comments were no longer relevant or could be expanded.

commit 6927e68d80bf78d898afe321a599bf174e116e40
Author: Damian Johnson <atagar@torproject.org>
Date:   Sat Feb 16 21:53:24 2013 -0800

    Treat descriptor archive contents as individual files
    
    When the descriptor reader encountered an archive and read non-descriptor
    content it stopped reading. This has caused me almost two weeks of headaches in
    troubleshooting...
    
    https://trac.torproject.org/8049
    
    Changing the reader's behaviour to instead handle each file within the archive
    separately. Thanks to Karsten for catching this!

commit f83c7efce3380c60c81028802e198791aa30dfbd
Author: Damian Johnson <atagar@torproject.org>
Date:   Sat Feb 16 10:53:39 2013 -0800

    Adding get_archive_path() method to descriptors
    
    We can't use a TarInfo's 'name' attribute for get_path() since that corresponds
    to its location within the archive. That said, I've often wanted both paths so
    both fixing get_path() for tarballs and adding a get_archive_path().

commit 8cdcb0883f0da8bb492da31cfea7155df5e9efed
Author: Damian Johnson <atagar@torproject.org>
Date:   Fri Feb 15 09:38:02 2013 -0800

    Dropping the 'path' argument from stem.descriptor.parse_file()
    
    File objects have a 'name' attribute that we can use to guess the path. This
    isn't entirely reliable, but nothing is...
    
    http://stackoverflow.com/questions/2458676/absolute-path-of-a-file-object
    
    The path argument was only there to support the descriptor reader. Now that
    parse_file() is something for our users it's nice to get rid of arguments they
    can't use.

commit 2a952ec98054cf656efd5d9b2bffa1960cdf5b42
Author: Damian Johnson <atagar@torproject.org>
Date:   Sat Feb 9 15:29:00 2013 -0800

    Accepting "NEVER" expiration in ADDRMAP events
    
    The expiry value in ADDRMAP events can be 'NEVER'. This is a little troublesome
    since it means that the field might or might not be quoted (making this unique
    among all tor events).
    
    Caught by Desoxy on 'https://trac.torproject.org/8162'.

commit dba169f5cb3d28da29c7c2011ef5de7cc5825d37
Author: Damian Johnson <atagar@torproject.org>
Date:   Sat Feb 9 13:07:23 2013 -0800

    Fixing SingleLineResponse interlinking
    
    The SingleLineResponse class wasn't in the module's __all__, causing it to not
    appear in the sphinx output.

commit 74b60f7552b587ea576db0be01e31e0e5531bb7d
Author: Damian Johnson <atagar@torproject.org>
Date:   Sat Feb 9 12:53:31 2013 -0800

    Improving stem.response.convert() pydocs
    
    The convert() pydocs were pretty clunky. Replacing the listing with a nice
    table mapping the response_type to classes, like what we do elsewhere.

commit 5f8b7b4231bcda7f69296821aa6417fd3e2ce5f3
Author: Damian Johnson <atagar@torproject.org>
Date:   Sat Feb 9 12:35:11 2013 -0800

    Adding a ControlMessage.from_str() function
    
    In discussions with Mike about using stem for txtorcon a major use has been
    response parsing. Using stem for this is dead easy, but requires a hack. Adding
    a function to negate the need for hackery.

commit f96d5f64a94ecfa9d05b80e2b3a6c7c3ba78bcea
Author: Damian Johnson <atagar@torproject.org>
Date:   Fri Feb 8 08:32:44 2013 -0800

    Noting '(Tor_internal)' addresses in the pydocs
    
    Noting that StreamEvents can have '(Tor_internal)' as a target address.
    
    Spec change:
    https://gitweb.torproject.org/torspec.git/commitdiff/3ad9d19e03bd816e1e0f0b9eeb839ee1eedcaedf

commit ea5212863a97efa4f29e47280faf3c9566ec5349
Author: Damian Johnson <atagar@torproject.org>
Date:   Fri Feb 8 08:29:22 2013 -0800

    Using numeric 'flag-thresholds' values
    
    Now that the spec has been revised to specify numeric values we can provide
    'flag => int/float' mappings (which are much nicer for our users).
    
    Spec change:
    https://gitweb.torproject.org/torspec.git/commitdiff/52d0eb4858ad3eb191df3afe324f43683467ae22

commit e8784466401a8120669128682b75eaa947e91c7a
Author: Damian Johnson <atagar@torproject.org>
Date:   Wed Feb 6 07:46:22 2013 -0800

    Minor stylistic corrections
    
    Couple PEP8 bugs that slipped in concerning spacing between code and inline
    comments.

commit 3687dde657dc8df40ffecadd45c4035ee3d44110
Author: Damian Johnson <atagar@torproject.org>
Date:   Wed Feb 6 07:41:30 2013 -0800

    Avoiding static /tmp usage
    
    Our tests had static /tmp paths at a couple places. Issue caught by Dererk and
    patch by Abhishek...
    
    https://trac.torproject.org/7926

commit 4e8aaa4daadb02db1686dde57c42c15aef6821e9
Author: Damian Johnson <atagar@torproject.org>
Date:   Tue Feb 5 09:48:12 2013 -0800

    Support for 'flag-thresholds' lines in network status votes
    
    Parsing the new 'flag-thresholds' in network status votes - thanks to Karsten
    for pointing this out.
    
    metrics-lib change:
    https://gitweb.torproject.org/metrics-lib.git/commitdiff/c2a0dbf8bf100a19660ad512b88d93f3d7c18a1e
    
    dir-spec addition:
    https://trac.torproject.org/8165

commit c6a9cde0f4eb5c627f5ba41f9d263be0c5854ae8
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Feb 3 22:14:20 2013 -0800

    Allowing for IPv4 'a' lines in router status entries
    
    Karsten reports on ticket #8036 that IPv4 addresses are indeed allowed on a
    router status entry's 'a' line. This is a little unfortunate since it means a
    less friendly attribute but not a big whoop.

commit b8baf77c13154ccb6c43299a36979d812ca7b8be
Author: Karsten Loesing <karsten.loesing@gmx.net>
Date:   Mon Feb 4 06:17:28 2013 +0100

    Try to make minor descriptor versions clearer.

commit 6c99a28e83490537615de9388484c574aa1b85dd
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Feb 3 20:43:28 2013 -0800

    Using port lists for addresses_v6 rather than ranges
    
    Huh, I wonder where I got the idea that 'a' lines had port ranges. Dropping
    that. According to the spec the 'a' lines should be parsed in the same way as
    'or-address'. However, I suspect that the spec is a little off here - checking
    if it can contain IPv4 addresses...
    
    Caught by Karsten on...
    
    https://trac.torproject.org/8036

commit d44018a5566fe5c92a326a413768bdd8462c425e
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Feb 3 20:01:35 2013 -0800

    Renaming check_whitespace.py to static_checks.py
    
    The check_whitespace.py module no longer... well, checks whitespace. Rather, it
    has become a dumping ground for all of the static checks that we do. Renaming
    it to something more appropriate.

commit ea0b73a5aa221fadafc2ba718a0ef42e151e5ad6
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Feb 3 13:00:56 2013 -0800

    Providing alternative methods for parsing a NetworkStatusDocument
    
    Adding support in both the DescriptorReader and parse_file() function for three
    ways of parsing network status documents...
    
    a. Provide the router status entries (ie. the current behavior).
    
    b. Provide the document itself with the router status entries that it contains.
       This has the biggest cost in terms of upfront parsing time and memory usage,
       but provides the caller with everything they might want.
    
    c. Provide the document but skip reading the router status entries. A handy
       option of you just care about the document's header/footer.
    
    Now that we have these capability I'm further simplifying the descriptor API a
    bit. The network status docs encouraged users to use the NetworkStatusDocument
    constructors to achieve option 'b' above, but now that it's in the reader and
    parse_file() there's no reason for them to do that.
    
    Users should now *always* use either the DescriptorReader or parse_file(). If
    they don't then they're off the reservation.

commit 479f535614081f097ee2e39ecde70ffaf658ba25
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Feb 3 11:29:53 2013 -0800

    Dropping Version.meets_requirements() in favour of comparisons
    
    Once upon a time you checked your requirements via simple comparisons...
    
      if my_version >= requirement:
        ... do stuff...
    
    I reluctantly changed this to a meets_requirements() method when we added the
    VersionRequirements class since it was no longer simple comparisons the __cmp__
    method could handle. However, now that we're using rich comparison operators we
    can go back to the nicer style of comparisons. Apologies for any confusion
    this back-and-forth has caused.

commit 30146d77243f7a25d54019d9d2641be258c444f8
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Feb 3 11:12:57 2013 -0800

    More succinct python 3 warning for parse_file()
    
    Read speeds and universal newline translation are both addressed by reading in
    binary mode. There's no need to have a separate warning for each.

commit 9cd4c9feb479fe00987526c272a1b2a1853bd295
Author: Damian Johnson <atagar@torproject.org>
Date:   Sat Feb 2 12:23:07 2013 -0800

    Using binary mode for the controller socket file
    
    Yay! Now that I have a version of python 3 that doesn't segfault I can finish
    making our integ tests work.
    
    The socket file used for controller connections should be normalized to use
    binary mode. This is its behavior in python 2.x, and in 3.x having it in text
    mode can cause sadness.
    
    Exception in thread Tor Listener:
    Traceback (most recent call last):
      File "/home/atagar/Desktop/Python-3.3.0/Lib/threading.py", line 639, in _bootstrap_inner
        self.run()
      File "/home/atagar/Desktop/Python-3.3.0/Lib/threading.py", line 596, in run
        self._target(*self._args, **self._kwargs)
      File "/home/atagar/Desktop/stem/test/data/python3/stem/control.py", line 573, in _reader_loop
        control_message = self._socket.recv()
      File "/home/atagar/Desktop/stem/test/data/python3/stem/socket.py", line 115, in recv
        return recv_message(socket_file)
      File "/home/atagar/Desktop/stem/test/data/python3/stem/socket.py", line 539, in recv_message
        line = control_file.readline()
      File "/home/atagar/Desktop/Python-3.3.0/Lib/codecs.py", line 300, in decode
        (result, consumed) = self._buffer_decode(data, self.errors, final)
    UnicodeDecodeError: 'utf-8' codec can't decode byte 0xc3 in position 2005: invalid continuation byte
    
    After addressing this and a few encoding issues the controller integ tests now
    pass, but after we're done testing python spews out a dump following...
    
    *** glibc detected *** python3: munmap_chunk(): invalid pointer: 0x097f1620 ***
    
    At this point I'm pretty well persuaded that the python 3.x series leaves
    something to be desired in terms of stability.

commit 3930f1f1eda99bcf22fe574b95665f8ef47ffdc4
Merge: 7921a46 2b2a645
Author: Damian Johnson <atagar@torproject.org>
Date:   Sat Feb 2 10:12:02 2013 -0800

    Python 3.x support
    
    Adding support for the python 3.x series. You can install the python 3 version
    of stem by running...
    
    python3 setup.py install
    
    The 2to3 conversion can be tested trough run_tests.py with the '--python3'
    argument. It passes all of the unit tests and the integ tests... er, don't
    technically fail. However, python 3.2 has a bug causing a segfault when it gets
    to the BaseController integ tests. Filed a ticket about it...
    
    http://bugs.python.org/issue17105
    
    However, stem's descriptor functionality checks out and this issue has likely
    been addressed in later python releases so there's little point to hold off on
    merging.
    
    Ticket for python 3 support...
    
    https://trac.torproject.org/7843

commit 2b2a645ac778570d99961f9b9592769fdc9caa10
Author: Damian Johnson <atagar@torproject.org>
Date:   Fri Feb 1 07:48:21 2013 -0800

    Converting cookie auth token to unicode
    
    Well, this is dumb. Making a formatted string with ascii bytes includes the b''
    wrapper in python 3. This broke our authentication calls, making calls like...
    
    AUTHENTICATE b'd55e81eb9c3a1e22a2db919ec2efd22df4aeb88ee0ab3d10e64dbb2450d06921'
    
    Converting the token to unicode to avoid this.
    
    ======================================================================
    ERROR: test_authenticate_cookie
    ----------------------------------------------------------------------
    Traceback:
      File "/home/atagar/Desktop/stem/test/data/python3/test/integ/connection/authentication.py", line 400, in _check_auth
        stem.connection.authenticate_cookie(control_socket, auth_arg)
      File "/home/atagar/Desktop/stem/test/data/python3/stem/connection.py", line 604, in authenticate_cookie
        raise CookieAuthRejected(str(auth_response), cookie_path, False, auth_response)
    stem.connection.CookieAuthRejected: Invalid hexadecimal encoding.  Maybe you tried a plain text password?  If so, the standard requires that you put it in double quotes.
    
    During handling of the above exception, another exception occurred:
    
    Traceback:
      File "/home/atagar/Desktop/stem/test/data/python3/test/integ/connection/authentication.py", line 303, in test_authenticate_cookie
        self._check_auth(auth_type, auth_value)
      File "/home/atagar/Desktop/stem/test/data/python3/test/integ/connection/authentication.py", line 411, in _check_auth
        failure_msg = _get_auth_failure_message(auth_type)
      File "/home/atagar/Desktop/stem/test/data/python3/test/integ/connection/authentication.py", line 99, in _get_auth_failure_message
        raise ValueError("No methods of authentication. If this is an open socket then auth shouldn't fail.")
    ValueError: No methods of authentication. If this is an open socket then auth shouldn't fail.

commit 384411b26dd140e3d4b181f3c2b1a48057238096
Author: Damian Johnson <atagar@torproject.org>
Date:   Fri Feb 1 07:16:25 2013 -0800

    Replacing file() with open()
    
    I'm not sure why we were using file() at one point rather than open(), but it
    makes python 3 sad...
    
    ======================================================================
    ERROR: test_authenticate_cookie
    ----------------------------------------------------------------------
    Traceback:
      File "/home/atagar/Desktop/stem/test/data/python3/test/integ/connection/authentication.py", line 303, in test_authenticate_cookie
        self._check_auth(auth_type, auth_value)
      File "/home/atagar/Desktop/stem/test/data/python3/test/integ/connection/authentication.py", line 400, in _check_auth
        stem.connection.authenticate_cookie(control_socket, auth_arg)
      File "/home/atagar/Desktop/stem/test/data/python3/stem/connection.py", line 583, in authenticate_cookie
        cookie_data = _read_cookie(cookie_path, False)
      File "/home/atagar/Desktop/stem/test/data/python3/stem/connection.py", line 877, in _read_cookie
        with file(cookie_path, 'rb', 0) as f:
    NameError: global name 'file' is not defined

commit a047a74abef0dc9fedf463c093c14defe958d81b
Author: Damian Johnson <atagar@torproject.org>
Date:   Fri Feb 1 07:12:04 2013 -0800

    Accounting for ascii/unicode for network status documents
    
    Woohoo! Last descriptor type. Unlike the other descriptor types callers are
    encouraged to sometimes use our NetworkStatusDocument classes directly so
    swapping the input to unicode if we get ascii.
    
    With this all of the descriptor integ tests now pass with python 3!

commit 284797ace4cf0b8e4469454b65809fc66c7ae1d2
Author: Damian Johnson <atagar@torproject.org>
Date:   Fri Feb 1 06:57:54 2013 -0800

    Pydoc missing version from descriptor type listing
    
    The 'network-status-microdesc-consensus-3' listing was missing the '1.0'.

commit 4815afe52c4af2d4cb3d687b35b7012239d7471b
Author: Damian Johnson <atagar@torproject.org>
Date:   Thu Jan 31 09:54:27 2013 -0800

    Using stem.descriptor.parse_file() for extrainfo integ tests
    
    Going through parse_file() so we do the proper unicode conversion.
    
    ======================================================================
    ERROR: test_cached_descriptor
    ----------------------------------------------------------------------
    Traceback:
      File "/home/atagar/Desktop/stem/test/data/python3/test/integ/descriptor/extrainfo_descriptor.py", line 150, in test_cached_descriptor
        for desc in stem.descriptor.extrainfo_descriptor._parse_file(descriptor_file):
      File "/home/atagar/Desktop/stem/test/data/python3/stem/descriptor/extrainfo_descriptor.py", line 155, in _parse_file
        extrainfo_content = stem.descriptor._read_until_keywords("router-signature", descriptor_file)
      File "/home/atagar/Desktop/stem/test/data/python3/stem/descriptor/__init__.py", line 350, in _read_until_keywords
        line_match = KEYWORD_LINE.match(line)
    TypeError: can't use a string pattern on a bytes-like object

commit 3afa4346d102d99eab93929be738cdb594105d9b
Author: Damian Johnson <atagar@torproject.org>
Date:   Thu Jan 31 09:44:18 2013 -0800

    Using binary mode when reading descriptors
    
    Now Damian, repleat after me: text mode is bad.
    
    In python 2.x text mode and binary mode seem to be indistinguishable, but in
    python 3 there's one tiny little difference: text mode is around 33x slower.
    The integ test that read the cached-consensus took over five minutes (by
    comparison to ten seconds with python 2.7), and in one case simply hung for
    twenty minutes before I killed it.
    
    I'm not aware of any disadvantage to using binary mode, so opting for that.

commit d9d46cb5b35f586bcf8025cb7682c4ad79e57e15
Author: Damian Johnson <atagar@torproject.org>
Date:   Thu Jan 31 08:31:53 2013 -0800

    Skipping deletion of pyc in __pycache__
    
    I disabled the deletion of orphaned pyc files when testing python 3 but on
    reflection that wasn't enough. Python 2.x test runs still delete the python 3
    bytecode. Changing the orphaned check to skip those files.

commit bec2e9721e228f73c8b1438f1d398182893df27f
Author: Damian Johnson <atagar@torproject.org>
Date:   Thu Jan 31 08:22:38 2013 -0800

    Fixing server descriptor test expecting unicode
    
    One of the server descriptor integ tests had a failing assertion because the
    expected text was ASCII bytes and the descriptor content was unicode. Fixing
    the test and moving the to_unicode helper to str_tools where it belongs.
    
    ======================================================================
    FAIL: test_non_ascii_descriptor
    ----------------------------------------------------------------------
    Traceback:
      File "/home/atagar/Desktop/stem/test/data/python3/test/integ/descriptor/server_descriptor.py", line 221, in test_non_ascii_descriptor
        self.assertEquals(expected_contact, desc.contact)
    AssertionError: '2048R/F171EC1F Johan BlÃ¥bÃ¤ck ã\x81\x93ã\x82\x93ã\x81«ã\x81¡ã\x81¯' != '2048R/F171EC1F Johan Blåbäck こんにちは'
    - 2048R/F171EC1F Johan BlÃ¥bÃ¤ck ããã«ã¡ã¯
    + 2048R/F171EC1F Johan Blåbäck こんにちは

commit f4ee5ab36ee512f7cb904bb371f593f7e2f1f8a6
Author: Damian Johnson <atagar@torproject.org>
Date:   Wed Jan 30 09:39:45 2013 -0800

    Checking that to_bytes has unicode before converting
    
    Adding a check to the to_bytes() helper so we don't attempt to convert ASCII
    bytes to ASCII bytes (which doesn't work so well).
    
    ======================================================================
    ERROR: test_old_descriptor
    ----------------------------------------------------------------------
    Traceback:
      File "/home/atagar/Desktop/stem/test/data/python3/test/integ/descriptor/server_descriptor.py", line 120, in test_old_descriptor
        desc = stem.descriptor.server_descriptor.RelayDescriptor(descriptor_contents)
      File "/home/atagar/Desktop/stem/test/data/python3/stem/descriptor/server_descriptor.py", line 642, in __init__
        self._validate_content()
      File "/home/atagar/Desktop/stem/test/data/python3/stem/descriptor/server_descriptor.py", line 687, in _validate_content
        key_der_as_hash = hashlib.sha1(stem.util.str_tools.to_bytes(key_as_bytes)).hexdigest()
      File "/home/atagar/Desktop/stem/test/data/python3/stem/util/str_tools.py", line 73, in to_bytes
        return _to_bytes(msg)
      File "/home/atagar/Desktop/stem/test/data/python3/stem/util/str_tools.py", line 54, in _to_bytes
        return codecs.latin_1_encode(msg)[0]
    TypeError: Can't convert 'bytes' object to str implicitly

commit 46f1bfb98cee79f9a00b76513d2c70df1824bb33
Author: Damian Johnson <atagar@torproject.org>
Date:   Wed Jan 30 09:36:09 2013 -0800

    Changing is_python_2* prereq checks to include python 3
    
    The is_python_26 and is_python_27 were checking if we were 2.6-2.x or 2.7-2.x.
    On reflection it makes more sense for these to be '2.y and above' checks rather
    than '2.y and above in the 2.x series'.

commit 6c855996c0daed3b6db222996dd651534c134c0d
Author: Damian Johnson <atagar@torproject.org>
Date:   Wed Jan 30 09:32:03 2013 -0800

    Providing ASCII bytes to hashlib.sha1()
    
    Another unicode/ASCII bytes conversion issue...
    
    ======================================================================
    ERROR: test_metrics_descriptor
    ----------------------------------------------------------------------
    Traceback:
      File "/home/atagar/Desktop/stem/test/data/python3/test/integ/descriptor/server_descriptor.py", line 89, in test_metrics_descriptor
        self.assertEquals("2C7B27BEAB04B4E2459D89CA6D5CD1CC5F95A689", desc.digest())
      File "/home/atagar/Desktop/stem/test/data/python3/stem/descriptor/server_descriptor.py", line 666, in digest
        digest_hash = hashlib.sha1(for_digest)
    TypeError: Unicode-objects must be encoded before hashing

commit 9ff618eebed92e5646090ce3faa802763a5f7720
Author: Damian Johnson <atagar@torproject.org>
Date:   Wed Jan 30 09:10:18 2013 -0800

    Skipping newline translation for descriptor integ tests
    
    Using a custom open() call for python 3's integ tests to prevent newline
    translation (and the resulting test failures).

commit 8a3cfb57e1982d26bafe6289f8ed9dea47192604
Author: Damian Johnson <atagar@torproject.org>
Date:   Wed Jan 30 08:53:06 2013 -0800

    Checking for 2to3 and python3 when needed
    
    Warning the user if 2to3 or python3 aren't in our PATH when the user provides
    the '--python3' testing argument.

commit 0288267be5a325aadd078a487751cf4ce83a2f73
Author: Damian Johnson <atagar@torproject.org>
Date:   Wed Jan 30 08:24:59 2013 -0800

    Skip universal newline translation in descriptor reader
    
    Python 3 introduces universal newline translation, converting '\n', '\r', and
    '\r\n' into the local system's newline style. This is a really neat feature and
    will solve many-a-headaches... but not for us. We conform to the tor spec which
    specifies when CRLF appears verses other newline types.
    
    Universal newline translation broke our ability to read the
    'cr_in_contact_line' example which has multiple '\r' within a contact line
    (https://trac.torproject.org/5637). Fixing the reader to disable newline
    translation and adding a warning to our parse_file() pydocs.

commit d0f4a0c429b1e3a2bead48403605bb361ec66832
Author: Damian Johnson <atagar@torproject.org>
Date:   Wed Jan 30 08:07:50 2013 -0800

    Adding --python3 to the run_tests.py help output

commit b4c4835d957463d6a453d9d7f7ad6007627abc96
Author: Damian Johnson <atagar@torproject.org>
Date:   Tue Jan 29 09:03:30 2013 -0800

    Normalizing descriptor handling as unicode
    
    Our python 3 descriptor integration tests were having troubles due to the
    ASCII/unicode switch. Adding a file interceptor so we always parse descriptors
    as unicode.
    
    Yes, yes, I know. Ewwww. I definitely don't like the _UnicodeReader helper so
    suggestions welcome for an alternative.

commit 9d53a2854178d12222480958795876e45ec0f1d6
Author: Damian Johnson <atagar@torproject.org>
Date:   Tue Jan 29 08:54:03 2013 -0800

    Improving error output for test_skip_nondescriptor_contents
    
    The descriptor reader's test_skip_nondescriptor_contents integ test is
    especially tickle since it can fail whenever there's new non-descriptor content
    in the test/integ/descriptor/data directory.
    
    Improving its error output to say what it expected and got rather than simply
    saying that the counts mismatch.

commit e99dc2b618cb33d5e23166510d224429b8f67046
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Jan 27 19:53:32 2013 -0800

    Accounting for tarfile.is_tarfile() raising AttributeErrors
    
    When we lack read permissions the tarfile.is_tarfile() funcion raises an
    AttributeError with python 3 (rather than an IOError as it does with python 2).
    This is most likely a bug...
    
    http://bugs.python.org/issue17059
    
    Working around it for now.

commit 313e5251da4a390fa283c440ffbe0f0ef048ed38
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Jan 27 19:31:42 2013 -0800

    Skipping orphaned file check if testing with python 3
    
    The orphaned *.pyc check is both broken with python 3 and pointless since it's
    an exported copy of the python 2 codebase (we're not acually making changes to
    it).

commit 2850199fc513fc4a276e16eaa59ccbc2dc69ea23
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Jan 27 19:21:20 2013 -0800

    Process renaming requires ASCII bytes
    
    Yet another unicode/ASCII compatability issue...
    
    ======================================================================
    ERROR: test_set_process_name
    ----------------------------------------------------------------------
    Traceback:
      File "/home/atagar/Desktop/stem/test/data/python3/test/integ/util/system.py", line 409, in test_set_process_name
        stem.util.system.set_process_name("stem_integ")
      File "/home/atagar/Desktop/stem/test/data/python3/stem/util/system.py", line 764, in set_process_name
        _set_prctl_name(process_name)
      File "/home/atagar/Desktop/stem/test/data/python3/stem/util/system.py", line 809, in _set_prctl_name
        name_buffer.value = process_name
    TypeError: str/bytes expected instead of str instance
    
    During handling of the above exception, another exception occurred:
    
    Traceback:
      File "/home/atagar/Desktop/stem/test/data/python3/test/integ/util/system.py", line 412, in test_set_process_name
        stem.util.system.set_process_name(initial_name)
      File "/home/atagar/Desktop/stem/test/data/python3/stem/util/system.py", line 764, in set_process_name
        _set_prctl_name(process_name)
      File "/home/atagar/Desktop/stem/test/data/python3/stem/util/system.py", line 809, in _set_prctl_name
        name_buffer.value = process_name
    TypeError: str/bytes expected instead of str instance

commit 7d1e8a4ffc08ca3b5e7fb34d3b025ec3c8755497
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Jan 27 19:08:40 2013 -0800

    Returning unicode from stem.util.system.call()
    
    The call() method is the basic call for shelling out and, like tor's stdout
    earlier, its output was ASCII bytes. This is fine in python 2.x, but causes
    problems for python 3.x. Both are fine with this being unicode output so going
    with that.
    
    ======================================================================
    ERROR: test_get_cwd
    ----------------------------------------------------------------------
    Traceback:
      File "/home/atagar/Desktop/stem/test/data/python3/test/integ/util/system.py", line 334, in test_get_cwd
        self.assertEquals(None, stem.util.system.get_cwd(99999))
      File "/home/atagar/Desktop/stem/test/data/python3/stem/util/system.py", line 528, in get_cwd
        elif results[0].endswith("No such process"):
    TypeError: expected an object with the buffer interface

commit 6a85a34c753f34c7cc79f4ad4e9f67d92bce1046
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Jan 27 19:01:32 2013 -0800

    Converting str stats for proc tests
    
    The proc tests were comparing strings with floats. It coincidentally passed,
    but wasn't really testing what we wanted. In python 3.x the comparisons fail
    due to the type mismatch.
    
    ======================================================================
    ERROR: test_get_stats
    ----------------------------------------------------------------------
    Traceback:
      File "/home/atagar/Desktop/stem/test/data/python3/test/integ/util/proc.py", line 74, in test_get_stats
        self.assertTrue(utime > 0)
    TypeError: unorderable types: str() > int()

commit c2b92450016ccfbe46edec151136c8a8a9f694cb
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Jan 27 18:18:45 2013 -0800

    Disabling newline translation in our socket
    
    In python 3 the socket file object tries to be helpful by translating newline
    characters. By default '\n', '\r', and '\r\n' are all translated to '\n'. Tor
    uses '\r\n' newlines and we check for this so disabling universal newline
    translation.
    
    ======================================================================
    ERROR: test_get_pid_by_port_netstat
    ----------------------------------------------------------------------
    Traceback:
      File "/home/atagar/Desktop/stem/test/data/python3/stem/connection.py", line 321, in authenticate
        protocolinfo_response = get_protocolinfo(controller)
      File "/home/atagar/Desktop/stem/test/data/python3/stem/connection.py", line 800, in get_protocolinfo
        protocolinfo_response = _msg(controller, "PROTOCOLINFO 1")
      File "/home/atagar/Desktop/stem/test/data/python3/stem/connection.py", line 837, in _msg
        return controller.recv()
      File "/home/atagar/Desktop/stem/test/data/python3/stem/socket.py", line 114, in recv
        return recv_message(socket_file)
      File "/home/atagar/Desktop/stem/test/data/python3/stem/socket.py", line 511, in recv_message
        raise stem.ProtocolError("All lines should end with CRLF")
    stem.ProtocolError: All lines should end with CRLF
    
    During handling of the above exception, another exception occurred:
    
    Traceback:
      File "/home/atagar/Desktop/stem/test/data/python3/test/integ/util/system.py", line 245, in test_get_pid_by_port_netstat
        elif not runner.is_ptraceable():
      File "/home/atagar/Desktop/stem/test/data/python3/test/runner.py", line 413, in is_ptraceable
        tor_version = self.get_tor_version()
      File "/home/atagar/Desktop/stem/test/data/python3/test/runner.py", line 567, in get_tor_version
        control_socket = self.get_tor_socket()
      File "/home/atagar/Desktop/stem/test/data/python3/test/runner.py", line 534, in get_tor_socket
        stem.connection.authenticate(control_socket, CONTROL_PASSWORD, self.get_chroot())
      File "/home/atagar/Desktop/stem/test/data/python3/stem/connection.py", line 323, in authenticate
        raise IncorrectSocketType("unable to use the control socket")
    stem.connection.IncorrectSocketType: unable to use the control socket

commit 6219ed6e6c517e0ce7d25b5d54355ed85329615e
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Jan 27 18:02:49 2013 -0800

    Making sure that the socket's file is writeable
    
    In python 2.x the socket.makefile() method *should* only be readable
    (according to the default argument) but I've been using it for write operations
    too all this time. In python 3.x doing this raises "io.UnsupportedOperation:
    not writable" so guess we gotta fix it now. :)
    
    ======================================================================
    ERROR: test_get_connections
    ----------------------------------------------------------------------
    Traceback:
      File "/home/atagar/Desktop/stem/test/data/python3/test/integ/util/proc.py", line 92, in test_get_connections
        elif not test.runner.get_runner().is_ptraceable():
      File "/home/atagar/Desktop/stem/test/data/python3/test/runner.py", line 413, in is_ptraceable
        tor_version = self.get_tor_version()
      File "/home/atagar/Desktop/stem/test/data/python3/test/runner.py", line 567, in get_tor_version
        control_socket = self.get_tor_socket()
      File "/home/atagar/Desktop/stem/test/data/python3/test/runner.py", line 534, in get_tor_socket
        stem.connection.authenticate(control_socket, CONTROL_PASSWORD, self.get_chroot())
      File "/home/atagar/Desktop/stem/test/data/python3/stem/connection.py", line 321, in authenticate
        protocolinfo_response = get_protocolinfo(controller)
      File "/home/atagar/Desktop/stem/test/data/python3/stem/connection.py", line 800, in get_protocolinfo
        protocolinfo_response = _msg(controller, "PROTOCOLINFO 1")
      File "/home/atagar/Desktop/stem/test/data/python3/stem/connection.py", line 836, in _msg
        controller.send(message)
      File "/home/atagar/Desktop/stem/test/data/python3/stem/socket.py", line 82, in send
        send_message(self._socket_file, message, raw)
      File "/home/atagar/Desktop/stem/test/data/python3/stem/socket.py", line 422, in send_message
        control_file.write(message)
    io.UnsupportedOperation: not writable

commit 1e2e6204eb8ba618e79c7bb1459e53e5154147fa
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Jan 27 17:43:22 2013 -0800

    Socket closures raise a ValueError in python 3
    
    Evidently reading from a closed socket file raises a ValueError rather than
    socket.error in python 3...
    
    Exception in thread Tor Listener:
    Traceback (most recent call last):
      File "/usr/lib/python3.2/threading.py", line 736, in _bootstrap_inner
        self.run()
      File "/usr/lib/python3.2/threading.py", line 689, in run
        self._target(*self._args, **self._kwargs)
      File "stem/control.py", line 573, in _reader_loop
        control_message = self._socket.recv()
      File "stem/socket.py", line 114, in recv
        return recv_message(socket_file)
      File "stem/socket.py", line 467, in recv_message
        line = control_file.readline()
      File "/usr/lib/python3.2/socket.py", line 269, in readinto
        self._checkClosed()
    ValueError: I/O operation on closed file.

commit 7507edec828603a860d9ebf0cbb049060d32fc3e
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Jan 27 17:41:08 2013 -0800

    Converting tor initialization lines to unicode
    
    The stdout of the tor process is an ASCII byte stream, causing our following
    regex search() call to error.

commit 8b95332960e5343dd9b716ef25682548f0de9d7e
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Jan 27 16:32:06 2013 -0800

    Mocking for open() broken in python 3
    
    In python 2.x there's both __builtin__.open() and io.open(), but in python 3.x
    there's just io.open() (which is aliased by builtin). Accounting for this when
    we mock it for the descriptor reader unit tests.
    
    I'm a little puzzled why the mocking wasn't failing more spectacularly before
    (the __builtin__ import should always fail on python 3), but oh well - fixed
    now.
    
    With this the unit tests finally pass with python 3!!!
    
    ======================================================================
    ERROR: test_load_processed_files
    ----------------------------------------------------------------------
    Traceback:
      File "/home/atagar/Desktop/stem/test/data/python3/test/unit/descriptor/reader.py", line 52, in test_load_processed_files
        self.assertEquals(expected_value, stem.descriptor.reader.load_processed_files(""))
      File "/home/atagar/Desktop/stem/test/data/python3/stem/descriptor/reader.py", line 179, in load_processed_files
        with open(path) as input_file:
    IOError: [Errno 2] No such file or directory: ''
    
    ======================================================================
    FAIL: test_get_connections
    ----------------------------------------------------------------------
    Traceback:
      File "/home/atagar/Desktop/stem/test/data/python3/test/unit/util/proc.py", line 171, in test_get_connections
        self.assertEquals(expected_results, proc.get_connections(pid))
    AssertionError: Lists differ: [('17.17.17.17', 4369, '34.34.... != []
    
    First list contains 2 additional elements.
    First extra element 0:
    ('17.17.17.17', 4369, '34.34.34.34', 8738)
    
    + []
    - [('17.17.17.17', 4369, '34.34.34.34', 8738),
    - ]

commit 8d5d2f14edf92c7240aae0b7894fea6e27b41699
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Jan 27 16:17:34 2013 -0800

    Converted _required_fields() encounter TypeErrors
    
    The server and extrainfo descriptors' _required_fields() functions get
    converted by 2to3 into a line that tries to concatenate a list with a tuple
    (raising a TypeError). On reflection the converted version which uses list
    comprehension is a little nicer than filter(), so using a variant of that which
    makes everyone happy.

commit 264c9e673f71dde707a03ec6b24931f1bd0f3fa4
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Jan 27 16:02:06 2013 -0800

    Accounting for different exception type from base64.b64decode()
    
    When the base64.b64decode() function encounters a value with malformed padding
    it raises a TypeError in python 2.x and a binascii.Error in python 3.x.
    
    ======================================================================
    ERROR: test_malformed_fingerprint
    ----------------------------------------------------------------------
    Traceback:
      File "/home/atagar/Desktop/stem/test/data/python3/test/unit/descriptor/router_status_entry.py", line 231, in test_malformed_fingerprint
        self._expect_invalid_attr(content, "fingerprint")
      File "/home/atagar/Desktop/stem/test/data/python3/test/unit/descriptor/router_status_entry.py", line 525, in _expect_invalid_attr
        entry = RouterStatusEntryV3(content, False)
      File "/home/atagar/Desktop/stem/test/data/python3/stem/descriptor/router_status_entry.py", line 330, in __init__
        super(RouterStatusEntryV3, self).__init__(content, validate, document)
      File "/home/atagar/Desktop/stem/test/data/python3/stem/descriptor/router_status_entry.py", line 150, in __init__
        self._parse(entries, validate)
      File "/home/atagar/Desktop/stem/test/data/python3/stem/descriptor/router_status_entry.py", line 337, in _parse
        _parse_r_line(self, value, validate, True)
      File "/home/atagar/Desktop/stem/test/data/python3/stem/descriptor/router_status_entry.py", line 496, in _parse_r_line
        desc.fingerprint = _decode_fingerprint(r_comp[1], validate)
      File "/home/atagar/Desktop/stem/test/data/python3/stem/descriptor/router_status_entry.py", line 703, in _decode_fingerprint
        identity_decoded = base64.b64decode(stem.util.str_tools.to_bytes(identity))
      File "/usr/lib/python3.2/base64.py", line 92, in b64decode
        return binascii.a2b_base64(s)
    binascii.Error: Incorrect padding

commit cc3f1be711665ab203f8a657a8400e2828bb9aef
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Jan 27 13:41:01 2013 -0800

    Dropping direct __dict__ usage
    
    Using an object's __dict__ attribute is generally thought to be a bad idea, and
    indeed it bites us from time to time. Functions like hasattr(), getattr(),
    setattr(), and vars() makes direct __dict__ usage unnecessary. This also fixes
    a python 3 mocking issue...
    
    ======================================================================
    ERROR: test_examples
    ----------------------------------------------------------------------
    Traceback:
      File "/home/atagar/Desktop/stem/test/data/python3/test/unit/descriptor/networkstatus/document_v3.py", line 129, in test_examples
        with support_with(io.StringIO(content)) as consensus_file:
      File "/home/atagar/Desktop/stem/test/data/python3/test/mocking.py", line 303, in support_with
        obj.__dict__["__enter__"] = return_value(obj)
    AttributeError: '_io.StringIO' object has no attribute '__dict__'

commit de9ac90b6db59f29a42453b829a66dff7b3b1767
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Jan 27 13:17:48 2013 -0800

    NetworkStatus' meets_consensus_method() comparisons didn't account for None
    
    Another spot where comparison with None fails with python 3...
    
    ======================================================================
    ERROR: test_with_directory_authorities
    ----------------------------------------------------------------------
    Traceback:
      File "/home/atagar/Desktop/stem/test/data/python3/test/unit/descriptor/networkstatus/document_v3.py", line 800, in test_with_directory_authorities
        document = NetworkStatusDocumentV3(content)
      File "/home/atagar/Desktop/stem/test/data/python3/stem/descriptor/networkstatus.py", line 509, in __init__
        self._footer = _DocumentFooter(document_file, validate, self._header)
      File "/home/atagar/Desktop/stem/test/data/python3/stem/descriptor/networkstatus.py", line 776, in __init__
        if header.meets_consensus_method(9):
      File "/home/atagar/Desktop/stem/test/data/python3/stem/descriptor/networkstatus.py", line 581, in meets_consensus_method
        return bool(self.consensus_method >= method or [x for x in self.consensus_methods if x >= method])
    TypeError: unorderable types: NoneType() >= int()

commit b96f434623cd829dc8e143e1e685167facad4e22
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Jan 27 12:51:57 2013 -0800

    Python 3 can't do comparison with other types
    
    Another change in python 2 => 3 is that comparison ('<' and '>') can no longer
    work with None, ints, and other types...
    
    In python 2:
    
    >>> 5 > None
    True
    
    In python 3:
    
    >>> 5 > None
    Traceback (most recent call last):
      File "<stdin>", line 1, in <module>
    TypeError: unorderable types: int() > NoneType()
    
    I expected the 'unorderable types' error would cause it to use the Version's
    comparison function but evidently that's not the case. Rather, when using
    python 3 callers need to check the values' type first (there's nothing we can
    do to make the comparison work). Personally I think that this is pretty stupid,
    but that's the workaround done by python devs on...
    
    http://bugs.python.org/issue13545
    
    Oh well. Dropping the test that comparison with None and ints work.
    
    ======================================================================
    ERROR: test_nonversion_comparison
    ----------------------------------------------------------------------
    Traceback:
      File "/home/atagar/Desktop/stem/test/data/python3/test/unit/version.py", line 125, in test_nonversion_comparison
        self.assertTrue(test_version > None)
    TypeError: unorderable types: Version() > NoneType()
    
    ----------------------------------------------------------------------
    Ran 9 tests in 0.043s

commit 4ccbe411ff3320a09e21baa44280c357fd44df6e
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Jan 27 12:41:50 2013 -0800

    The min/max() functions can't accept None in python 3
    
    In python 2:
    
    >>> max(5, None)
    5
    
    In python 3:
    
    >>> max(5, None)
    Traceback (most recent call last):
    File "<stdin>", line 1, in <module>
    TypeError: unorderable types: NoneType() > int()
    
    ======================================================================
    ERROR: test_comparison
    ----------------------------------------------------------------------
    Traceback:
      File "/home/atagar/Desktop/stem/test/data/python3/test/unit/version.py", line 107, in test_comparison
        self.assert_version_is_equal("0.1.2", "0.1.2.0")
      File "/home/atagar/Desktop/stem/test/data/python3/test/unit/version.py", line 252, in assert_version_is_equal
        self.assertEqual(version1, version2)
      File "/usr/lib/python3.2/unittest/case.py", line 643, in assertEqual
        assertion_func(first, second, msg=msg)
      File "/usr/lib/python3.2/unittest/case.py", line 633, in _baseAssertEqual
        if not first == second:
      File "/home/atagar/Desktop/stem/test/data/python3/stem/version.py", line 214, in __eq__
        return self._compare(other, lambda s, o: s == o)
      File "/home/atagar/Desktop/stem/test/data/python3/stem/version.py", line 197, in _compare
        my_version = max(0, self.__dict__[attr])
    TypeError: unorderable types: NoneType() > int()

commit e6e5005b8afd9b7e0a1239a92d7c7a3f39e3ef42
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Jan 27 12:28:59 2013 -0800

    Using byte string for binascii.a2b_hex in python 3
    
    Like base64.b64decode(), binascii.a2b_hex() expects a byte string.
    
    ======================================================================
    ERROR: test_valid_response
    ----------------------------------------------------------------------
    Traceback:
      File "/home/atagar/Desktop/stem/test/data/python3/test/unit/response/authchallenge.py", line 31, in test_valid_response
        stem.response.convert("AUTHCHALLENGE", control_message)
      File "/home/atagar/Desktop/stem/test/data/python3/stem/response/__init__.py", line 117, in convert
        message._parse_message(**kwargs)
      File "/home/atagar/Desktop/stem/test/data/python3/stem/response/authchallenge.py", line 40, in _parse_message
        self.server_hash = binascii.a2b_hex(value)
    TypeError: 'str' does not support the buffer interface
    
    ----------------------------------------------------------------------
    Ran 2 tests in 0.009s

commit 2e7913aa6c59d147ef5ae926d456c54ec459dd52
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Jan 27 12:17:43 2013 -0800

    Using byte string for base64.b64decode in python 3
    
    First correction for the ASCII -> Unicode switch over in python 3.
    
    ======================================================================
    ERROR: test_get_network_status
    ----------------------------------------------------------------------
    Traceback:
      File "/home/atagar/Desktop/stem/test/data/python3/stem/descriptor/router_status_entry.py", line 702, in _decode_fingerprint
        identity_decoded = base64.b64decode(identity)
      File "/usr/lib/python3.2/base64.py", line 83, in b64decode
        raise TypeError("expected bytes, not %s" % s.__class__.__name__)
    TypeError: expected bytes, not str
    
    During handling of the above exception, another exception occurred:
    
    Traceback:
      File "/home/atagar/Desktop/stem/test/data/python3/test/unit/control/controller.py", line 247, in test_get_network_status
        router = stem.descriptor.router_status_entry.RouterStatusEntryV2(desc)
      File "/home/atagar/Desktop/stem/test/data/python3/stem/descriptor/router_status_entry.py", line 254, in __init__
        super(RouterStatusEntryV2, self).__init__(content, validate, document)
      File "/home/atagar/Desktop/stem/test/data/python3/stem/descriptor/router_status_entry.py", line 149, in __init__
        self._parse(entries, validate)
      File "/home/atagar/Desktop/stem/test/data/python3/stem/descriptor/router_status_entry.py", line 261, in _parse
        _parse_r_line(self, value, validate, True)
      File "/home/atagar/Desktop/stem/test/data/python3/stem/descriptor/router_status_entry.py", line 495, in _parse_r_line
        desc.fingerprint = _decode_fingerprint(r_comp[1], validate)
      File "/home/atagar/Desktop/stem/test/data/python3/stem/descriptor/router_status_entry.py", line 707, in _decode_fingerprint
        raise ValueError("Unable to decode identity string '%s'" % identity)
    ValueError: Unable to decode identity string '/96bKo4soysolMgKn5Hex2nyFSY='
    
    ----------------------------------------------------------------------
    Ran 9 tests in 0.063s

commit 4f108d1dffd2e23db8ced6d4cb755a336a0767f3
Author: Damian Johnson <atagar@torproject.org>
Date:   Fri Jan 25 09:57:54 2013 -0800

    Including signature method in DocumentSignature's comparison
    
    The DocumentSignature's method argument is new-ish, and its comparison function
    wasn't taking it into account. Both fixing this and using the default method
    (sha1) in the mock instance so our tests still pass.

commit 5914ae523eb393383a120cd24c12c508e0ffaeac
Author: Damian Johnson <atagar@torproject.org>
Date:   Tue Jan 22 09:27:45 2013 -0800

    Using rich comparison functions
    
    Python 3.x drops support for __cmp__, requiring that users opt for rich
    comparison methods instead...
    
    http://python3porting.com/problems.html#unorderable-types-cmp-and-cmp
    
    ======================================================================
    ERROR: test_event_listening
    ----------------------------------------------------------------------
    Traceback:
      File "/home/atagar/Desktop/stem/test/data/python3/test/unit/control/controller.py", line 285, in test_event_listening
        self.assertRaises(InvalidRequest, self.controller.add_event_listener, mocking.no_op(), EventType.BW)
      File "/usr/lib/python3.2/unittest/case.py", line 574, in assertRaises
        callableObj(*args, **kwargs)
      File "/home/atagar/Desktop/stem/test/data/python3/stem/control.py", line 1438, in add_event_listener
        if not self.get_version().meets_requirements(event_version):
      File "/home/atagar/Desktop/stem/test/data/python3/stem/version.py", line 175, in meets_requirements
        return self >= requirements
    TypeError: unorderable types: Version() >= Version()
    
    This change uncovered a couple bugs where events failed to strip off the
    trailing 'OK'. I'm not entirely sure why the previous comparisons didn't catch
    this, but oh well - fixed now.

commit 137aed3eadb184fd3e96828cd207220d3e09a043
Author: Damian Johnson <atagar@torproject.org>
Date:   Mon Jan 21 09:02:18 2013 -0800

    Disabling static checks when using python 3.x
    
    Not only are our static checks useless with the python 3.x codebase (pyflakes
    probably ins't python 3.x compatable and who cares about PEP8 issues with the
    output?), the pyflake check errors...
    
    Traceback (most recent call last):
      File "./test/data/python3/run_tests.py", line 554, in <module>
        style_issues.update(test.check_whitespace.pyflakes_issues(os.path.join(base_path, "stem")))
      File "/home/atagar/Desktop/stem/test/data/python3/test/check_whitespace.py", line 132, in pyflakes_issues
        line_match = re.match("^(.*):(\d+): (.*)$", line)
      File "/usr/lib/python3.2/re.py", line 153, in match
        return _compile(pattern, flags).match(string)
    TypeError: can't use a string pattern on a bytes-like object

commit 62086346044c9eab1ce68d830669559773ef22b9
Author: Damian Johnson <atagar@torproject.org>
Date:   Mon Jan 21 08:57:02 2013 -0800

    Accounting for __builtin__ renaming
    
    Python 3.x renames __builtin__ to builtins...
    
    ======================================================================
    ERROR: test_parse_circ_path
    ----------------------------------------------------------------------
    Traceback:
      File "/home/atagar/Desktop/stem/test/data/python3/test/unit/control/controller.py", line 24, in setUp
        mocking.revert_mocking()
      File "/home/atagar/Desktop/stem/test/data/python3/test/mocking.py", line 404, in revert_mocking
        if module == __builtin__:
    NameError: global name '__builtin__' is not defined

commit 84df4318abce565fd2f682ee6e12ea2fe9acf072
Author: Damian Johnson <atagar@torproject.org>
Date:   Mon Jan 21 08:56:35 2013 -0800

    Adding is_python_3() to prereq module
    
    Something tells me that we'll need this...

commit 54eac73e62739cb40bced307ff6967548eb3af42
Author: Damian Johnson <atagar@torproject.org>
Date:   Mon Jan 21 00:42:46 2013 -0800

    Dropping hardcoded python 2.x check
    
    Our prereq module asserted that stem isn't compatable beyond the 2.x series.
    Clearly I'm trying to 'fix' that with this branch.
    
    Ideally we'd keep this check for our python 2.x codebase, and strip it when
    we do a 2to3 conversion. However, that's more error prone than I'd like so
    simply dropping the check entirely.

commit 77b6fa86df045298564b1c0b9f66bd3d71d66d2e
Author: Damian Johnson <atagar@torproject.org>
Date:   Mon Jan 21 00:36:24 2013 -0800

    Making the Enum's keys() method provide a list
    
    The 2to3 converter is evidently confused because we have a keys() method that
    provides a tuple rather than a list. Dictionaries provide lists via their
    keys() method so there's probably not a terribly compelling reason for us to do
    differently.

commit f9a2f147b6fe6187e3ba8d1b5bffa5efce14fac1
Author: Damian Johnson <atagar@torproject.org>
Date:   Mon Jan 21 00:18:20 2013 -0800

    Making static checks skip the data directory
    
    Our static checkers (most noticeably pep8 and pyflakes) run over the test data
    directory. This was fine until I started using it for the python3 export. Now
    that it has python code these checkers have a lot to say about it, none of it
    helpful.
    
    Simply ignoring the output if it concerns the data directory. This is a sucky
    solution since pyflakes/pep8 are still running over an extra copy of our
    codebase, taking a noticeable bit of extra time. However, pyflakes at least
    lacks any options for ignoring directories.
    
    I'll probably simply move our python3 export to another location later if this
    annoys me.

commit 919502c53baff9f823ed537dab86ec930cf2eaf7
Author: Damian Johnson <atagar@torproject.org>
Date:   Sun Jan 20 23:42:29 2013 -0800

    Python 3 testing support
    
    Adding python 3 support to the tests. This introduces two new testing
    arguments...
    
    --python3     Does a 2to3 export of our codebase and tests against that. If a
                  python3 export already exists then reuses that (... it takes an
                  annoyingly long time to run).
    
    --clean       Wipes our prior python3 export.
    
    Next to start sorting out the 2to3 conversion issues...

commit 7921a46ba8655baa7c4b81d900a9854444675564
Author: Damian Johnson <atagar@torproject.org>
Date:   Thu Jan 24 09:21:35 2013 -0800

    Populating BridgeNetworkStatusDocuments with v2 entries
    
    Karsten reports that bridge network status documents have v2 router status
    entries, not v3.
    
    https://trac.torproject.org/8036

commit 0b1d47d92d447614095cf43fdb35214650db8d82
Author: Damian Johnson <atagar@torproject.org>
Date:   Thu Jan 24 09:20:47 2013 -0800

    NetworkStatusDocumentV3's params misdocumented as being a list
    
    The params is a dict, not a list. Caught by amj703 on...
    
    https://trac.torproject.org/8036

commit ce8fcf13521567c439696d7e87894eb09e238347
Author: Damian Johnson <atagar@torproject.org>
Date:   Wed Jan 23 09:25:03 2013 -0800

    Broken link for bad relays wiki
    
    Wrong format for external links.
    
    /home/atagar/Desktop/stem/stem/__init__.py:
      docstring of stem:56:
      ERROR: Unknown target name: "https://trac.torproject.org/projects/tor/wiki/doc/badrelays".

commit ab992cd1716b4bc9f61660b746281c61dd878ab5
Author: Damian Johnson <atagar@torproject.org>
Date:   Wed Jan 23 09:21:53 2013 -0800

    Fixing ExitPolicyRule's get_address_type() pydocs
    
    We had an ending colon rather than a backtick for the AddressType references.
    
    /home/atagar/Desktop/stem/stem/exit_policy.py:
      docstring of stem.exit_policy.ExitPolicyRule.get_address_type:1:
      WARNING: Inline interpreted text or phrase reference start-string without end-string.
    
